diff -pruN 245.4-4/debian/changelog 245.4-4ubuntu3/debian/changelog
--- 245.4-4/debian/changelog	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/changelog	2020-04-22 09:04:26.000000000 +0000
@@ -1,3 +1,26 @@
+systemd (245.4-4ubuntu3) focal; urgency=medium
+
+  * dhcp: Allow setting request options again
+    link_configure() may be called multiple times on a link causing request options
+    set multiple times. (LP: #1870410)
+    File: debian/patches/dhcp-Allow-setting-request-options-again.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=4c48893eb04b01a2ec62d2d2823a79a9f5cb2b80
+  * Don't try calling NULL callback in bus_wait_for_units_clear.
+    This fixes a crash most frequently occurring in the Unity session
+    (LP: #1870930)
+    File: debian/patches/shared-Don-t-try-calling-NULL-callback-in-bus_wait_for_un.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b2ec1a3367cef401f8de745fecc9c385f020be78
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Wed, 22 Apr 2020 11:04:26 +0200
+
+systemd (245.4-4ubuntu1) focal; urgency=medium
+
+  * Merge to Ubuntu from Debian unstable
+  - Dropped changes:
+    * d/rules: in dh_auto_test, include meson param --print-errorlogs.
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Tue, 14 Apr 2020 00:05:30 +0200
+
 systemd (245.4-4) unstable; urgency=medium
 
   * Drop Conflicts: virtualbox-guest-utils from systemd-timesyncd.
@@ -34,6 +57,222 @@ systemd (245.4-3) unstable; urgency=medi
 
  -- Michael Biebl <biebl@debian.org>  Fri, 10 Apr 2020 11:55:15 +0200
 
+systemd (245.4-2ubuntu1) focal; urgency=medium
+
+  [ Balint Reczey ]
+  * Merge to Ubuntu from Debian unstable
+  * Refresh patches
+    - Dropped changes:
+      * units: Don't mount tracefs in LXC.
+    - Remaining changes:
+      * Specify Ubuntu's Vcs-Git
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=fd832930ef280c9a4a9dda2440d5a46a6fdb6232
+      * Enable EFI/bootctl on armhf.
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=043122f7d8a1487bfd357e815a6ece1ceea6e7d1
+      * Recommend networkd-dispatcher
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1e3b2c7e4757119da0d550b0b3c0a6626a176dc
+      * Add conflicts with upstart and systemd-shim
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=83ed7496afc7c27be026014d109855f7d0ad1176
+      * debian/control: strengthen dependencies.
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1ecf0c372f5212129c85ae60fddf26b2271a1fe
+      * debian/rules: Set -Duser-path instead of patching the source for the same result
+        File: debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=67d2ac5d806b55b0d178fca7e0af08cd9d12580c
+      * config: tpm-pcrindex=12, on Ubuntu only.
+        File: debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2f8c22d44a619ce8fa17eb0cd7c7e2c601cdbbeb
+      * Ubuntu/extra: ship dhclient-enter hook.
+        Files:
+        - debian/extra/dhclient-enter-resolved-hook
+        - debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f3398a213f80b02bf3db0c1ce9e22d69f6d56764
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=258893bae8cbb12670e4807636fe8f7e9fb5407a
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0725c1169ddde4f41cacba7af3e546704e2206be
+      * udev-udeb: ship modprobe.d snippet to force scsi_mod.scan=sync in d-i.
+        Files:
+        - debian/extra/modprobe.d-udeb/scsi-mod-scan-sync.conf
+        - debian/udev-udeb.install
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=eb6d8a2b9504917abb7aa2c4035fdbb7b98227f7
+      * debian/extra/start-udev: Set scsi_mod scan=sync even if it's builtin to the kernel (we previously only set it in modprobe.d)
+        Files:
+        - debian/extra/start-udev
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6b72628f8de991e2c67ac4289fc74daf3abe7d14
+      * debian/extra/units/systemd-resolved.service.d/resolvconf.conf:
+        drop resolvconf.conf drop-in, resolved integration moved to resolvconf package.
+      * debian/extra/wrap_cl.py: add changelog formatter
+        Files:
+        - debian/extra/wrap_cl.py
+        - debian/gbp.conf
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=26e69bceab9cec8df64cdca18cd71e7c0874f8b3
+      * debian/gbp.conf: Set tag format to ubuntu/*
+      * debian/gbp.conf: Change debian-branch to ubuntu-focal
+      * libnss-resolve: do not disable and stop systemd-resolved
+        File: debian/libnss-resolve.postrm
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=95577d14e84e19b614b83b2e24985d89e8c2dac0
+      * core: Revert strict mount namespacing/sandboxing, until LXD allows the needed mounts.
+        File: debian/patches/Revert-namespace-be-more-careful-when-handling-namespacin.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=030919ba5e4931d6ee576d0259fae67fe4ed9770
+      * Revert upstream adding LINK_STATE_INITIALIZED because it breaks netplan.io's
+        ethernets autopkgtest.
+        Files:
+        - debian/patches/Revert-network-do-not-drop-foreign-config-if-interface-is.patch
+        - debian/patches/Revert-network-fix-assertion-when-link-get-carrier.patch
+        - debian/patches/Revert-network-prevent-interfaces-to-be-initialized-multi.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=22a9fa3bb03ba2a629926af39ea7df81fe33c9b8
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=70e93c2a05f0f7435614f8d52944d726601e319c
+      * Revert upstream commit breaking IPv4 DHCP in LXC containers in 244.1
+        (LP: #1857123)
+        File: debian/patches/Revert-network-if-sys-is-rw-then-udev-should-be-around.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=39c12f8e736afd1b7bdeb13ff6bccaea85020873
+      * Skip falling back to device name when net_get_name(device) fails.
+        File: debian/patches/Skip-falling-back-to-device-name-when-net_get_name-device.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c79fe0e2dc29834e0cd236ade6e4e44a6ffb74fa
+      * Add "AssumedApparmorLabel=unconfined" to timedate1 dbus service file
+        File: debian/patches/debian/UBUNTU-Add-AssumedApparmorLabel-unconfined-to-timedate1-dbus.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5ad0879e10bbe3d641f940260b93c7eb2cf4624c
+      * Re-add support for /etc/writable for core18
+        File: debian/patches/debian/UBUNTU-Support-system-image-read-only-etc.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=a5b5fca66c1127068e4ce0cc9ab497814211f4f7
+      * core: set /run size to 10%, like initramfs-tools does.
+        File: debian/patches/debian/UBUNTU-core-set-run-size-to-10-like-initramfs-tools-does.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fac2568fe716dc1a41bada78293dc6327a6df0d
+      * Ship systemd sysctl settings.
+        Files:
+        - debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch
+        - debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=7cd041a6d0ef459e4b2a82d8ea5fa1ce05184dfb
+      * journald.service: set Nice=-1 to dodge watchdog on soft lockups.
+        File: debian/patches/debian/UBUNTU-journald.service-set-Nice-1-to-dodge-watchdog-on-soft-loc.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e0a9aeffac556492bf517ce2d23313ff7a277926
+      * networkd: if RA was implicit, do not await ndisc_configured.
+        File: debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2f749ff528d1b788aa4ca778e954c16b213ee629
+      * networkd: [Route] PreferredSource not working in *.network files.
+        Files:
+        - debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4e2ee0b2ac1be2ae78952890a56a2d5398df518
+      * systemd-resolved: Default to Cache=no-negative
+        File: debian/patches/debian/UBUNTU-resolved-default-no-negative-caching.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b42658843a9496d6b6bb68ac159f2a9f0a8ba9db
+      * Disable LLMNR and MulticastDNS by default
+        Files:
+        - debian/patches/debian/UBUNTU-resolved-disable-global-LLMNR-and-MulticastDNS.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4ec428e83696a5cd0405b677a35e97681867629
+      * test-sleep: skip test_fiemap upon inapproriate ioctl for device.
+        File: debian/patches/debian/UBUNTU-test-sleep-skip-test_fiemap-upon-inapproriate-ioctl-.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6ebb5b9f6b77760a5470e8a780d69875b1db76f7
+      * test/test-functions: launch qemu-system with -vga none.
+        File: debian/patches/debian/UBUNTU-test-test-functions-launch-qemu-with-vga-none.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=90af1fa893cce5ed49999d16da0b793da6523394
+      * units: conditionalize more units to not start in containers.
+        Files:
+        - debian/patches/debian/UBUNTU-units-block-CAP_SYS_MODULE-units-in-containers-too.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3689afa1a782de8c19a757459b6360de1195ad55
+      * units: Disable journald Watchdog
+        File: debian/patches/debian/UBUNTU-units-disable-journald-watchdog.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=64d2b4f1d0d057073fba585f19823332e2a6eed5
+      * wait-online: do not wait, if no links are managed (neither configured, or failed).
+        File: debian/patches/debian/UBUNTU-wait-online-exit-if-no-links-are-managed.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=31f04c3fc769dacb3cf2a78240a1710a99a865b8
+      * Set UseDomains to true, by default, on Ubuntu.
+        File: debian/patches/debian/Ubuntu-UseDomains-by-default.patch
+      * Ignore failures to set Nice priority on services in containers.
+        File: debian/patches/debian/Ubuntu-core-in-execute-soft-fail-setting-Nice-priority-when.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5b8e457f8d883fc6f55d33d46b3474926a495d29
+      * units: set ConditionVirtualization=!private-users on journald audit socket.
+        File: debian/patches/debian/Ubuntu-units-set-ConditionVirtualization-private-users-on-j.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=03ed18a9940731bbf794ad320fabf337488835c6
+      * Workaround captive portals not responding to EDNS0 queries (DVE-2018-0001).
+        File: debian/patches/resolved-Mitigate-DVE-2018-0001-by-retrying-NXDOMAIN-with.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=87d3fe81b7281687ecf3c0b9a8356e90cc714d0b
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2974114ed9b89ea922a23893e8eff70d5cac77fe
+      * Disable dh_installinit generation of tmpfiles for the systemd package.
+        Files:
+        - debian/rules
+        - debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fd144cbe31cc7a9383cc76f21f4b84c22a9dd1b
+      * Enable systemd-resolved by default
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=05adfa0902115f51c1196ad623165a75bb8b4313
+      * Create /etc/resolv.conf at postinst, pointing at the stub resolver.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=ef4adf46bbbe2d22508b70b889d23da53b85039d
+      * Always setup /etc/resolv.conf on new installations.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=20bc8a37fa3c9620bed21a56a4eabd71db71d861
+      * Disable systemd-networkd-wait-online by default.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=694473d812b50d2fefd6494d494ca02b91bc8785
+      * postinst: drop empty/stock /etc/rc.local
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e7d071a26a79558771303b0b87f007e650eaebbe
+      * systemd.postinst: enable persistent journal
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f94f18d9dbc085b6a9ff33c141a6e542142f85b5
+      * debian/systemd.postinst: Skip daemon-reexec and try-restarts during shutdown
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=51daab96ae79483b5e5fb62e1e0477c87ee11fd1
+      * Drop systemd.prerm safety check.
+        File: debian/systemd.prerm
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0244c4d56556317f14eecc2f51871969ef02ba7b
+      * boot-and-services: stderr is ok, for status command on the c1 container.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=da14d34e7cc33c44ad67e64c9fd092f8cc1675f9
+      * adt: boot-and-services: assert any kernel syslog messages.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=29dc34f7a6e5dc505f6212c17c42e4420b47ed16
+      * Wait for systemctl is-system-running state.
+        File: debian/tests/boot-smoke
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=776998f1f55c445b6e385cab69a4219c42d00838
+      * debian/tests: Enforce udev upgrade.
+        Files:
+        - debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f350b43ccc1aa31c745b4ccebbb4084d5cea41ff
+      * Only test that gdm3 comes up on amd64. Stalls on other arches.
+        File: debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=97cb13685dfb353045c449ec5d6d1df60f661079
+      * debian/tests/systemd-fsckd: update assertions expectations for v237
+        File: debian/tests/systemd-fsckd
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d5becd9a416b55dcdb7b9a7aba60c4e3d304e6a6
+      * Skip systemd-fsckd on arm64, because of broken/lack of clean shutdown.
+        File: debian/tests/systemd-fsckd
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=bf5b501ac934497dbef5f64908ff37643dc7288e
+      * debian/tests: blacklist upstream test-24-unit-tests on ppc64le.
+        File: debian/tests/upstream
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=8062b9a2712c390010d2948eaf764a1b52e68715
+      * debian/test/boot-and-services: Skip AppArmor tests in arm containers.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=9d3b35df77aa939365563a4edaee54ebb7f559a3
+      * d/t/control: run udev tests only with isolation-machine.
+        File: debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4b4c9bf44f4b8d7f75a4204aff697f549c8aad7
+      * Add riscv64 seccomp support.
+  * network: do not re-attach sd-event object (LP: #1870410)
+    File: debian/patches/network-do-not-re-attach-sd-event-object.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b10aee06d30b98395d20344195d3e671e25498ab
+  * Enable seccomp support on riscv64 again.
+    File: debian/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=a1ffd64333784a10dd0eeb87f5198462b85c6f9a
+
+  [ Dan Streetman ]
+  * network: attach sd-event in link_load() when creating link dhcp_client or ipv4ll
+    (LP: #1870410)
+    Author: Dan Streetman
+    Files:
+    - debian/patches/network-attach-sd-event-in-link_load-when-creating-link-d.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3408963020c6c0cf180130eabfd96e758d1a9c1f
+  * d/rules: in dh_auto_test, include meson param --print-errorlogs.
+    Also, don't cat testlog.txt; it's noisy and not very helpful.
+    File: debian/rules
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=ca8ed6fb7fa0f2a63557f705b1fdc97ab7ba5ace
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Wed, 08 Apr 2020 10:21:18 +0200
+
 systemd (245.4-2) unstable; urgency=medium
 
   [ Balint Reczey ]
@@ -68,6 +307,237 @@ systemd (245.4-1) unstable; urgency=medi
 
  -- Michael Biebl <biebl@debian.org>  Thu, 02 Apr 2020 11:58:18 +0200
 
+systemd (245.2-1ubuntu3) focal; urgency=medium
+
+  * Add riscv64 seccomp support.
+
+ -- William Grant <wgrant@ubuntu.com>  Sun, 05 Apr 2020 17:33:43 +1000
+
+systemd (245.2-1ubuntu2) focal; urgency=medium
+
+  * units: Don't mount tracefs in LXC.
+    This fixes autopkgtest in LXC.
+    File: debian/patches/units-Don-t-mount-tracefs-in-LXC.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=cedcc2ceb7e788b2b0cbb97c7fbbd596d6c010a3
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Tue, 24 Mar 2020 13:09:27 +0100
+
+systemd (245.2-1ubuntu1) focal; urgency=medium
+
+  * Merge to Ubuntu from Debian unstable
+    - Notable changes in 245 missing from NEWS
+      * Modprobing is split out to a separate service unit, modprobe@.service
+      * New mount for for tracefs, under /sys/kernel/tracing
+  * Refresh patches
+    - Dropped changes:
+      * Keep sd_bus_enqueue_for_read() public
+      * Improve autopkgtest success rate, by bumping up timeouts
+      * d/p/lp1762391/0001-user-util-Add-helper-functions-for-gid-lists-operati.patch,
+        d/p/lp1762391/0002-execute-Restore-call-to-pam_setcred.patch,
+        d/p/lp1762391/0003-execute-Detect-groups-added-by-PAM-and-merge-them-wi.patch,
+        d/p/lp1762391/0004-test-Add-tests-for-gid-list-ops.patch,
+        d/p/lp1762391/0005-execute-add-const-to-array-parameters-where-possible.patch,
+        d/p/lp1762391/0006-execute-allow-pam_setcred-to-fail-ignore-errors.patch:
+        - Restore call to pam_setcred (LP: #1762391)
+      * d/p/0001-network-rename-linux_configure_after_setting_mtu-to-linux.patch,
+        d/p/0002-network-add-link-setting_genmode-flag.patch,
+        d/p/0003-network-if-ipv6ll-is-disabled-enumerate-tentative-ipv6-ad.patch,
+        d/p/0004-network-drop-foreign-config-after-addr_gen_mode-has-been-.patch:
+        - drop foreign config and raise interface after setting genmode
+      * pstore: Don't start systemd-pstore.service in containers.
+      * shutdown: do not detach autoclear loopback devices
+      * shutdown: cherry-pick PR#14409 to fix detach of loopback devices
+        for Ubuntu Core 20
+    - Remaining changes:
+      * Specify Ubuntu's Vcs-Git
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=fd832930ef280c9a4a9dda2440d5a46a6fdb6232
+      * Enable EFI/bootctl on armhf.
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=043122f7d8a1487bfd357e815a6ece1ceea6e7d1
+      * Recommend networkd-dispatcher
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1e3b2c7e4757119da0d550b0b3c0a6626a176dc
+      * Add conflicts with upstart and systemd-shim
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=83ed7496afc7c27be026014d109855f7d0ad1176
+      * debian/control: strengthen dependencies.
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1ecf0c372f5212129c85ae60fddf26b2271a1fe
+      * debian/rules: Set -Duser-path instead of patching the source for the same result
+        File: debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=67d2ac5d806b55b0d178fca7e0af08cd9d12580c
+      * config: tpm-pcrindex=12, on Ubuntu only.
+        File: debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2f8c22d44a619ce8fa17eb0cd7c7e2c601cdbbeb
+      * Ubuntu/extra: ship dhclient-enter hook.
+        Files:
+        - debian/extra/dhclient-enter-resolved-hook
+        - debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f3398a213f80b02bf3db0c1ce9e22d69f6d56764
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=258893bae8cbb12670e4807636fe8f7e9fb5407a
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0725c1169ddde4f41cacba7af3e546704e2206be
+      * udev-udeb: ship modprobe.d snippet to force scsi_mod.scan=sync in d-i.
+        Files:
+        - debian/extra/modprobe.d-udeb/scsi-mod-scan-sync.conf
+        - debian/udev-udeb.install
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=eb6d8a2b9504917abb7aa2c4035fdbb7b98227f7
+      * debian/extra/start-udev: Set scsi_mod scan=sync even if it's builtin to the kernel (we previously only set it in modprobe.d)
+        Files:
+        - debian/extra/start-udev
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6b72628f8de991e2c67ac4289fc74daf3abe7d14
+      * debian/extra/units/systemd-resolved.service.d/resolvconf.conf:
+        drop resolvconf.conf drop-in, resolved integration moved to resolvconf package.
+      * debian/extra/wrap_cl.py: add changelog formatter
+        Files:
+        - debian/extra/wrap_cl.py
+        - debian/gbp.conf
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=26e69bceab9cec8df64cdca18cd71e7c0874f8b3
+      * debian/gbp.conf: Set tag format to ubuntu/*
+      * debian/gbp.conf: Change debian-branch to ubuntu-focal
+      * libnss-resolve: do not disable and stop systemd-resolved
+        File: debian/libnss-resolve.postrm
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=95577d14e84e19b614b83b2e24985d89e8c2dac0
+      * core: Revert strict mount namespacing/sandboxing, until LXD allows the needed mounts.
+        File: debian/patches/Revert-namespace-be-more-careful-when-handling-namespacin.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=030919ba5e4931d6ee576d0259fae67fe4ed9770
+      * Revert upstream adding LINK_STATE_INITIALIZED because it breaks netplan.io's
+        ethernets autopkgtest.
+        Files:
+        - debian/patches/Revert-network-do-not-drop-foreign-config-if-interface-is.patch
+        - debian/patches/Revert-network-fix-assertion-when-link-get-carrier.patch
+        - debian/patches/Revert-network-prevent-interfaces-to-be-initialized-multi.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=22a9fa3bb03ba2a629926af39ea7df81fe33c9b8
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=70e93c2a05f0f7435614f8d52944d726601e319c
+      * Revert upstream commit breaking IPv4 DHCP in LXC containers in 244.1
+        (LP: #1857123)
+        File: debian/patches/Revert-network-if-sys-is-rw-then-udev-should-be-around.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=39c12f8e736afd1b7bdeb13ff6bccaea85020873
+      * Skip falling back to device name when net_get_name(device) fails.
+        File: debian/patches/Skip-falling-back-to-device-name-when-net_get_name-device.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c79fe0e2dc29834e0cd236ade6e4e44a6ffb74fa
+      * Add "AssumedApparmorLabel=unconfined" to timedate1 dbus service file
+        File: debian/patches/debian/UBUNTU-Add-AssumedApparmorLabel-unconfined-to-timedate1-dbus.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5ad0879e10bbe3d641f940260b93c7eb2cf4624c
+      * Re-add support for /etc/writable for core18
+        File: debian/patches/debian/UBUNTU-Support-system-image-read-only-etc.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=a5b5fca66c1127068e4ce0cc9ab497814211f4f7
+      * core: set /run size to 10%, like initramfs-tools does.
+        File: debian/patches/debian/UBUNTU-core-set-run-size-to-10-like-initramfs-tools-does.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fac2568fe716dc1a41bada78293dc6327a6df0d
+      * Ship systemd sysctl settings.
+        Files:
+        - debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch
+        - debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=7cd041a6d0ef459e4b2a82d8ea5fa1ce05184dfb
+      * journald.service: set Nice=-1 to dodge watchdog on soft lockups.
+        File: debian/patches/debian/UBUNTU-journald.service-set-Nice-1-to-dodge-watchdog-on-soft-loc.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e0a9aeffac556492bf517ce2d23313ff7a277926
+      * networkd: if RA was implicit, do not await ndisc_configured.
+        File: debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2f749ff528d1b788aa4ca778e954c16b213ee629
+      * networkd: [Route] PreferredSource not working in *.network files.
+        Files:
+        - debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4e2ee0b2ac1be2ae78952890a56a2d5398df518
+      * systemd-resolved: Default to Cache=no-negative
+        File: debian/patches/debian/UBUNTU-resolved-default-no-negative-caching.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b42658843a9496d6b6bb68ac159f2a9f0a8ba9db
+      * Disable LLMNR and MulticastDNS by default
+        Files:
+        - debian/patches/debian/UBUNTU-resolved-disable-global-LLMNR-and-MulticastDNS.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4ec428e83696a5cd0405b677a35e97681867629
+      * test-sleep: skip test_fiemap upon inapproriate ioctl for device.
+        File: debian/patches/debian/UBUNTU-test-sleep-skip-test_fiemap-upon-inapproriate-ioctl-.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6ebb5b9f6b77760a5470e8a780d69875b1db76f7
+      * test/test-functions: launch qemu-system with -vga none.
+        File: debian/patches/debian/UBUNTU-test-test-functions-launch-qemu-with-vga-none.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=90af1fa893cce5ed49999d16da0b793da6523394
+      * units: conditionalize more units to not start in containers.
+        Files:
+        - debian/patches/debian/UBUNTU-units-block-CAP_SYS_MODULE-units-in-containers-too.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3689afa1a782de8c19a757459b6360de1195ad55
+      * units: Disable journald Watchdog
+        File: debian/patches/debian/UBUNTU-units-disable-journald-watchdog.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=64d2b4f1d0d057073fba585f19823332e2a6eed5
+      * wait-online: do not wait, if no links are managed (neither configured, or failed).
+        File: debian/patches/debian/UBUNTU-wait-online-exit-if-no-links-are-managed.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=31f04c3fc769dacb3cf2a78240a1710a99a865b8
+      * Set UseDomains to true, by default, on Ubuntu.
+        File: debian/patches/debian/Ubuntu-UseDomains-by-default.patch
+      * Ignore failures to set Nice priority on services in containers.
+        File: debian/patches/debian/Ubuntu-core-in-execute-soft-fail-setting-Nice-priority-when.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5b8e457f8d883fc6f55d33d46b3474926a495d29
+      * units: set ConditionVirtualization=!private-users on journald audit socket.
+        File: debian/patches/debian/Ubuntu-units-set-ConditionVirtualization-private-users-on-j.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=03ed18a9940731bbf794ad320fabf337488835c6
+      * Workaround captive portals not responding to EDNS0 queries (DVE-2018-0001).
+        File: debian/patches/resolved-Mitigate-DVE-2018-0001-by-retrying-NXDOMAIN-with.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=87d3fe81b7281687ecf3c0b9a8356e90cc714d0b
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2974114ed9b89ea922a23893e8eff70d5cac77fe
+      * Disable dh_installinit generation of tmpfiles for the systemd package.
+        Files:
+        - debian/rules
+        - debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fd144cbe31cc7a9383cc76f21f4b84c22a9dd1b
+      * Enable systemd-resolved by default
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=05adfa0902115f51c1196ad623165a75bb8b4313
+      * Create /etc/resolv.conf at postinst, pointing at the stub resolver.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=ef4adf46bbbe2d22508b70b889d23da53b85039d
+      * Always setup /etc/resolv.conf on new installations.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=20bc8a37fa3c9620bed21a56a4eabd71db71d861
+      * Disable systemd-networkd-wait-online by default.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=694473d812b50d2fefd6494d494ca02b91bc8785
+      * postinst: drop empty/stock /etc/rc.local
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e7d071a26a79558771303b0b87f007e650eaebbe
+      * systemd.postinst: enable persistent journal
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f94f18d9dbc085b6a9ff33c141a6e542142f85b5
+      * debian/systemd.postinst: Skip daemon-reexec and try-restarts during shutdown
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=51daab96ae79483b5e5fb62e1e0477c87ee11fd1
+      * Drop systemd.prerm safety check.
+        File: debian/systemd.prerm
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0244c4d56556317f14eecc2f51871969ef02ba7b
+      * boot-and-services: stderr is ok, for status command on the c1 container.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=da14d34e7cc33c44ad67e64c9fd092f8cc1675f9
+      * adt: boot-and-services: assert any kernel syslog messages.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=29dc34f7a6e5dc505f6212c17c42e4420b47ed16
+      * Wait for systemctl is-system-running state.
+        File: debian/tests/boot-smoke
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=776998f1f55c445b6e385cab69a4219c42d00838
+      * debian/tests: Enforce udev upgrade.
+        Files:
+        - debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f350b43ccc1aa31c745b4ccebbb4084d5cea41ff
+      * Only test that gdm3 comes up on amd64. Stalls on other arches.
+        File: debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=97cb13685dfb353045c449ec5d6d1df60f661079
+      * debian/tests/systemd-fsckd: update assertions expectations for v237
+        File: debian/tests/systemd-fsckd
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d5becd9a416b55dcdb7b9a7aba60c4e3d304e6a6
+      * Skip systemd-fsckd on arm64, because of broken/lack of clean shutdown.
+        File: debian/tests/systemd-fsckd
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=bf5b501ac934497dbef5f64908ff37643dc7288e
+      * debian/tests: blacklist upstream test-24-unit-tests on ppc64le.
+        File: debian/tests/upstream
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=8062b9a2712c390010d2948eaf764a1b52e68715
+      * debian/test/boot-and-services: Skip AppArmor tests in arm containers.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=9d3b35df77aa939365563a4edaee54ebb7f559a3
+      * d/t/control: run udev tests only with isolation-machine.
+        File: debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4b4c9bf44f4b8d7f75a4204aff697f549c8aad7
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Thu, 19 Mar 2020 17:36:59 +0100
+
 systemd (245.2-1) unstable; urgency=medium
 
   * New upstream version 245.2
@@ -107,6 +577,15 @@ systemd (245-1) unstable; urgency=medium
 
  -- Michael Biebl <biebl@debian.org>  Wed, 11 Mar 2020 13:33:37 +0100
 
+systemd (244.3-1ubuntu1) focal; urgency=medium
+
+  * Merge to Ubuntu from Debian unstable
+  * Refresh patches:
+    - Dropped changes: none
+    - Remaining changes: all
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Mon, 24 Feb 2020 20:29:44 +0100
+
 systemd (244.3-1) unstable; urgency=medium
 
   * New upstream version 244.3
@@ -116,6 +595,227 @@ systemd (244.3-1) unstable; urgency=medi
 
  -- Michael Biebl <biebl@debian.org>  Sat, 15 Feb 2020 15:44:45 +0100
 
+systemd (244.2-1ubuntu1) focal; urgency=medium
+
+  * Merge to Ubuntu from Debian unstable
+  * Refresh patches:
+    - Dropped changes:
+      * SECURITY UPDATE: heap use-after-free with async polkit queries
+    - Remaining changes:
+      * Recommend networkd-dispatcher
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1e3b2c7e4757119da0d550b0b3c0a6626a176dc
+      * Enable EFI/bootctl on armhf.
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=043122f7d8a1487bfd357e815a6ece1ceea6e7d1
+      * debian/control: strengthen dependencies.
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1ecf0c372f5212129c85ae60fddf26b2271a1fe
+      * Add conflicts with upstart and systemd-shim
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=83ed7496afc7c27be026014d109855f7d0ad1176
+      * Specify Ubuntu's Vcs-Git
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=fd832930ef280c9a4a9dda2440d5a46a6fdb6232
+      * debian/rules: Set -Duser-path instead of patching the source for the same result
+        File: debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=67d2ac5d806b55b0d178fca7e0af08cd9d12580c
+      * config: tpm-pcrindex=12, on Ubuntu only.
+        File: debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2f8c22d44a619ce8fa17eb0cd7c7e2c601cdbbeb
+      * Ubuntu/extra: ship dhclient-enter hook.
+        Files:
+        - debian/extra/dhclient-enter-resolved-hook
+        - debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f3398a213f80b02bf3db0c1ce9e22d69f6d56764
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=258893bae8cbb12670e4807636fe8f7e9fb5407a
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0725c1169ddde4f41cacba7af3e546704e2206be
+      * udev-udeb: ship modprobe.d snippet to force scsi_mod.scan=sync in d-i.
+        Files:
+        - debian/extra/modprobe.d-udeb/scsi-mod-scan-sync.conf
+        - debian/udev-udeb.install
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=eb6d8a2b9504917abb7aa2c4035fdbb7b98227f7
+      * debian/extra/start-udev: Set scsi_mod scan=sync even if it's builtin to the kernel (we previously only set it in modprobe.d)
+        Files:
+        - debian/extra/start-udev
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6b72628f8de991e2c67ac4289fc74daf3abe7d14
+      * debian/extra/units/systemd-resolved.service.d/resolvconf.conf:
+        drop resolvconf.conf drop-in, resolved integration moved to resolvconf package.
+      * debian/extra/wrap_cl.py: add changelog formatter
+        Files:
+        - debian/extra/wrap_cl.py
+        - debian/gbp.conf
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=26e69bceab9cec8df64cdca18cd71e7c0874f8b3
+      * debian/gbp.conf: Set tag format to ubuntu/*
+      * debian/gbp.conf: Change debian-branch to ubuntu-focal
+      * libnss-resolve: do not disable and stop systemd-resolved
+        File: debian/libnss-resolve.postrm
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=95577d14e84e19b614b83b2e24985d89e8c2dac0
+      * core: Revert strict mount namespacing/sandboxing, until LXD allows the needed mounts.
+        File: debian/patches/Revert-namespace-be-more-careful-when-handling-namespacin.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=030919ba5e4931d6ee576d0259fae67fe4ed9770
+      * Revert upstream adding LINK_STATE_INITIALIZED because it breaks netplan.io's
+        ethernets autopkgtest.
+        Files:
+        - debian/patches/Revert-network-do-not-drop-foreign-config-if-interface-is.patch
+        - debian/patches/Revert-network-fix-assertion-when-link-get-carrier.patch
+        - debian/patches/Revert-network-prevent-interfaces-to-be-initialized-multi.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=22a9fa3bb03ba2a629926af39ea7df81fe33c9b8
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=70e93c2a05f0f7435614f8d52944d726601e319c
+      * Revert upstream commit breaking IPv4 DHCP in LXC containers in 244.1
+        (LP: #1857123)
+        File: debian/patches/Revert-network-if-sys-is-rw-then-udev-should-be-around.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=39c12f8e736afd1b7bdeb13ff6bccaea85020873
+      * Skip falling back to device name when net_get_name(device) fails.
+        File: debian/patches/Skip-falling-back-to-device-name-when-net_get_name-device.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c79fe0e2dc29834e0cd236ade6e4e44a6ffb74fa
+      * Add "AssumedApparmorLabel=unconfined" to timedate1 dbus service file
+        File: debian/patches/debian/UBUNTU-Add-AssumedApparmorLabel-unconfined-to-timedate1-dbus.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5ad0879e10bbe3d641f940260b93c7eb2cf4624c
+      * Re-add support for /etc/writable for core18
+        File: debian/patches/debian/UBUNTU-Support-system-image-read-only-etc.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=a5b5fca66c1127068e4ce0cc9ab497814211f4f7
+      * Improve autopkgtest success rate, by bumping up timeouts
+        File: debian/patches/debian/UBUNTU-bump-selftest-timeouts.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c05586d9da033bbfd6b6a74e10b87520843c7c48
+      * core: set /run size to 10%, like initramfs-tools does.
+        File: debian/patches/debian/UBUNTU-core-set-run-size-to-10-like-initramfs-tools-does.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fac2568fe716dc1a41bada78293dc6327a6df0d
+      * Ship systemd sysctl settings.
+        Files:
+        - debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch
+        - debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=7cd041a6d0ef459e4b2a82d8ea5fa1ce05184dfb
+      * journald.service: set Nice=-1 to dodge watchdog on soft lockups.
+        File: debian/patches/debian/UBUNTU-journald.service-set-Nice-1-to-dodge-watchdog-on-soft-loc.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e0a9aeffac556492bf517ce2d23313ff7a277926
+      * networkd: if RA was implicit, do not await ndisc_configured.
+        File: debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2f749ff528d1b788aa4ca778e954c16b213ee629
+      * networkd: [Route] PreferredSource not working in *.network files.
+        Files:
+        - debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4e2ee0b2ac1be2ae78952890a56a2d5398df518
+      * systemd-resolved: Default to Cache=no-negative
+        File: debian/patches/debian/UBUNTU-resolved-default-no-negative-caching.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b42658843a9496d6b6bb68ac159f2a9f0a8ba9db
+      * Disable LLMNR and MulticastDNS by default
+        Files:
+        - debian/patches/debian/UBUNTU-resolved-disable-global-LLMNR-and-MulticastDNS.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4ec428e83696a5cd0405b677a35e97681867629
+      * test-sleep: skip test_fiemap upon inapproriate ioctl for device.
+        File: debian/patches/debian/UBUNTU-test-sleep-skip-test_fiemap-upon-inapproriate-ioctl-.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6ebb5b9f6b77760a5470e8a780d69875b1db76f7
+      * test/test-functions: launch qemu-system with -vga none.
+        File: debian/patches/debian/UBUNTU-test-test-functions-launch-qemu-with-vga-none.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=90af1fa893cce5ed49999d16da0b793da6523394
+      * units: conditionalize more units to not start in containers.
+        Files:
+        - debian/patches/debian/UBUNTU-units-block-CAP_SYS_MODULE-units-in-containers-too.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3689afa1a782de8c19a757459b6360de1195ad55
+      * units: Disable journald Watchdog
+        File: debian/patches/debian/UBUNTU-units-disable-journald-watchdog.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=64d2b4f1d0d057073fba585f19823332e2a6eed5
+      * wait-online: do not wait, if no links are managed (neither configured, or failed).
+        File: debian/patches/debian/UBUNTU-wait-online-exit-if-no-links-are-managed.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=31f04c3fc769dacb3cf2a78240a1710a99a865b8
+      * Set UseDomains to true, by default, on Ubuntu.
+        File: debian/patches/debian/Ubuntu-UseDomains-by-default.patch
+      * Ignore failures to set Nice priority on services in containers.
+        File: debian/patches/debian/Ubuntu-core-in-execute-soft-fail-setting-Nice-priority-when.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5b8e457f8d883fc6f55d33d46b3474926a495d29
+      * units: set ConditionVirtualization=!private-users on journald audit socket.
+        File: debian/patches/debian/Ubuntu-units-set-ConditionVirtualization-private-users-on-j.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=03ed18a9940731bbf794ad320fabf337488835c6
+      * d/p/lp1762391/0001-user-util-Add-helper-functions-for-gid-lists-operati.patch,
+        d/p/lp1762391/0002-execute-Restore-call-to-pam_setcred.patch,
+        d/p/lp1762391/0003-execute-Detect-groups-added-by-PAM-and-merge-them-wi.patch,
+        d/p/lp1762391/0004-test-Add-tests-for-gid-list-ops.patch,
+        d/p/lp1762391/0005-execute-add-const-to-array-parameters-where-possible.patch,
+        d/p/lp1762391/0006-execute-allow-pam_setcred-to-fail-ignore-errors.patch:
+        - Restore call to pam_setcred (LP: #1762391)
+      * pstore: Don't start systemd-pstore.service in containers.
+        Usually it is not useful and can also fail making
+        boot-and-services autopkgtest fail. (LP: #1856729)
+        File: debian/patches/pstore-Don-t-start-systemd-pstore.service-in-containers.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=28b5a03769cbed9d3170ebac38508b867530a2d6
+      * Workaround captive portals not responding to EDNS0 queries (DVE-2018-0001).
+        File: debian/patches/resolved-Mitigate-DVE-2018-0001-by-retrying-NXDOMAIN-with.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=87d3fe81b7281687ecf3c0b9a8356e90cc714d0b
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2974114ed9b89ea922a23893e8eff70d5cac77fe
+      * shutdown: do not detach autoclear loopback devices
+        File: debian/patches/shutdown-do-not-detach-autoclear-loopback-devices.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3978d34b59e98cdd01836c41a10442967636b8fc
+      * shutdown: cherry-pick PR#14409 to fix detach of loopback devices
+        for Ubuntu Core 20
+        File: debian/patches/shutdown-modernizations-pr-14409.patch
+        https://github.com/systemd/systemd/pull/14409.diff
+      * Disable dh_installinit generation of tmpfiles for the systemd package.
+        Files:
+        - debian/rules
+        - debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fd144cbe31cc7a9383cc76f21f4b84c22a9dd1b
+      * Enable systemd-resolved by default
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=05adfa0902115f51c1196ad623165a75bb8b4313
+      * Create /etc/resolv.conf at postinst, pointing at the stub resolver.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=ef4adf46bbbe2d22508b70b889d23da53b85039d
+      * Always setup /etc/resolv.conf on new installations.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=20bc8a37fa3c9620bed21a56a4eabd71db71d861
+      * Disable systemd-networkd-wait-online by default.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=694473d812b50d2fefd6494d494ca02b91bc8785
+      * postinst: drop empty/stock /etc/rc.local
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e7d071a26a79558771303b0b87f007e650eaebbe
+      * systemd.postinst: enable persistent journal
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f94f18d9dbc085b6a9ff33c141a6e542142f85b5
+      * debian/systemd.postinst: Skip daemon-reexec and try-restarts during shutdown
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=51daab96ae79483b5e5fb62e1e0477c87ee11fd1
+      * Drop systemd.prerm safety check.
+        File: debian/systemd.prerm
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0244c4d56556317f14eecc2f51871969ef02ba7b
+      * boot-and-services: stderr is ok, for status command on the c1 container.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=da14d34e7cc33c44ad67e64c9fd092f8cc1675f9
+      * adt: boot-and-services: assert any kernel syslog messages.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=29dc34f7a6e5dc505f6212c17c42e4420b47ed16
+      * Wait for systemctl is-system-running state.
+        File: debian/tests/boot-smoke
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=776998f1f55c445b6e385cab69a4219c42d00838
+      * debian/tests: Enforce udev upgrade.
+        Files:
+        - debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f350b43ccc1aa31c745b4ccebbb4084d5cea41ff
+      * Only test that gdm3 comes up on amd64. Stalls on other arches.
+        File: debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=97cb13685dfb353045c449ec5d6d1df60f661079
+      * debian/tests/systemd-fsckd: update assertions expectations for v237
+        File: debian/tests/systemd-fsckd
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d5becd9a416b55dcdb7b9a7aba60c4e3d304e6a6
+      * Skip systemd-fsckd on arm64, because of broken/lack of clean shutdown.
+        File: debian/tests/systemd-fsckd
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=bf5b501ac934497dbef5f64908ff37643dc7288e
+      * debian/tests: blacklist upstream test-24-unit-tests on ppc64le.
+        File: debian/tests/upstream
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=8062b9a2712c390010d2948eaf764a1b52e68715
+      * debian/test/boot-and-services: Skip AppArmor tests in arm containers.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=9d3b35df77aa939365563a4edaee54ebb7f559a3
+      * d/t/control: run udev tests only with isolation-machine.
+        File: debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4b4c9bf44f4b8d7f75a4204aff697f549c8aad7
+  * Keep sd_bus_enqueue_for_read() public
+    File: debian/patches/Export-sd_bus_enqueue_for_read.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1eb313b0e2d0a13bb891125b611ef2dc47e483b5
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Tue, 11 Feb 2020 19:21:08 +0100
+
 systemd (244.2-1) unstable; urgency=medium
 
   [ Michael Biebl ]
@@ -195,6 +895,342 @@ systemd (244.1-1) unstable; urgency=medi
 
  -- Michael Biebl <biebl@debian.org>  Sat, 25 Jan 2020 18:53:23 +0100
 
+systemd (244.1-0ubuntu3) focal; urgency=medium
+
+  * SECURITY UPDATE: heap use-after-free with async polkit queries
+    - debian/patches/CVE-2020-1712-1.patch: on async pk requests,
+      re-validate action/details in src/shared/bus-util.c.
+    - debian/patches/CVE-2020-1712-2.patch: introduce API for re-enqueuing
+      incoming messages in src/libsystemd/libsystemd.sym,
+      src/libsystemd/sd-bus/sd-bus.c, src/systemd/sd-bus.h.
+    - debian/patches/CVE-2020-1712-3.patch: when authorizing via PK
+      re-resolve callback/userdata instead of caching it in
+      src/shared/bus-util.c.
+    - debian/patches/CVE-2020-1712-4.patch: fix typo in function name in
+      src/libsystemd/libsystemd.sym, src/libsystemd/sd-bus/sd-bus.c,
+      src/systemd/sd-bus.h, src/shared/bus-util.c.
+    - debian/libsystemd0.symbols: added new symbols.
+    - CVE-2020-1712
+
+ -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 05 Feb 2020 12:56:57 -0500
+
+systemd (244.1-0ubuntu2) focal; urgency=medium
+
+  [ Dimitri John Ledkov ]
+  * shutdown: do not detach autoclear loopback devices
+    Author: Dimitri John Ledkov
+    File: debian/patches/shutdown-do-not-detach-autoclear-loopback-devices.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3978d34b59e98cdd01836c41a10442967636b8fc
+
+  [ Balint Reczey ]
+  * Revert upstream commit breaking IPv4 DHCP in LXC containers in 244.1
+    (LP: #1857123)
+    File: debian/patches/Revert-network-if-sys-is-rw-then-udev-should-be-around.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=39c12f8e736afd1b7bdeb13ff6bccaea85020873
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Wed, 22 Jan 2020 16:27:49 +0100
+
+systemd (244.1-0ubuntu1) focal; urgency=medium
+
+  * New upstream version 244.1
+    - network: set ipv6 mtu after link-up or device mtu change (LP: #1671951)
+    - & other changes
+  * Refresh patches.
+    - Dropped changes:
+      * d/p/lp-1853852-*: fix issues with muliplexed shmat calls (LP: #1853852)
+        Files:
+        - debian/patches/lp-1853852-seccomp-fix-multiplexed-system-calls.patch
+        - debian/patches/lp-1853852-seccomp-mmap-test-results-depend-on-kernel-libseccom.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=382271662c60c339b0a404c7a1772fe5670516ef
+      * d/p/lp1671951-network-set-ipv6-mtu-after-link-up-or-device-mtu-cha.patch:
+        set ipv6 mtu at correct time
+  * pstore: Don't start systemd-pstore.service in containers.
+    Usually it is not useful and can also fail making
+    boot-and-services autopkgtest fail. (LP: #1856729)
+    File: debian/patches/pstore-Don-t-start-systemd-pstore.service-in-containers.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=28b5a03769cbed9d3170ebac38508b867530a2d6
+  * Revert: network: do not drop foreign config if interface is in initialized state.
+    This fixes FTBFS with the other network-related reverts.
+    File: debian/patches/Revert-network-do-not-drop-foreign-config-if-interface-is.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=22a9fa3bb03ba2a629926af39ea7df81fe33c9b8
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Wed, 18 Dec 2019 21:40:27 +0100
+
+systemd (244-3ubuntu5) focal; urgency=medium
+
+  [ Dariusz Gadomski ]
+  * d/p/lp1762391/0001-user-util-Add-helper-functions-for-gid-lists-operati.patch,
+    d/p/lp1762391/0002-execute-Restore-call-to-pam_setcred.patch,
+    d/p/lp1762391/0003-execute-Detect-groups-added-by-PAM-and-merge-them-wi.patch,
+    d/p/lp1762391/0004-test-Add-tests-for-gid-list-ops.patch,
+    d/p/lp1762391/0005-execute-add-const-to-array-parameters-where-possible.patch,
+    d/p/lp1762391/0006-execute-allow-pam_setcred-to-fail-ignore-errors.patch:
+    - Restore call to pam_setcred (LP: #1762391)
+
+  [ Dan Streetman ]
+  * d/t/storage: without scsi_debug, skip test (LP: #1847816)
+
+ -- Dan Streetman <ddstreet@canonical.com>  Sun, 19 Jan 2020 09:59:58 -0500
+
+systemd (244-3ubuntu4) focal; urgency=medium
+
+  * d/p/lp1671951-network-set-ipv6-mtu-after-link-up-or-device-mtu-cha.patch:
+    set ipv6 mtu at correct time (LP: #1671951)
+  * d/p/0001-network-rename-linux_configure_after_setting_mtu-to-linux.patch,
+    d/p/0002-network-add-link-setting_genmode-flag.patch,
+    d/p/0003-network-if-ipv6ll-is-disabled-enumerate-tentative-ipv6-ad.patch,
+    d/p/0004-network-drop-foreign-config-after-addr_gen_mode-has-been-.patch:
+    - drop foreign config and raise interface after setting genmode
+      (LP: #1845909)
+
+ -- Dan Streetman <ddstreet@canonical.com>  Tue, 14 Jan 2020 14:01:15 -0500
+
+systemd (244-3ubuntu3) focal; urgency=medium
+
+  * shutdown: cherry-pick PR#14409 to fix detach of loopback devices
+    for Ubuntu Core 20
+    File: debian/patches/shutdown-modernizations-pr-14409.patch
+    https://github.com/systemd/systemd/pull/14409.diff
+
+ -- Michael Vogt <michael.vogt@ubuntu.com>  Fri, 10 Jan 2020 10:08:42 +0100
+
+systemd (244-3ubuntu2) focal; urgency=medium
+
+  * d/p/debian/UBUNTU-Support-system-image-read-only-etc.patch:
+    - re-add missing bits for timedated.c (LP: #1778936)
+
+ -- Michael Vogt <michael.vogt@ubuntu.com>  Wed, 08 Jan 2020 16:15:05 +0100
+
+systemd (244-3ubuntu1) focal; urgency=medium
+
+  [ Balint Reczey ]
+  * Merge to Ubuntu from Debian unstable
+  * Refresh patches:
+    - Dropped changes:
+      * d/t/control: mark udev test skippable.
+        File: debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c3419bd2a30a78d05cca9c38e50c9726de7e7632
+      * test-execute: Filter /dev/.lxc in exec-dynamicuser-statedir.service.
+        File: debian/patches/test-execute-Filter-dev-.lxc-in-exec-dynamicuser-statedir.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=75af888d5552f706b86182a56f12ccc8e83ca04e
+      * Pass personality test even when i386 userland runs on amd64 kernel
+        File: debian/patches/debian/UBUNTU-test-Pass-personality-test-even-when-i386-userland-runs-o.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=42e0bfc426f19430f6768ef4922a9531a345765f
+      * Fix resolved fallback to TCP (LP: #1849658)
+        Author: Dan Streetman
+        File: debian/patches/resolved-set-stream-type-during-DnsStream-creation.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f1ee30b13c9d2d34968b09ce620f3bc24a1a78c7
+    - Remaining changes:
+      * Recommend networkd-dispatcher
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1e3b2c7e4757119da0d550b0b3c0a6626a176dc
+      * Enable EFI/bootctl on armhf.
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=043122f7d8a1487bfd357e815a6ece1ceea6e7d1
+      * debian/control: strengthen dependencies.
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1ecf0c372f5212129c85ae60fddf26b2271a1fe
+      * Add conflicts with upstart and systemd-shim
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=83ed7496afc7c27be026014d109855f7d0ad1176
+      * Specify Ubuntu's Vcs-Git
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=fd832930ef280c9a4a9dda2440d5a46a6fdb6232
+      * Ubuntu/extra: ship dhclient-enter hook.
+        Files:
+        - debian/extra/dhclient-enter-resolved-hook
+        - debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f3398a213f80b02bf3db0c1ce9e22d69f6d56764
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=258893bae8cbb12670e4807636fe8f7e9fb5407a
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0725c1169ddde4f41cacba7af3e546704e2206be
+      * udev-udeb: ship modprobe.d snippet to force scsi_mod.scan=sync in d-i.
+        Files:
+        - debian/extra/modprobe.d-udeb/scsi-mod-scan-sync.conf
+        - debian/udev-udeb.install
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=eb6d8a2b9504917abb7aa2c4035fdbb7b98227f7
+      * debian/extra/start-udev: Set scsi_mod scan=sync even if it's builtin to the kernel (we previously only set it in modprobe.d)
+        Files:
+        - debian/extra/start-udev
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6b72628f8de991e2c67ac4289fc74daf3abe7d14
+      * debian/extra/units/systemd-resolved.service.d/resolvconf.conf:
+        drop resolvconf.conf drop-in, resolved integration moved to resolvconf package.
+      * debian/extra/wrap_cl.py: add changelog formatter
+        Files:
+        - debian/extra/wrap_cl.py
+        - debian/gbp.conf
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=26e69bceab9cec8df64cdca18cd71e7c0874f8b3
+      * debian/gbp.conf: Set tag format to ubuntu/*
+      * debian/gbp.conf: Change debian-branch to ubuntu-eoan
+      * libnss-resolve: do not disable and stop systemd-resolved
+        File: debian/libnss-resolve.postrm
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=95577d14e84e19b614b83b2e24985d89e8c2dac0
+      * core: Revert strict mount namespacing/sandboxing, until LXD allows the needed mounts.
+        File: debian/patches/Revert-namespace-be-more-careful-when-handling-namespacin.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=030919ba5e4931d6ee576d0259fae67fe4ed9770
+      * Add "AssumedApparmorLabel=unconfined" to timedate1 dbus service file
+        File: debian/patches/debian/UBUNTU-Add-AssumedApparmorLabel-unconfined-to-timedate1-dbus.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5ad0879e10bbe3d641f940260b93c7eb2cf4624c
+      * Re-add support for /etc/writable for core18
+        File: debian/patches/debian/UBUNTU-Support-system-image-read-only-etc.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=a5b5fca66c1127068e4ce0cc9ab497814211f4f7
+      * Improve autopkgtest success rate, by bumping up timeouts
+        File: debian/patches/debian/UBUNTU-bump-selftest-timeouts.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c05586d9da033bbfd6b6a74e10b87520843c7c48
+      * core: set /run size to 10%, like initramfs-tools does.
+        File: debian/patches/debian/UBUNTU-core-set-run-size-to-10-like-initramfs-tools-does.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fac2568fe716dc1a41bada78293dc6327a6df0d
+      * Ship systemd sysctl settings.
+        Files:
+        - debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch
+        - debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=7cd041a6d0ef459e4b2a82d8ea5fa1ce05184dfb
+      * journald.service: set Nice=-1 to dodge watchdog on soft lockups.
+        File: debian/patches/debian/UBUNTU-journald.service-set-Nice-1-to-dodge-watchdog-on-soft-loc.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e0a9aeffac556492bf517ce2d23313ff7a277926
+      * networkd: if RA was implicit, do not await ndisc_configured.
+        File: debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2f749ff528d1b788aa4ca778e954c16b213ee629
+      * networkd: [Route] PreferredSource not working in *.network files.
+        Files:
+        - debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4e2ee0b2ac1be2ae78952890a56a2d5398df518
+      * Disable LLMNR and MulticastDNS by default
+        Files:
+        - debian/patches/debian/UBUNTU-resolved-disable-global-LLMNR-and-MulticastDNS.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4ec428e83696a5cd0405b677a35e97681867629
+      * test-sleep: skip test_fiemap upon inapproriate ioctl for device.
+        File: debian/patches/debian/UBUNTU-test-sleep-skip-test_fiemap-upon-inapproriate-ioctl-.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6ebb5b9f6b77760a5470e8a780d69875b1db76f7
+      * test/test-functions: launch qemu-system with -vga none.
+        File: debian/patches/debian/UBUNTU-test-test-functions-launch-qemu-with-vga-none.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=90af1fa893cce5ed49999d16da0b793da6523394
+      * units: conditionalize more units to not start in containers.
+        Files:
+        - debian/patches/debian/UBUNTU-units-block-CAP_SYS_MODULE-units-in-containers-too.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3689afa1a782de8c19a757459b6360de1195ad55
+      * units: Disable journald Watchdog
+        File: debian/patches/debian/UBUNTU-units-disable-journald-watchdog.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=64d2b4f1d0d057073fba585f19823332e2a6eed5
+      * wait-online: do not wait, if no links are managed (neither configured, or failed).
+        File: debian/patches/debian/UBUNTU-wait-online-exit-if-no-links-are-managed.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=31f04c3fc769dacb3cf2a78240a1710a99a865b8
+      * Set UseDomains to true, by default, on Ubuntu.
+        File: debian/patches/debian/Ubuntu-UseDomains-by-default.patch
+      * Ignore failures to set Nice priority on services in containers.
+        File: debian/patches/debian/Ubuntu-core-in-execute-soft-fail-setting-Nice-priority-when.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5b8e457f8d883fc6f55d33d46b3474926a495d29
+      * units: set ConditionVirtualization=!private-users on journald audit socket.
+        File: debian/patches/debian/Ubuntu-units-set-ConditionVirtualization-private-users-on-j.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=03ed18a9940731bbf794ad320fabf337488835c6
+      * Workaround captive portals not responding to EDNS0 queries (DVE-2018-0001).
+        File: debian/patches/resolved-Mitigate-DVE-2018-0001-by-retrying-NXDOMAIN-with.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=87d3fe81b7281687ecf3c0b9a8356e90cc714d0b
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2974114ed9b89ea922a23893e8eff70d5cac77fe
+      * Disable dh_installinit generation of tmpfiles for the systemd package.
+        Files:
+        - debian/rules
+        - debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fd144cbe31cc7a9383cc76f21f4b84c22a9dd1b
+      * Enable systemd-resolved by default
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=05adfa0902115f51c1196ad623165a75bb8b4313
+      * Create /etc/resolv.conf at postinst, pointing at the stub resolver.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=ef4adf46bbbe2d22508b70b889d23da53b85039d
+      * Always setup /etc/resolv.conf on new installations.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=20bc8a37fa3c9620bed21a56a4eabd71db71d861
+      * Disable systemd-networkd-wait-online by default.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=694473d812b50d2fefd6494d494ca02b91bc8785
+      * postinst: drop empty/stock /etc/rc.local
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e7d071a26a79558771303b0b87f007e650eaebbe
+      * systemd.postinst: enable persistent journal
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f94f18d9dbc085b6a9ff33c141a6e542142f85b5
+      * debian/systemd.postinst: Skip daemon-reexec and try-restarts during shutdown
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=51daab96ae79483b5e5fb62e1e0477c87ee11fd1
+      * Drop systemd.prerm safety check.
+        File: debian/systemd.prerm
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0244c4d56556317f14eecc2f51871969ef02ba7b
+      * boot-and-services: stderr is ok, for status command on the c1 container.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=da14d34e7cc33c44ad67e64c9fd092f8cc1675f9
+      * adt: boot-and-services: assert any kernel syslog messages.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=29dc34f7a6e5dc505f6212c17c42e4420b47ed16
+      * Wait for systemctl is-system-running state.
+        File: debian/tests/boot-smoke
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=776998f1f55c445b6e385cab69a4219c42d00838
+      * debian/tests: Enforce udev upgrade.
+        Files:
+        - debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f350b43ccc1aa31c745b4ccebbb4084d5cea41ff
+      * Only test that gdm3 comes up on amd64. Stalls on other arches.
+        File: debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=97cb13685dfb353045c449ec5d6d1df60f661079
+      * debian/tests/systemd-fsckd: update assertions expectations for v237
+        File: debian/tests/systemd-fsckd
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d5becd9a416b55dcdb7b9a7aba60c4e3d304e6a6
+      * Skip systemd-fsckd on arm64, because of broken/lack of clean shutdown.
+        File: debian/tests/systemd-fsckd
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=bf5b501ac934497dbef5f64908ff37643dc7288e
+      * debian/tests: blacklist upstream test-24-unit-tests on ppc64le.
+        File: debian/tests/upstream
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=8062b9a2712c390010d2948eaf764a1b52e68715
+      * Skip falling back to device name when net_get_name(device) fails.
+        File: debian/patches/Skip-falling-back-to-device-name-when-net_get_name-device.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c79fe0e2dc29834e0cd236ade6e4e44a6ffb74fa
+      * debian/test/boot-and-services: Skip AppArmor tests in arm containers.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=9d3b35df77aa939365563a4edaee54ebb7f559a3
+      * d/t/control: run udev tests only with isolation-machine.
+        File: debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4b4c9bf44f4b8d7f75a4204aff697f549c8aad7
+      * UBUNTU: drop setting fs.protected_regular and fs.protected_fifos
+        File: debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6e583847b04c3f83a50f3bd6947dcae6a73d8388
+  * debian/rules: Set -Duser-path instead of patching the source for the same result
+    File: debian/rules
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=67d2ac5d806b55b0d178fca7e0af08cd9d12580c
+  * systemd-resolved: Default to Cache=no-negative
+    File: debian/patches/debian/UBUNTU-resolved-default-no-negative-caching.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b42658843a9496d6b6bb68ac159f2a9f0a8ba9db
+
+  [ Dan Streetman ]
+  * Remove tempfile used by dhclient-enter-resolved-hook
+    File: debian/extra/dhclient-enter-resolved-hook
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=00a0d3997f7f9664df5cc2d7f96622e8c641f3e5
+
+  [ Christian Ehrhardt ]
+  * drop d/p/test-expect-mmap-to-fail-in-seccomp-test-on-s390-and-s390.patch.
+    File: debian/patches/test-expect-mmap-to-fail-in-seccomp-test-on-s390-and-s390.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2edd57973b9342d46d5d4095d80dfe0969cd08e4
+  * d/p/lp-1853852-*: fix issues with muliplexed shmat calls (LP: #1853852)
+    Author: Christian Ehrhardt
+    Files:
+    - debian/patches/lp-1853852-seccomp-fix-multiplexed-system-calls.patch
+    - debian/patches/lp-1853852-seccomp-mmap-test-results-depend-on-kernel-libseccom.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=382271662c60c339b0a404c7a1772fe5670516ef
+  * changelog: fix issues with muliplexed shmat calls (LP: #1853852)
+    File: debian/changelog
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=7048d92d071e70e5b17989ae2e03c996c843df78
+
+  [ Dimitri John Ledkov ]
+  * config: tpm-pcrindex=12, on Ubuntu only.
+    In Ubuntu, we are trying to integrate measured boot with either bootctl or
+    grub, or sometimes both using chainloading. In those cases we may want to seal
+    against grub's PCRs, bootctl stub PCRs, or both at the same time. To achieve
+    that, we wouldn't like to decouple grub's & bootctl's PCR and make the latter
+    one use PCR #12.
+    Author: Dimitri John Ledkov
+    File: debian/rules
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2f8c22d44a619ce8fa17eb0cd7c7e2c601cdbbeb
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Fri, 13 Dec 2019 19:05:14 +0100
+
 systemd (244-3) unstable; urgency=medium
 
   * Update udev-udeb to use 73-usb-net-by-mac.link
@@ -294,12 +1330,306 @@ systemd (243-4) experimental; urgency=me
 
  -- Michael Biebl <biebl@debian.org>  Sat, 09 Nov 2019 01:15:08 +0100
 
+systemd (243-3ubuntu1) focal; urgency=medium
+
+  [ Dan Streetman ]
+  * Fix resolved fallback to TCP (LP: #1849658)
+    Author: Dan Streetman
+    File: debian/patches/resolved-set-stream-type-during-DnsStream-creation.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f1ee30b13c9d2d34968b09ce620f3bc24a1a78c7
+  * Separate stderr and stdout of /etc/dhcp/dhclient-enter-hooks.d/resolved
+    (LP: #1849608)
+    Author: Dan Streetman
+    File: debian/extra/dhclient-enter-resolved-hook
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=fec4d6d026488a1d32ad9dceef18d9ea9c8acbda
+
+  [ Balint Reczey ]
+  * Merge to Ubuntu from Debian experimental
+  * Refresh patches:
+    - Dropped changes:
+      * udevadm trigger: do not propagate EACCES and ENODEV.
+        File: debian/patches/udevadm-trigger-do-not-propagate-EACCES-and-ENODEV.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=334e3fdc904de05105c78763c88220c1976d1946
+      * Pass personality test even when i386 userland runs on amd64 kernel
+        File: debian/patches/debian/UBUNTU-test-Pass-personality-test-even-when-i386-userland-runs-o.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=42e0bfc426f19430f6768ef4922a9531a345765f
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Wed, 30 Oct 2019 15:19:33 +0100
+
 systemd (243-3) experimental; urgency=medium
 
   * Import patches from v243-stable branch (up to ef677436aa)
 
  -- Michael Biebl <biebl@debian.org>  Mon, 14 Oct 2019 15:26:01 +0200
 
+systemd (243-2ubuntu1) focal; urgency=medium
+
+  [ Balint Reczey ]
+  * Merge to Ubuntu from experimental
+  * Refresh patches:
+    - Dropped changes:
+      * Cherrypick ask-password: prevent buffer overrow when reading from keyring.
+        File: debian/patches/ask-password-prevent-buffer-overrow-when-reading-fro.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6d6e9cbd4fc6e018031a4762e88f2c3aa19e24e8
+      * random-util: eat up bad RDRAND values seen on AMD CPUs.
+        File: debian/patches/+rdrand-workaround-on-amd.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?h=ubuntu-eoan&id=6ab88231efca4b04b26de6cfb5d671be154aabe0
+    - Remaining changes:
+      * Recommend networkd-dispatcher
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1e3b2c7e4757119da0d550b0b3c0a6626a176dc
+      * Enable EFI/bootctl on armhf.
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=043122f7d8a1487bfd357e815a6ece1ceea6e7d1
+      * debian/control: strengthen dependencies.
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1ecf0c372f5212129c85ae60fddf26b2271a1fe
+      * Add conflicts with upstart and systemd-shim
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=83ed7496afc7c27be026014d109855f7d0ad1176
+      * Specify Ubuntu's Vcs-Git
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=fd832930ef280c9a4a9dda2440d5a46a6fdb6232
+      * Ubuntu/extra: ship dhclient-enter hook.
+        Files:
+        - debian/extra/dhclient-enter-resolved-hook
+        - debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f3398a213f80b02bf3db0c1ce9e22d69f6d56764
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=258893bae8cbb12670e4807636fe8f7e9fb5407a
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0725c1169ddde4f41cacba7af3e546704e2206be
+      * udev-udeb: ship modprobe.d snippet to force scsi_mod.scan=sync in d-i.
+        Files:
+        - debian/extra/modprobe.d-udeb/scsi-mod-scan-sync.conf
+        - debian/udev-udeb.install
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=eb6d8a2b9504917abb7aa2c4035fdbb7b98227f7
+      * debian/extra/start-udev: Set scsi_mod scan=sync even if it's builtin to the kernel (we previously only set it in modprobe.d)
+        Files:
+        - debian/extra/start-udev
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6b72628f8de991e2c67ac4289fc74daf3abe7d14
+      * debian/extra/units/systemd-resolved.service.d/resolvconf.conf:
+        drop resolvconf.conf drop-in, resolved integration moved to resolvconf package.
+      * debian/extra/wrap_cl.py: add changelog formatter
+        Files:
+        - debian/extra/wrap_cl.py
+        - debian/gbp.conf
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=26e69bceab9cec8df64cdca18cd71e7c0874f8b3
+      * debian/gbp.conf: Set tag format to ubuntu/*
+      * debian/gbp.conf: Change debian-branch to ubuntu-eoan
+      * libnss-resolve: do not disable and stop systemd-resolved
+        File: debian/libnss-resolve.postrm
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=95577d14e84e19b614b83b2e24985d89e8c2dac0
+      * core: Revert strict mount namespacing/sandboxing, until LXD allows the needed mounts.
+        File: debian/patches/Revert-namespace-be-more-careful-when-handling-namespacin.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=030919ba5e4931d6ee576d0259fae67fe4ed9770
+      * Add "AssumedApparmorLabel=unconfined" to timedate1 dbus service file
+        File: debian/patches/debian/UBUNTU-Add-AssumedApparmorLabel-unconfined-to-timedate1-dbus.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5ad0879e10bbe3d641f940260b93c7eb2cf4624c
+      * Re-add support for /etc/writable for core18
+        File: debian/patches/debian/UBUNTU-Support-system-image-read-only-etc.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=a5b5fca66c1127068e4ce0cc9ab497814211f4f7
+      * Improve autopkgtest success rate, by bumping up timeouts
+        File: debian/patches/debian/UBUNTU-bump-selftest-timeouts.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c05586d9da033bbfd6b6a74e10b87520843c7c48
+      * core: set /run size to 10%, like initramfs-tools does.
+        File: debian/patches/debian/UBUNTU-core-set-run-size-to-10-like-initramfs-tools-does.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fac2568fe716dc1a41bada78293dc6327a6df0d
+      * Ship systemd sysctl settings.
+        Files:
+        - debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch
+        - debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=7cd041a6d0ef459e4b2a82d8ea5fa1ce05184dfb
+      * journald.service: set Nice=-1 to dodge watchdog on soft lockups.
+        File: debian/patches/debian/UBUNTU-journald.service-set-Nice-1-to-dodge-watchdog-on-soft-loc.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e0a9aeffac556492bf517ce2d23313ff7a277926
+      * networkd: if RA was implicit, do not await ndisc_configured.
+        File: debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2f749ff528d1b788aa4ca778e954c16b213ee629
+      * networkd: [Route] PreferredSource not working in *.network files.
+        Files:
+        - debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4e2ee0b2ac1be2ae78952890a56a2d5398df518
+      * Disable LLMNR and MulticastDNS by default
+        Files:
+        - debian/patches/debian/UBUNTU-resolved-disable-global-LLMNR-and-MulticastDNS.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4ec428e83696a5cd0405b677a35e97681867629
+      * test-sleep: skip test_fiemap upon inapproriate ioctl for device.
+        File: debian/patches/debian/UBUNTU-test-sleep-skip-test_fiemap-upon-inapproriate-ioctl-.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6ebb5b9f6b77760a5470e8a780d69875b1db76f7
+      * test/test-functions: launch qemu-system with -vga none.
+        File: debian/patches/debian/UBUNTU-test-test-functions-launch-qemu-with-vga-none.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=90af1fa893cce5ed49999d16da0b793da6523394
+      * units: conditionalize more units to not start in containers.
+        Files:
+        - debian/patches/debian/UBUNTU-units-block-CAP_SYS_MODULE-units-in-containers-too.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3689afa1a782de8c19a757459b6360de1195ad55
+      * units: Disable journald Watchdog
+        File: debian/patches/debian/UBUNTU-units-disable-journald-watchdog.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=64d2b4f1d0d057073fba585f19823332e2a6eed5
+      * wait-online: do not wait, if no links are managed (neither configured, or failed).
+        File: debian/patches/debian/UBUNTU-wait-online-exit-if-no-links-are-managed.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=31f04c3fc769dacb3cf2a78240a1710a99a865b8
+      * Set UseDomains to true, by default, on Ubuntu.
+        File: debian/patches/debian/Ubuntu-UseDomains-by-default.patch
+      * Ignore failures to set Nice priority on services in containers.
+        File: debian/patches/debian/Ubuntu-core-in-execute-soft-fail-setting-Nice-priority-when.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5b8e457f8d883fc6f55d33d46b3474926a495d29
+      * units: set ConditionVirtualization=!private-users on journald audit socket.
+        File: debian/patches/debian/Ubuntu-units-set-ConditionVirtualization-private-users-on-j.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=03ed18a9940731bbf794ad320fabf337488835c6
+      * Workaround captive portals not responding to EDNS0 queries (DVE-2018-0001).
+        File: debian/patches/resolved-Mitigate-DVE-2018-0001-by-retrying-NXDOMAIN-with.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=87d3fe81b7281687ecf3c0b9a8356e90cc714d0b
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2974114ed9b89ea922a23893e8eff70d5cac77fe
+      * Disable dh_installinit generation of tmpfiles for the systemd package.
+        Files:
+        - debian/rules
+        - debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fd144cbe31cc7a9383cc76f21f4b84c22a9dd1b
+      * Enable systemd-resolved by default
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=05adfa0902115f51c1196ad623165a75bb8b4313
+      * Create /etc/resolv.conf at postinst, pointing at the stub resolver.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=ef4adf46bbbe2d22508b70b889d23da53b85039d
+      * Always setup /etc/resolv.conf on new installations.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=20bc8a37fa3c9620bed21a56a4eabd71db71d861
+      * Disable systemd-networkd-wait-online by default.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=694473d812b50d2fefd6494d494ca02b91bc8785
+      * postinst: drop empty/stock /etc/rc.local
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e7d071a26a79558771303b0b87f007e650eaebbe
+      * systemd.postinst: enable persistent journal
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f94f18d9dbc085b6a9ff33c141a6e542142f85b5
+      * debian/systemd.postinst: Skip daemon-reexec and try-restarts during shutdown
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=51daab96ae79483b5e5fb62e1e0477c87ee11fd1
+      * Drop systemd.prerm safety check.
+        File: debian/systemd.prerm
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0244c4d56556317f14eecc2f51871969ef02ba7b
+      * boot-and-services: stderr is ok, for status command on the c1 container.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=da14d34e7cc33c44ad67e64c9fd092f8cc1675f9
+      * adt: boot-and-services: assert any kernel syslog messages.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=29dc34f7a6e5dc505f6212c17c42e4420b47ed16
+      * tests/boot-smoke: ignore udevd connection timeouts resolving colord group.
+        File: debian/tests/boot-smoke
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e1477b764fa9ef23f5181ef3d31a1332191c3e0b
+      * Fix false negative checking for running jobs after boot.
+        File: debian/tests/boot-smoke
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=aeb01631efbaf3fe851dee15d496e0b66b5c347f
+      * Wait for systemctl is-system-running state.
+        File: debian/tests/boot-smoke
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=776998f1f55c445b6e385cab69a4219c42d00838
+      * debian/tests: Enforce udev upgrade.
+        Files:
+        - debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f350b43ccc1aa31c745b4ccebbb4084d5cea41ff
+      * Only test that gdm3 comes up on amd64. Stalls on other arches.
+        File: debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=97cb13685dfb353045c449ec5d6d1df60f661079
+      * debian/tests/systemd-fsckd: update assertions expectations for v237
+        File: debian/tests/systemd-fsckd
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d5becd9a416b55dcdb7b9a7aba60c4e3d304e6a6
+      * Skip systemd-fsckd on arm64, because of broken/lack of clean shutdown.
+        File: debian/tests/systemd-fsckd
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=bf5b501ac934497dbef5f64908ff37643dc7288e
+      * debian/tests: blacklist upstream test-24-unit-tests on ppc64le.
+        File: debian/tests/upstream
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=8062b9a2712c390010d2948eaf764a1b52e68715
+      * Skip falling back to device name when net_get_name(device) fails.
+        File: debian/patches/Skip-falling-back-to-device-name-when-net_get_name-device.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c79fe0e2dc29834e0cd236ade6e4e44a6ffb74fa
+      * d/t/control: mark udev test skippable.
+        File: debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c3419bd2a30a78d05cca9c38e50c9726de7e7632
+      * debian/extra/wrap_cl.py: add changelog formatter
+        Files:
+        - debian/extra/wrap_cl.py
+        - debian/gbp.conf
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=26e69bceab9cec8df64cdca18cd71e7c0874f8b3
+      * debian/test/boot-and-services: Skip AppArmor tests in arm containers.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=9d3b35df77aa939365563a4edaee54ebb7f559a3
+      * d/t/control: run udev tests only with isolation-machine.
+        File: debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4b4c9bf44f4b8d7f75a4204aff697f549c8aad7
+      * UBUNTU: drop setting fs.protected_regular and fs.protected_fifos
+        File: debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6e583847b04c3f83a50f3bd6947dcae6a73d8388
+      * test-execute: Filter /dev/.lxc in exec-dynamicuser-statedir.service.
+        File: debian/patches/test-execute-Filter-dev-.lxc-in-exec-dynamicuser-statedir.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=75af888d5552f706b86182a56f12ccc8e83ca04e
+      * Pass personality test even when i386 userland runs on amd64 kernel
+        File: debian/patches/debian/UBUNTU-test-Pass-personality-test-even-when-i386-userland-runs-o.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=42e0bfc426f19430f6768ef4922a9531a345765f
+  * Revert manager putting bin before sbin in user instances
+    File: debian/patches/Revert-manager-put-bin-before-sbin-for-user-instances.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=a01b494922bf76c4c3659b43df4f45a554f3276a
+  * Set the previous default, -Ddefault-hierarchy=hybrid at build-time.
+    This prevents breaking container managers
+    File: debian/rules
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=ad8bc71956b7bcc97563383345024c93a0572cc7
+  * Revert "cgroup: Continue unit reset if cgroup is busy"
+    The change broke libvirt autopkgtest in Ubuntu. (LP: #1844879)
+    File: debian/patches/Revert-cgroup-Continue-unit-reset-if-cgroup-is-busy.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=9bed00d9ea138f08d79c83c40ed3933eb04a5624
+  * debian/tests/boot-smoke: Drop part of the delta to gain better debug info
+    File: debian/tests/boot-smoke
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=06715f3af3099cae57768de99d1b84fecca5a15d
+  * Revert upstream adding LINK_STATE_INITIALIZED because it breaks netplan.io's
+    ethernets autopkgtest.
+    Files:
+    - debian/patches/Revert-network-fix-assertion-when-link-get-carrier.patch
+    - debian/patches/Revert-network-prevent-interfaces-to-be-initialized-multi.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=70e93c2a05f0f7435614f8d52944d726601e319c
+  * d/e/checkout-upstream: UPSTREAM_REPO can override default systemd repo
+    File: debian/extra/checkout-upstream
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=a658380b58e5082e79476096fe7ee85358546f64
+  * debian/extra/checkout-upstream: rebase only PRs on upstream master.
+    This fixes testing arbitrary upstream commits with UPSTREAM_HEAD=<commit-id>.
+    File: debian/extra/checkout-upstream
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=7b8d2ae3cc68e7c388ce9ef7189c0451745ad6c2
+  * d/e/checkout-upstream: Add KEEP_DEBIAN_PATCHES option to keep patches.
+    The Debian patches that apply cleanly are kept when KEEP_DEBIAN_PATCHES
+    is set to give a better picture of how the tested upstream version
+    would work packaged.
+    File: debian/extra/checkout-upstream
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=a69135efeb8ee0bb92ff56523c117db2585922c4
+  * d/e/checkout-upstream: Keep all autopkgtests when KEEP_DEBIAN_TESTS is set
+    File: debian/extra/checkout-upstream
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=50ae2b41d87a7791d609d66e3d27a3a50d814edc
+  * debian/extra/checkout-upstream: Use dots when deriving version from upstream
+    to sort higher than potential versions in Debian and also to conform native
+    package versioning practice.
+    File: debian/extra/checkout-upstream
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=11c23cb721fa402160ea81b10cf3022a3f4cba8c
+  * Use package's version as systemd's reported version (LP: #1849158)
+    File: debian/rules
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5245cbb5d168b56adc8106ccdb9b224830d55a45
+  * Fix test: expect mmap to fail in seccomp test on s390 and s390x
+    File: debian/patches/test-expect-mmap-to-fail-in-seccomp-test-on-s390-and-s390.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=04b28d6b177c2cf84c4bd262183098f47c356885
+  * udevadm trigger: do not propagate EACCES and ENODEV.
+    Propagating the errors broke udisks2 install scripts among others.
+    (LP: #1845314)
+    File: debian/patches/udevadm-trigger-do-not-propagate-EACCES-and-ENODEV.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=334e3fdc904de05105c78763c88220c1976d1946
+  * debian/gbp.conf: Set debian-branch to ubuntu-focal
+    File: debian/gbp.conf
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=fae20a0dd7c2b24f6f6b49edf6e8f70adf57dc44
+
+  [ Dan Streetman ]
+  * d/extra/rules/73-special-net-names.rules: use $$ instead of $ in PROGRAM= value.
+    Author: Dan Streetman
+    File: debian/extra/rules/73-special-net-names.rules
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c5a86d7e286d14f2bc78473c3a1cc6ddc0df9158
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Tue, 22 Oct 2019 19:17:05 +0200
+
 systemd (243-2) experimental; urgency=medium
 
   * Import patches from v243-stable branch (up to fab6f010ac)
@@ -351,6 +1681,45 @@ systemd (242-8) unstable; urgency=medium
 
  -- Michael Biebl <biebl@debian.org>  Fri, 08 Nov 2019 23:18:00 +0100
 
+systemd (242-7ubuntu2) eoan; urgency=medium
+
+  [ Bryan Quigley ]
+  * Update patch for resolved: Mitigate DVE-2018-0001, by retrying NXDOMAIN
+    without EDNS0. This disables the workaround if DNSSEC=yes.
+    Falls back directly to simple UDP instead of trying an intermediate.
+    (LP: #1796501)
+    Author: Bryan Quigley
+    File: debian/patches/resolved-Mitigate-DVE-2018-0001-by-retrying-NXDOMAIN-with.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2974114ed9b89ea922a23893e8eff70d5cac77fe
+
+  [ Balint Reczey ]
+  * Pass personality test even when i386 userland runs on amd64 kernel
+    File: debian/patches/debian/UBUNTU-test-Pass-personality-test-even-when-i386-userland-runs-o.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=42e0bfc426f19430f6768ef4922a9531a345765f
+  * Refresh patches
+    Files:
+    - debian/patches/Revert-namespace-be-more-careful-when-handling-namespacin.patch
+    - debian/patches/debian/Ubuntu-core-in-execute-soft-fail-setting-Nice-priority-when.patch
+    - debian/patches/test-execute-Filter-dev-.lxc-in-exec-dynamicuser-statedir.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=ff8387be07322230e9afe87f1c767ee241e9a0e1
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Tue, 08 Oct 2019 22:31:17 +0200
+
+systemd (242-7ubuntu1) eoan; urgency=medium
+
+  * Merge from unstable
+  * UBUNTU: drop setting fs.protected_regular and fs.protected_fifos from
+    sysctl defaults shipped by systemd (LP: #1845637)
+    File: debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6e583847b04c3f83a50f3bd6947dcae6a73d8388
+  * test-execute: Filter /dev/.lxc in exec-dynamicuser-statedir.service.
+    It appears in nested LXC containers and broke the armhf autopkgtest.
+    (LP: #1845337)
+    File: debian/patches/test-execute-Filter-dev-.lxc-in-exec-dynamicuser-statedir.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=75af888d5552f706b86182a56f12ccc8e83ca04e
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Wed, 02 Oct 2019 14:13:28 +0200
+
 systemd (242-7) unstable; urgency=medium
 
   * sleep: properly pass verb to sleep script
@@ -365,6 +1734,243 @@ systemd (242-7) unstable; urgency=medium
 
  -- Michael Biebl <biebl@debian.org>  Wed, 04 Sep 2019 19:34:17 +0200
 
+systemd (242-6ubuntu1) eoan; urgency=medium
+
+  [ Dan Streetman ]
+  * d/t/control: mark udev test skippable.
+    The udev test will return 77 (from udev-test.pl) if it can't
+    setup the test environment; mark it skipped in that case.
+    Author: Dan Streetman
+    File: debian/tests/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c3419bd2a30a78d05cca9c38e50c9726de7e7632
+
+  [ Dimitri John Ledkov ]
+  * debian/extra/wrap_cl.py: add changelog formatter
+    Author: Dimitri John Ledkov
+    Files:
+    - debian/extra/wrap_cl.py
+    - debian/gbp.conf
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=26e69bceab9cec8df64cdca18cd71e7c0874f8b3
+
+  [ Balint Reczey ]
+  * debian/test/boot-and-services: Skip AppArmor tests in arm containers.
+    The test is failing on armhf testbeds using containers
+    File: debian/tests/boot-and-services
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=9d3b35df77aa939365563a4edaee54ebb7f559a3
+  * d/t/control: run udev tests only with isolation-machine.
+    It fails in Ubuntu CI armhf containers and may fail elsewhere, too.
+    File: debian/tests/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4b4c9bf44f4b8d7f75a4204aff697f549c8aad7
+  * Merge to Ubuntu from unstable
+    - Dropped changes:
+      * Skip starting systemd-remount-fs.service in containers
+        even when /etc/fstab is present.
+        File: debian/patches/debian/Skip-starting-systemd-remount-fs.service-in-containers.patch
+      * resolved: add support for pipelined requests
+        Files:
+        - debian/patches/llmnr-add-comment-why-we-install-no-complete-handler-on-s.patch
+        - debian/patches/resolved-add-comment-to-dns_stream_complete-about-its-err.patch
+        - debian/patches/resolved-keep-stub-stream-connections-up-for-as-long-as-c.patch
+        - debian/patches/resolved-only-call-complete-with-zero-argument-in-LLMNR-c.patch
+        - debian/patches/resolved-restart-stream-timeout-whenever-we-managed-to-re.patch
+        - debian/patches/stream-follow-coding-style-don-t-use-degrade-to-bool-for-.patch
+        - debian/patches/stream-track-type-of-DnsStream-object.patch
+        - debian/patches/transaction-simplify-handling-if-we-get-an-unexpected-DNS.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=8ad1db08c2135af098a33957ce7cffbe21fb683f
+      * pam-systemd: use secure_getenv() rather than getenv()
+        File: debian/patches/pam-systemd-use-secure_getenv-rather-than-getenv.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f3291e9e8c3eafd0c8921cb26a0d5ee0fd563b3c
+      * support PPC64LE qemu based testing.
+        Files:
+        - debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=483a4daba07f809883883e8e8b9c365cfbf7256e
+      * tests/storage: make the test more resilient.
+        File: debian/tests/storage
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c08dcb1ffe372acd3a21496758a1984ff78dcdd4
+      * Wait for cryptsetup unit to start, before stopping.
+        File: debian/tests/storage
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b65aa350be7e61c65927fbc0921a750fcfaa51cd
+      * Fix typpo in storage test.
+        File: debian/tests/storage
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f28aa5fe4ab175b99b6ea702559c59ca473b4ca8
+    - Remaining changes:
+      * Set UseDomains to true, by default, on Ubuntu.
+        File: debian/patches/debian/Ubuntu-UseDomains-by-default.patch
+      * Enable systemd-resolved by default
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=05adfa0902115f51c1196ad623165a75bb8b4313
+      * Create /etc/resolv.conf at postinst, pointing at the stub resolver.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=ef4adf46bbbe2d22508b70b889d23da53b85039d
+      * libnss-resolve: do not disable and stop systemd-resolved
+        File: debian/libnss-resolve.postrm
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=95577d14e84e19b614b83b2e24985d89e8c2dac0
+      * Ignore failures to set Nice priority on services in containers.
+        File: debian/patches/debian/Ubuntu-core-in-execute-soft-fail-setting-Nice-priority-when.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5b8e457f8d883fc6f55d33d46b3474926a495d29
+      * units: set ConditionVirtualization=!private-users on journald audit socket.
+        File: debian/patches/debian/Ubuntu-units-set-ConditionVirtualization-private-users-on-j.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=03ed18a9940731bbf794ad320fabf337488835c6
+      * debian/tests: Enforce udev upgrade.
+        Files:
+        - debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f350b43ccc1aa31c745b4ccebbb4084d5cea41ff
+      * Always setup /etc/resolv.conf on new installations.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=20bc8a37fa3c9620bed21a56a4eabd71db71d861
+      * Ubuntu/extra: ship dhclient-enter hook.
+        Files:
+        - debian/extra/dhclient-enter-resolved-hook
+        - debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f3398a213f80b02bf3db0c1ce9e22d69f6d56764
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=258893bae8cbb12670e4807636fe8f7e9fb5407a
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0725c1169ddde4f41cacba7af3e546704e2206be
+      * Disable systemd-networkd-wait-online by default.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=694473d812b50d2fefd6494d494ca02b91bc8785
+      * postinst: drop empty/stock /etc/rc.local
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e7d071a26a79558771303b0b87f007e650eaebbe
+      * Ship systemd sysctl settings.
+        Files:
+        - debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch
+        - debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=7cd041a6d0ef459e4b2a82d8ea5fa1ce05184dfb
+      * systemd.postinst: enable persistent journal
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f94f18d9dbc085b6a9ff33c141a6e542142f85b5
+      * Disable LLMNR and MulticastDNS by default
+        Files:
+        - debian/patches/debian/UBUNTU-resolved-disable-global-LLMNR-and-MulticastDNS.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4ec428e83696a5cd0405b677a35e97681867629
+      * Add "AssumedApparmorLabel=unconfined" to timedate1 dbus service file
+        File: debian/patches/debian/UBUNTU-Add-AssumedApparmorLabel-unconfined-to-timedate1-dbus.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5ad0879e10bbe3d641f940260b93c7eb2cf4624c
+      * debian/tests/systemd-fsckd: update assertions expectations for v237
+        File: debian/tests/systemd-fsckd
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d5becd9a416b55dcdb7b9a7aba60c4e3d304e6a6
+      * test/test-functions: launch qemu-system with -vga none.
+        File: debian/patches/debian/UBUNTU-test-test-functions-launch-qemu-with-vga-none.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=90af1fa893cce5ed49999d16da0b793da6523394
+      * tests/boot-smoke: ignore udevd connection timeouts resolving colord group.
+        File: debian/tests/boot-smoke
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e1477b764fa9ef23f5181ef3d31a1332191c3e0b
+      * Drop systemd.prerm safety check.
+        File: debian/systemd.prerm
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0244c4d56556317f14eecc2f51871969ef02ba7b
+      * wait-online: do not wait, if no links are managed (neither configured, or failed).
+        File: debian/patches/debian/UBUNTU-wait-online-exit-if-no-links-are-managed.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=31f04c3fc769dacb3cf2a78240a1710a99a865b8
+      * journald.service: set Nice=-1 to dodge watchdog on soft lockups.
+        File: debian/patches/debian/UBUNTU-journald.service-set-Nice-1-to-dodge-watchdog-on-soft-loc.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e0a9aeffac556492bf517ce2d23313ff7a277926
+      * Workaround captive portals not responding to EDNS0 queries (DVE-2018-0001).
+        File: debian/patches/resolved-Mitigate-DVE-2018-0001-by-retrying-NXDOMAIN-with.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=87d3fe81b7281687ecf3c0b9a8356e90cc714d0b
+      * Recommend networkd-dispatcher
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1e3b2c7e4757119da0d550b0b3c0a6626a176dc
+      * networkd: if RA was implicit, do not await ndisc_configured.
+        File: debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2f749ff528d1b788aa4ca778e954c16b213ee629
+      * udev-udeb: ship modprobe.d snippet to force scsi_mod.scan=sync in d-i.
+        Files:
+        - debian/extra/modprobe.d-udeb/scsi-mod-scan-sync.conf
+        - debian/udev-udeb.install
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=eb6d8a2b9504917abb7aa2c4035fdbb7b98227f7
+      * Disable dh_installinit generation of tmpfiles for the systemd package.
+        Files:
+        - debian/rules
+        - debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fd144cbe31cc7a9383cc76f21f4b84c22a9dd1b
+      * Enable EFI/bootctl on armhf.
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=043122f7d8a1487bfd357e815a6ece1ceea6e7d1
+      * boot-and-services: stderr is ok, for status command on the c1 container.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=da14d34e7cc33c44ad67e64c9fd092f8cc1675f9
+      * Skip systemd-fsckd on arm64, because of broken/lack of clean shutdown.
+        File: debian/tests/systemd-fsckd
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=bf5b501ac934497dbef5f64908ff37643dc7288e
+      * adt: boot-and-services: assert any kernel syslog messages.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=29dc34f7a6e5dc505f6212c17c42e4420b47ed16
+      * debian/extra/start-udev: Set scsi_mod scan=sync even if it's builtin to the kernel (we previously only set it in modprobe.d)
+        Files:
+        - debian/extra/start-udev
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6b72628f8de991e2c67ac4289fc74daf3abe7d14
+      * units: conditionalize more units to not start in containers.
+        Files:
+        - debian/patches/debian/UBUNTU-units-block-CAP_SYS_MODULE-units-in-containers-too.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3689afa1a782de8c19a757459b6360de1195ad55
+      * test-sleep: skip test_fiemap upon inapproriate ioctl for device.
+        File: debian/patches/debian/UBUNTU-test-sleep-skip-test_fiemap-upon-inapproriate-ioctl-.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6ebb5b9f6b77760a5470e8a780d69875b1db76f7
+      * Re-add support for /etc/writable for core18
+        File: debian/patches/debian/UBUNTU-Support-system-image-read-only-etc.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=a5b5fca66c1127068e4ce0cc9ab497814211f4f7
+      * debian/control: strengthen dependencies.
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1ecf0c372f5212129c85ae60fddf26b2271a1fe
+      * Improve autopkgtest success rate, by bumping up timeouts
+        File: debian/patches/debian/UBUNTU-bump-selftest-timeouts.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c05586d9da033bbfd6b6a74e10b87520843c7c48
+      * units: Disable journald Watchdog
+        File: debian/patches/debian/UBUNTU-units-disable-journald-watchdog.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=64d2b4f1d0d057073fba585f19823332e2a6eed5
+      * Add conflicts with upstart and systemd-shim
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=83ed7496afc7c27be026014d109855f7d0ad1176
+      * Specify Ubuntu's Vcs-Git
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=fd832930ef280c9a4a9dda2440d5a46a6fdb6232
+      * debian/systemd.postinst: Skip daemon-reexec and try-restarts during shutdown
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=51daab96ae79483b5e5fb62e1e0477c87ee11fd1
+      * Switch gbp.conf to disco.
+        File: debian/gbp.conf
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=fea585b259e3e766d8d3dbc9690e879c054ddc87
+      * core: set /run size to 10%, like initramfs-tools does.
+        File: debian/patches/debian/UBUNTU-core-set-run-size-to-10-like-initramfs-tools-does.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fac2568fe716dc1a41bada78293dc6327a6df0d
+      * core: Revert strict mount namespacing/sandboxing, until LXD allows the needed mounts.
+        File: debian/patches/Revert-namespace-be-more-careful-when-handling-namespacin.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=030919ba5e4931d6ee576d0259fae67fe4ed9770
+      * networkd: [Route] PreferredSource not working in *.network files.
+        Files:
+        - debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4e2ee0b2ac1be2ae78952890a56a2d5398df518
+      * debian/tests: blacklist upstream test-24-unit-tests on ppc64le.
+        File: debian/tests/upstream
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=8062b9a2712c390010d2948eaf764a1b52e68715
+      * debian/control: Update Vcs-{Browser|Git} to Ubuntu's packaging repository
+      * debian/gbp.conf: Set tag format to ubuntu/*
+      * Only test that gdm3 comes up on amd64. Stalls on other arches.
+        File: debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=97cb13685dfb353045c449ec5d6d1df60f661079
+      * Fix false negative checking for running jobs after boot.
+        File: debian/tests/boot-smoke
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=aeb01631efbaf3fe851dee15d496e0b66b5c347f
+      * Cherrypick ask-password: prevent buffer overrow when reading from keyring.
+        File: debian/patches/ask-password-prevent-buffer-overrow-when-reading-fro.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6d6e9cbd4fc6e018031a4762e88f2c3aa19e24e8
+      * Wait for systemctl is-system-running state.
+        File: debian/tests/boot-smoke
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=776998f1f55c445b6e385cab69a4219c42d00838
+      * random-util: eat up bad RDRAND values seen on AMD CPUs.
+        File: debian/patches/+rdrand-workaround-on-amd.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?h=ubuntu-eoan&id=6ab88231efca4b04b26de6cfb5d671be154aabe0
+  * Refresh patches
+  * debian/tests/boot-smoke: Restore exit handling Ubuntu delta lost in 241 merge
+    File: debian/tests/boot-smoke
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3bad1cf23cc91299471542e83c589f2b6237a162
+  * Skip falling back to device name when net_get_name(device) fails.
+    This fixes network-manager and netplan.io autopkgtests
+    File: debian/patches/Skip-falling-back-to-device-name-when-net_get_name-device.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c79fe0e2dc29834e0cd236ade6e4e44a6ffb74fa
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Thu, 12 Sep 2019 10:28:46 +0200
+
 systemd (242-6) unstable; urgency=medium
 
   [ Dan Streetman ]
@@ -510,6 +2116,313 @@ systemd (242-1) experimental; urgency=me
 
  -- Michael Biebl <biebl@debian.org>  Wed, 08 May 2019 01:33:56 +0200
 
+systemd (241-7ubuntu1) eoan; urgency=medium
+
+  * Merge from unstable
+    - Dropped changes:
+      * debian/tests: Switch to gdm
+        Files:
+        - debian/tests/boot-and-services
+        - debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f350b43ccc1aa31c745b4ccebbb4084d5cea41ff
+      * Cherrypick proposed patch to fix LinkLocalAddressing post-unify-MTU settings.
+        File: debian/patches/networkd-honour-LinkLocalAddressing.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=cd9ba0d0f47634c9e5d862b8208cdc3178f25496
+      * Import patches to support PPC64LE qemu based testing.
+        Files:
+        - debian/tests/control
+        - debian/patches/test-test-functions-on-PP64-use-vmlinux.patch
+        - debian/patches/test-test-functions-on-PPC64-use-hvc0-console.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=483a4daba07f809883883e8e8b9c365cfbf7256e
+      * networkd: [Route] PreferredSource not working in *.network files.
+        Files:
+        - debian/patches/Install-routes-after-addresses-are-ready.patch
+        - debian/patches/Move-link_check_ready-to-later-in-the-file.patch
+        - debian/patches/tests-Add-test-for-IPv6-source-routing.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4e2ee0b2ac1be2ae78952890a56a2d5398df518
+      * udevadm: Fix segfault with subsystem-match containing '/' (Closes: #919206)
+        File: debian/patches/udevadm-fix-segfault.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=736973d38676301f276716f22a746aed2489baac
+      * Blacklist TEST-10-ISSUE-2467 #11706
+        File: debian/tests/upstream
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f93b9e46b54388370da7b0cd7f858031be3a2578
+      * Fix comment about why we disable hwclock.service.
+        File: debian/systemd.links
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=8473f88fffdb9db1f5ba547bb692a911997f2569
+      * debian/tests/storage: fix for LUKS2 and avoid interactive password prompts.
+        File: debian/tests/storage
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5594ebf325816e76a8c58043c56fc94f2d52b2a6
+      * d/p/network-remove-routing-policy-rule-from-foreign-rule.patch
+      * d/p/network-do-not-remove-rule-when-it-is-requested-by-e.patch
+        - Fix RoutingPolicyRule does not apply correctly
+      * core: queue jobs on uninstall to generate PropertiesChanged signal.
+        File: debian/patches/core-when-we-uninstall-a-job-add-unit-to-dbus-queue.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=241deca98fb9a0f1ba9a6ba781f738fb31a3bd80
+      * systemd-stable: cherrypick many bugfixes from the v240-stable branch.
+        Files:
+        - debian/patches/Add-missing-dash-to-all-option-in-the-timedatectl-man-pag.patch
+        - debian/patches/Add-note-about-transactions-being-genereated-independentl.patch
+        - debian/patches/Change-job-mode-of-manager-triggered-restarts-to-JOB_REPL.patch
+        - debian/patches/Fix-omission-in-docs.patch
+        - debian/patches/Log-the-job-being-merged.patch
+        - debian/patches/NEWS-document-deprecation-of-PermissionsStartOnly-in-v240.patch
+        - debian/patches/NEWS-retroactively-describe-.include-deprecation.patch
+        - debian/patches/Update-systemd-system.conf.xml.patch
+        - debian/patches/basic-prioq-add-prioq_peek_item.patch
+        - debian/patches/core-Fix-EOPNOTSUPP-emergency-action-error-string.patch
+        - debian/patches/core-Fix-return-argument-check-for-parse_emergency_action.patch
+        - debian/patches/core-mount-do-not-add-Before-local-fs.target-or-remote-fs.patch
+        - debian/patches/core-mount-move-static-function-earlier-in-file.patch
+        - debian/patches/curl-util-fix-use-after-free.patch
+        - debian/patches/ethtool-Make-sure-advertise-is-actually-set-when-autonego.patch
+        - debian/patches/journal-avoid-buffer-overread-when-locale-name-is-too-lon.patch
+        - debian/patches/journal-limit-the-number-of-entries-in-the-cache-based-on.patch
+        - debian/patches/journald-periodically-drop-cache-for-all-dead-PIDs.patch
+        - debian/patches/machinectl-fix-argument-index-in-error-log.patch
+        - debian/patches/man-Fix-a-typo-in-systemd.exec.xml.patch
+        - debian/patches/man-fix-reference.patch
+        - debian/patches/man-fix-volume-num-of-journalctl.patch
+        - debian/patches/man-update-DefaultDependency-in-systemd.mount-5.patch
+        - debian/patches/netlink-set-maximum-size-of-WGDEVICE_A_IFNAME.patch
+        - debian/patches/network-make-Link-and-NetDev-always-have-the-valid-poiter.patch
+        - debian/patches/network-unset-Network-manager-when-loading-.network-file-.patch
+        - debian/patches/network-wireguard-rename-and-split-set_wireguard_interfac.patch
+        - debian/patches/networkd-wait-for-kernel-to-reply-ipv6-peer-address.patch
+        - debian/patches/nspawn-ignore-SIGPIPE-for-nspawn-itself.patch
+        - debian/patches/pager-improve-english-a-bit.patch
+        - debian/patches/pid1-fix-cleanup-of-stale-implicit-deps-based-on-proc-sel.patch
+        - debian/patches/procfs-util-expose-functionality-to-query-total-memory.patch
+        - debian/patches/pull-fix-invalid-error-check.patch
+        - debian/patches/shared-Revert-commit-49fe5c099-in-parts-for-function-pars.patch
+        - debian/patches/shared-dissect-image-make-sure-that-we-don-t-truncate-dev.patch
+        - debian/patches/test-execute-unset-HOME-before-testing.patch
+        - debian/patches/udev-do-logging-before-setting-variables-to-NULL.patch
+        - debian/patches/udev-val-may-be-NULL-use-strempty.patch
+        - debian/patches/udevadm-info-a-should-enumerate-sysfs-attributes-not-envs.patch
+        - debian/patches/udevd-use-worker_free-on-failure-in-worker_new.patch
+        - debian/patches/units-make-sure-initrd-cleanup.service-terminates-before-.patch
+        - debian/patches/wait-online-do-not-fail-if-we-receive-invalid-messages.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2b3db732ba7e5418d45ca42884e8d075189f2724
+      * Cherrypick missing systemd-stable patches to unbreak wireguard peer endpoints.
+        Files:
+        - debian/patches/network-wireguard-fixes-sending-wireguard-peer-setti.patch
+        - debian/patches/network-wireguard-use-sd_netlink_message_append_sock.patch
+        - debian/patches/sd-netlink-introduce-sd_netlink_message_append_socka.patch
+        - debian/patches/test-network-add-more-checks-in-NetworkdNetDevTests..patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=4046f515e40c4dc80d18d2303466737f1f451f11
+      * Cherry-pick patches to fix FTBFS with GCC 9:
+        - d/p/strv-rework-FOREACH_STRING-macro.patch
+        - d/p/test-systemctl-nspawn-use-const-char-instead-of-char-as-i.patch
+    - Remaining changes:
+      * Skip starting systemd-remount-fs.service in containers
+        even when /etc/fstab is present.
+        File: debian/patches/debian/Skip-starting-systemd-remount-fs.service-in-containers.patch
+      * resolved: add support for pipelined requests
+        Files:
+        - debian/patches/llmnr-add-comment-why-we-install-no-complete-handler-on-s.patch
+        - debian/patches/resolved-add-comment-to-dns_stream_complete-about-its-err.patch
+        - debian/patches/resolved-keep-stub-stream-connections-up-for-as-long-as-c.patch
+        - debian/patches/resolved-only-call-complete-with-zero-argument-in-LLMNR-c.patch
+        - debian/patches/resolved-restart-stream-timeout-whenever-we-managed-to-re.patch
+        - debian/patches/stream-follow-coding-style-don-t-use-degrade-to-bool-for-.patch
+        - debian/patches/stream-track-type-of-DnsStream-object.patch
+        - debian/patches/transaction-simplify-handling-if-we-get-an-unexpected-DNS.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=8ad1db08c2135af098a33957ce7cffbe21fb683f
+      * networkd: [Route] PreferredSource not working in *.network files.
+        Files:
+        - debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4e2ee0b2ac1be2ae78952890a56a2d5398df518
+      * virt: detect WSL environment as a container
+        Files:
+        - debian/patches/virt-detect-WSL-environment-as-a-container-id-wsl.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=20b10ce955ad6ddb85c185a13e05a72c3e717f20
+      * pam-systemd: use secure_getenv() rather than getenv()
+        File: debian/patches/pam-systemd-use-secure_getenv-rather-than-getenv.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f3291e9e8c3eafd0c8921cb26a0d5ee0fd563b3c
+      * Set UseDomains to true, by default, on Ubuntu.
+        File: debian/patches/debian/Ubuntu-UseDomains-by-default.patch
+      * Enable systemd-resolved by default
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=05adfa0902115f51c1196ad623165a75bb8b4313
+      * Create /etc/resolv.conf at postinst, pointing at the stub resolver.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=ef4adf46bbbe2d22508b70b889d23da53b85039d
+      * libnss-resolve: do not disable and stop systemd-resolved
+        File: debian/libnss-resolve.postrm
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=95577d14e84e19b614b83b2e24985d89e8c2dac0
+      * Ignore failures to set Nice priority on services in containers.
+        File: debian/patches/debian/Ubuntu-core-in-execute-soft-fail-setting-Nice-priority-when.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5b8e457f8d883fc6f55d33d46b3474926a495d29
+      * units: set ConditionVirtualization=!private-users on journald audit socket.
+        File: debian/patches/debian/Ubuntu-units-set-ConditionVirtualization-private-users-on-j.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=03ed18a9940731bbf794ad320fabf337488835c6
+      * debian/tests: Enforce udev upgrade.
+        Files:
+        - debian/tests/boot-and-services
+        - debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f350b43ccc1aa31c745b4ccebbb4084d5cea41ff
+      * Always setup /etc/resolv.conf on new installations.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=20bc8a37fa3c9620bed21a56a4eabd71db71d861
+      * Ubuntu/extra: ship dhclient-enter hook.
+        Files:
+        - debian/extra/dhclient-enter-resolved-hook
+        - debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f3398a213f80b02bf3db0c1ce9e22d69f6d56764
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=258893bae8cbb12670e4807636fe8f7e9fb5407a
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0725c1169ddde4f41cacba7af3e546704e2206be
+      * Disable systemd-networkd-wait-online by default.
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=694473d812b50d2fefd6494d494ca02b91bc8785
+      * postinst: drop empty/stock /etc/rc.local
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e7d071a26a79558771303b0b87f007e650eaebbe
+      * Ship systemd sysctl settings.
+        Files:
+        - debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch
+        - debian/rules
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=7cd041a6d0ef459e4b2a82d8ea5fa1ce05184dfb
+      * systemd.postinst: enable persistent journal
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f94f18d9dbc085b6a9ff33c141a6e542142f85b5
+      * Disable LLMNR and MulticastDNS by default
+        Files:
+        - debian/patches/debian/UBUNTU-resolved-disable-global-LLMNR-and-MulticastDNS.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4ec428e83696a5cd0405b677a35e97681867629
+      * Add "AssumedApparmorLabel=unconfined" to timedate1 dbus service file
+        File: debian/patches/debian/UBUNTU-Add-AssumedApparmorLabel-unconfined-to-timedate1-dbus.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5ad0879e10bbe3d641f940260b93c7eb2cf4624c
+      * debian/tests/systemd-fsckd: update assertions expectations for v237
+        File: debian/tests/systemd-fsckd
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d5becd9a416b55dcdb7b9a7aba60c4e3d304e6a6
+      * test/test-functions: launch qemu-system with -vga none.
+        File: debian/patches/debian/UBUNTU-test-test-functions-launch-qemu-with-vga-none.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=90af1fa893cce5ed49999d16da0b793da6523394
+      * tests/boot-smoke: ignore udevd connection timeouts resolving colord group.
+        File: debian/tests/boot-smoke
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e1477b764fa9ef23f5181ef3d31a1332191c3e0b
+      * Drop systemd.prerm safety check.
+        File: debian/systemd.prerm
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0244c4d56556317f14eecc2f51871969ef02ba7b
+      * wait-online: do not wait, if no links are managed (neither configured, or failed).
+        File: debian/patches/debian/UBUNTU-wait-online-exit-if-no-links-are-managed.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=31f04c3fc769dacb3cf2a78240a1710a99a865b8
+      * journald.service: set Nice=-1 to dodge watchdog on soft lockups.
+        File: debian/patches/debian/UBUNTU-journald.service-set-Nice-1-to-dodge-watchdog-on-soft-loc.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e0a9aeffac556492bf517ce2d23313ff7a277926
+      * Workaround captive portals not responding to EDNS0 queries (DVE-2018-0001).
+        File: debian/patches/resolved-Mitigate-DVE-2018-0001-by-retrying-NXDOMAIN-with.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=87d3fe81b7281687ecf3c0b9a8356e90cc714d0b
+      * Recommend networkd-dispatcher
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1e3b2c7e4757119da0d550b0b3c0a6626a176dc
+      * networkd: if RA was implicit, do not await ndisc_configured.
+        File: debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2f749ff528d1b788aa4ca778e954c16b213ee629
+      * udev-udeb: ship modprobe.d snippet to force scsi_mod.scan=sync in d-i.
+        Files:
+        - debian/extra/modprobe.d-udeb/scsi-mod-scan-sync.conf
+        - debian/udev-udeb.install
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=eb6d8a2b9504917abb7aa2c4035fdbb7b98227f7
+      * Disable dh_installinit generation of tmpfiles for the systemd package.
+        Files:
+        - debian/rules
+        - debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fd144cbe31cc7a9383cc76f21f4b84c22a9dd1b
+      * Enable EFI/bootctl on armhf.
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=043122f7d8a1487bfd357e815a6ece1ceea6e7d1
+      * boot-and-services: stderr is ok, for status command on the c1 container.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=da14d34e7cc33c44ad67e64c9fd092f8cc1675f9
+      * Skip systemd-fsckd on arm64, because of broken/lack of clean shutdown.
+        File: debian/tests/systemd-fsckd
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=bf5b501ac934497dbef5f64908ff37643dc7288e
+      * adt: boot-and-services: assert any kernel syslog messages.
+        File: debian/tests/boot-and-services
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=29dc34f7a6e5dc505f6212c17c42e4420b47ed16
+      * debian/extra/start-udev: Set scsi_mod scan=sync even if it's builtin to the kernel (we previously only set it in modprobe.d)
+        Files:
+        - debian/extra/start-udev
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6b72628f8de991e2c67ac4289fc74daf3abe7d14
+      * units: conditionalize more units to not start in containers.
+        Files:
+        - debian/patches/debian/UBUNTU-units-block-CAP_SYS_MODULE-units-in-containers-too.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3689afa1a782de8c19a757459b6360de1195ad55
+      * test-sleep: skip test_fiemap upon inapproriate ioctl for device.
+        File: debian/patches/debian/UBUNTU-test-sleep-skip-test_fiemap-upon-inapproriate-ioctl-.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6ebb5b9f6b77760a5470e8a780d69875b1db76f7
+      * Re-add support for /etc/writable for core18
+        File: debian/patches/debian/UBUNTU-Support-system-image-read-only-etc.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=a5b5fca66c1127068e4ce0cc9ab497814211f4f7
+      * debian/control: strengthen dependencies.
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1ecf0c372f5212129c85ae60fddf26b2271a1fe
+      * Improve autopkgtest success rate, by bumping up timeouts
+        File: debian/patches/debian/UBUNTU-bump-selftest-timeouts.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c05586d9da033bbfd6b6a74e10b87520843c7c48
+      * units: Disable journald Watchdog
+        File: debian/patches/debian/UBUNTU-units-disable-journald-watchdog.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=64d2b4f1d0d057073fba585f19823332e2a6eed5
+      * Add conflicts with upstart and systemd-shim
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=83ed7496afc7c27be026014d109855f7d0ad1176
+      * Specify Ubuntu's Vcs-Git
+        File: debian/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=fd832930ef280c9a4a9dda2440d5a46a6fdb6232
+      * debian/systemd.postinst: Skip daemon-reexec and try-restarts during shutdown
+        File: debian/systemd.postinst
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=51daab96ae79483b5e5fb62e1e0477c87ee11fd1
+      * Switch gbp.conf to disco.
+        File: debian/gbp.conf
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=fea585b259e3e766d8d3dbc9690e879c054ddc87
+      * core: set /run size to 10%, like initramfs-tools does.
+        File: debian/patches/debian/UBUNTU-core-set-run-size-to-10-like-initramfs-tools-does.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fac2568fe716dc1a41bada78293dc6327a6df0d
+      * support PPC64LE qemu based testing.
+        Files:
+        - debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=483a4daba07f809883883e8e8b9c365cfbf7256e
+      * core: Revert strict mount namespacing/sandboxing, until LXD allows the needed mounts.
+        File: debian/patches/Revert-namespace-be-more-careful-when-handling-namespacin.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=030919ba5e4931d6ee576d0259fae67fe4ed9770
+      * networkd: [Route] PreferredSource not working in *.network files.
+        Files:
+        - debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4e2ee0b2ac1be2ae78952890a56a2d5398df518
+      * debian/tests: blacklist upstream test-24-unit-tests on ppc64le.
+        File: debian/tests/upstream
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=8062b9a2712c390010d2948eaf764a1b52e68715
+      * debian/control: Update Vcs-{Browser|Git} to Ubuntu's packaging repository
+      * debian/gbp.conf: Set tag format to ubuntu/*
+      * Only test that gdm3 comes up on amd64. Stalls on other arches.
+        File: debian/tests/control
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=97cb13685dfb353045c449ec5d6d1df60f661079
+      * tests/storage: make the test more resilient.
+        File: debian/tests/storage
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c08dcb1ffe372acd3a21496758a1984ff78dcdd4
+      * Fix false negative checking for running jobs after boot.
+        File: debian/tests/boot-smoke
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=aeb01631efbaf3fe851dee15d496e0b66b5c347f
+      * Cherrypick ask-password: prevent buffer overrow when reading from keyring.
+        File: debian/patches/ask-password-prevent-buffer-overrow-when-reading-fro.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6d6e9cbd4fc6e018031a4762e88f2c3aa19e24e8
+      * Wait for cryptsetup unit to start, before stopping.
+        File: debian/tests/storage
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b65aa350be7e61c65927fbc0921a750fcfaa51cd
+      * Wait for systemctl is-system-running state.
+        File: debian/tests/boot-smoke
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=776998f1f55c445b6e385cab69a4219c42d00838
+      * Fix typpo in storage test.
+        File: debian/tests/storage
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f28aa5fe4ab175b99b6ea702559c59ca473b4ca8
+      * random-util: eat up bad RDRAND values seen on AMD CPUs.
+        File: debian/patches/+rdrand-workaround-on-amd.patch
+        https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?h=ubuntu-eoan&id=6ab88231efca4b04b26de6cfb5d671be154aabe0
+  * Refresh patches
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Wed, 28 Aug 2019 17:19:28 +0200
+
 systemd (241-7) unstable; urgency=medium
 
   [ Michael Biebl ]
@@ -685,6 +2598,247 @@ systemd (241-1) unstable; urgency=medium
 
  -- Felipe Sateler <fsateler@debian.org>  Thu, 21 Feb 2019 20:10:15 -0300
 
+systemd (240-6ubuntu13) eoan; urgency=medium
+
+  * Drop s390x seccomp fix causing regression on s390x
+    Files:
+    - debian/patches/src-shared-seccomp-util.c-Add-mmap-definitions-for-s390.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=da95e1d022e94a4d3ce0b69bd6eb398c95d09f24
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Mon, 26 Aug 2019 17:02:54 +0200
+
+systemd (240-6ubuntu12) eoan; urgency=medium
+
+  * Depends on g++-8 as well
+    Files:
+    - debian/control
+    - debian/rules
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5594b4f2ba2a4f68911ecebb5fab4f3cf99a5f30
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 22 Aug 2019 16:41:11 +0100
+
+systemd (240-6ubuntu11) eoan; urgency=medium
+
+  [ Dan Streetman ]
+  * d/p/lp1835581-src-network-networkd-dhcp4.c-set-prefsrc-for-classle.patch:
+    - Set src address for dhcp 'classless' routes (LP: #1835581)
+
+  [ Jorge Niedbalski ]
+  * d/p/lp1668771-resolved-switch-cache-option-to-a-tri-state-option-s.patch:
+    Allows cache=no-negative option to be set, ignoring negative
+    answers to be cached (LP: #1668771).
+
+  [ Jeremy Soller ]
+  * random-util: eat up bad RDRAND values seen on AMD CPUs.
+    This fixes AMD Ryzen 3000 series failing to boot (LP: #1835809)
+
+  [ You-Sheng Yang ]
+  * d/p/d/Revert-udev-network-device-renaming-immediately-give.patch:
+    - udev: drop Revert-udev-network-device-renaming-immediately-give.patch.
+      The removing patch was for the already deprecated
+      "75-persistent-net-generator.rules" based interface renaming mechanism,
+      and it's causing unnecessary problem when a system happends to NICs with
+      same MAC address, e.g. Dell's MAC address pass-thru. (LP: #1837700)
+
+  [ Dimitri John Ledkov ]
+  * Cherrypick seccomp fixes for new kernel and glibc.
+    Files:
+    - debian/patches/seccomp-add-new-5.1-syscall-pidfd_send_signal-to-filter-s.patch
+    - debian/patches/seccomp-add-rseq-to-default-list-of-syscalls-to-whitelist.patch
+    - debian/patches/seccomp-allow-shmat-to-be-a-separate-syscall-on-architect.patch
+    - debian/patches/seccomp-drop-mincore-from-system-service-syscall-filter-g.patch
+    - debian/patches/seccomp-shm-get-at-dt-now-have-their-own-numbers-everywhe.patch
+    - debian/patches/shared-seccomp-add-sync_file_range2.patch
+    - debian/patches/src-shared-seccomp-util.c-Add-mmap-definitions-for-s390.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=627919b0cbcc7e094995f167f8c5eb899f801fd3
+
+  * Build with gcc-8, otherwise tests segfault.
+    Files:
+    - debian/control
+    - debian/rules
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1ca0100244e46b00a97dfa10a5d980de7bdc6735
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 22 Aug 2019 15:03:45 +0100
+
+systemd (240-6ubuntu9) eoan; urgency=medium
+
+  * Fix typpo in storage test.
+    File: debian/tests/storage
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f28aa5fe4ab175b99b6ea702559c59ca473b4ca8
+
+  * Fix bashism
+    File: debian/extra/dhclient-enter-resolved-hook
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0725c1169ddde4f41cacba7af3e546704e2206be
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 30 May 2019 21:45:50 +0100
+
+systemd (240-6ubuntu8) eoan; urgency=medium
+
+  * Only restart resolved on changes in dhclient enter hook.
+    This prevents spurious restarts of resolved on rebounds when
+    the addresses did not change. (LP: #1805183)
+    Author: Julian Andres Klode
+    File: debian/extra/dhclient-enter-resolved-hook
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=258893bae8cbb12670e4807636fe8f7e9fb5407a
+
+  * Wait for cryptsetup unit to start, before stopping.
+    Patch from cascardo. Plus small refactor for readability. (LP: #1814373)
+    File: debian/tests/storage
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b65aa350be7e61c65927fbc0921a750fcfaa51cd
+
+  * Wait for systemctl is-system-running state.
+    File: debian/tests/boot-smoke
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=776998f1f55c445b6e385cab69a4219c42d00838
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 30 May 2019 14:59:04 +0100
+
+systemd (240-6ubuntu7) eoan; urgency=medium
+
+  * Revert "Add check to switch VTs only between K_XLATE or K_UNICODE"
+    This reverts commit 60407728a1a453104e3975ecfdf25a254dd7cc44.
+    Files:
+    - debian/patches/Add-check-to-switch-VTs-only-between-K_XLATE-or-K_UNICODE.patch
+    - debian/patches/Move-verify_vc_kbmode-to-terminal-util.c-as-vt_verify_kbm.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=18029ab5ff436bfb3b401f24cd1e3a4cf2a1579c
+
+  * Cherrypick missing systemd-stable patches to unbreak wireguard peer endpoints.
+    Signed-off-by: Dimitri John Ledkov <xnox@ubuntu.com> (LP: #1825378)
+    Author: Dan Streetman
+    Files:
+    - debian/patches/network-wireguard-fixes-sending-wireguard-peer-setti.patch
+    - debian/patches/network-wireguard-use-sd_netlink_message_append_sock.patch
+    - debian/patches/sd-netlink-introduce-sd_netlink_message_append_socka.patch
+    - debian/patches/test-network-add-more-checks-in-NetworkdNetDevTests..patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=4046f515e40c4dc80d18d2303466737f1f451f11
+
+  * Remove expected failure from passing test.
+    Signed-off-by: Dimitri John Ledkov <xnox@ubuntu.com> (LP: #1829450)
+    Author: Dan Streetman
+    File: debian/tests/systemd-fsckd
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c43b12037d08555dc1d26593307726d7c7992df0
+
+  * Fix false negative checking for running jobs after boot.
+    Signed-off-by: Dimitri John Ledkov <xnox@ubuntu.com> (LP: #1825997)
+    Author: Dan Streetman
+    File: debian/tests/boot-smoke
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=aeb01631efbaf3fe851dee15d496e0b66b5c347f
+
+  * Cherrypick ask-password: prevent buffer overrow when reading from keyring.
+    Signed-off-by: Dimitri John Ledkov <xnox@ubuntu.com> (LP: #1814373)
+    Author: Dan Streetman
+    File: debian/patches/ask-password-prevent-buffer-overrow-when-reading-fro.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6d6e9cbd4fc6e018031a4762e88f2c3aa19e24e8
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 29 May 2019 19:54:37 +0100
+
+systemd (240-6ubuntu6) eoan; urgency=medium
+
+  * Add check to switch VTs only between K_XLATE or K_UNICODE.
+    Switching to K_UNICODE from other than L_XLATE can make the keyboard
+    unusable and possibly leak keypresses from X. (LP: #1803993)
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Thu, 16 May 2019 23:22:15 +0200
+
+systemd (240-6ubuntu5) disco; urgency=medium
+
+  * systemd-stable: cherrypick many bugfixes from the v240-stable branch.
+    Includes many documentation fixes, memory safety (use after free, read
+    overruns, etc), networkd wireguard fixes, POSIX ACL fix which is preventing adm
+    group from reading journals (LP: #1824342), journal dropping caches
+    improvement, fixes regressions in udevadm / machinectl command line parsing.
+    Files:
+    - debian/patches/Add-missing-dash-to-all-option-in-the-timedatectl-man-pag.patch
+    - debian/patches/Add-note-about-transactions-being-genereated-independentl.patch
+    - debian/patches/Change-job-mode-of-manager-triggered-restarts-to-JOB_REPL.patch
+    - debian/patches/Fix-omission-in-docs.patch
+    - debian/patches/Log-the-job-being-merged.patch
+    - debian/patches/NEWS-document-deprecation-of-PermissionsStartOnly-in-v240.patch
+    - debian/patches/NEWS-retroactively-describe-.include-deprecation.patch
+    - debian/patches/Update-systemd-system.conf.xml.patch
+    - debian/patches/basic-prioq-add-prioq_peek_item.patch
+    - debian/patches/core-Fix-EOPNOTSUPP-emergency-action-error-string.patch
+    - debian/patches/core-Fix-return-argument-check-for-parse_emergency_action.patch
+    - debian/patches/core-mount-do-not-add-Before-local-fs.target-or-remote-fs.patch
+    - debian/patches/core-mount-move-static-function-earlier-in-file.patch
+    - debian/patches/curl-util-fix-use-after-free.patch
+    - debian/patches/ethtool-Make-sure-advertise-is-actually-set-when-autonego.patch
+    - debian/patches/journal-avoid-buffer-overread-when-locale-name-is-too-lon.patch
+    - debian/patches/journal-limit-the-number-of-entries-in-the-cache-based-on.patch
+    - debian/patches/journald-periodically-drop-cache-for-all-dead-PIDs.patch
+    - debian/patches/machinectl-fix-argument-index-in-error-log.patch
+    - debian/patches/man-Fix-a-typo-in-systemd.exec.xml.patch
+    - debian/patches/man-fix-reference.patch
+    - debian/patches/man-fix-volume-num-of-journalctl.patch
+    - debian/patches/man-update-DefaultDependency-in-systemd.mount-5.patch
+    - debian/patches/netlink-set-maximum-size-of-WGDEVICE_A_IFNAME.patch
+    - debian/patches/network-make-Link-and-NetDev-always-have-the-valid-poiter.patch
+    - debian/patches/network-unset-Network-manager-when-loading-.network-file-.patch
+    - debian/patches/network-wireguard-rename-and-split-set_wireguard_interfac.patch
+    - debian/patches/networkd-wait-for-kernel-to-reply-ipv6-peer-address.patch
+    - debian/patches/nspawn-ignore-SIGPIPE-for-nspawn-itself.patch
+    - debian/patches/pager-improve-english-a-bit.patch
+    - debian/patches/pid1-fix-cleanup-of-stale-implicit-deps-based-on-proc-sel.patch
+    - debian/patches/procfs-util-expose-functionality-to-query-total-memory.patch
+    - debian/patches/pull-fix-invalid-error-check.patch
+    - debian/patches/shared-Revert-commit-49fe5c099-in-parts-for-function-pars.patch
+    - debian/patches/shared-dissect-image-make-sure-that-we-don-t-truncate-dev.patch
+    - debian/patches/test-execute-unset-HOME-before-testing.patch
+    - debian/patches/udev-do-logging-before-setting-variables-to-NULL.patch
+    - debian/patches/udev-val-may-be-NULL-use-strempty.patch
+    - debian/patches/udevadm-info-a-should-enumerate-sysfs-attributes-not-envs.patch
+    - debian/patches/udevd-use-worker_free-on-failure-in-worker_new.patch
+    - debian/patches/units-make-sure-initrd-cleanup.service-terminates-before-.patch
+    - debian/patches/wait-online-do-not-fail-if-we-receive-invalid-messages.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2b3db732ba7e5418d45ca42884e8d075189f2724
+
+  * Only test that gdm3 comes up on amd64. Stalls on other arches.
+    File: debian/tests/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=97cb13685dfb353045c449ec5d6d1df60f661079
+
+  * tests/storage: make the test more resilient.
+    Skip if the scsi_debug module is not available (like on custom kernels). Do not
+    fail the tests if removing the module fail, at the end of the test run.
+    File: debian/tests/storage
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c08dcb1ffe372acd3a21496758a1984ff78dcdd4
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 11 Apr 2019 14:44:08 +0100
+
+systemd (240-6ubuntu4) disco; urgency=medium
+
+  * pam-systemd: use secure_getenv() rather than getenv()
+    CVE-2019-3842
+    File: debian/patches/pam-systemd-use-secure_getenv-rather-than-getenv.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f3291e9e8c3eafd0c8921cb26a0d5ee0fd563b3c
+
+  * core: queue jobs on uninstall to generate PropertiesChanged signal.
+    (LP: #1816812)
+    File: debian/patches/core-when-we-uninstall-a-job-add-unit-to-dbus-queue.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=241deca98fb9a0f1ba9a6ba781f738fb31a3bd80
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 10 Apr 2019 01:06:03 +0100
+
+systemd (240-6ubuntu3) disco; urgency=medium
+
+  * virt: detect WSL environment as a container (LP: #1816753)
+  * debian/control: Update Vcs-{Browser|Git} to Ubuntu's packaging repository
+  * debian/gbp.conf: Set tag format to ubuntu/*
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Fri, 22 Mar 2019 18:39:48 +0100
+
+systemd (240-6ubuntu2) disco; urgency=medium
+
+  * d/p/network-remove-routing-policy-rule-from-foreign-rule.patch
+  * d/p/network-do-not-remove-rule-when-it-is-requested-by-e.patch
+    - Fix RoutingPolicyRule does not apply correctly (LP: #1818282)
+
+ -- Ioanna Alifieraki <ioanna-marial.alifieraki@canonical.com>  Mon, 04 Mar 2019 10:32:19 +0000
+
+systemd (240-6ubuntu1) disco; urgency=medium
+
+  * Release to ubuntu.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 20 Feb 2019 21:41:03 +0100
+
 systemd (240-6) unstable; urgency=high
 
   * High urgency as this fixes a vulnerability.
@@ -732,6 +2886,113 @@ systemd (240-6) unstable; urgency=high
 
  -- Martin Pitt <mpitt@debian.org>  Mon, 18 Feb 2019 13:54:04 +0000
 
+systemd (240-5ubuntu4) disco; urgency=medium
+
+  * debian/tests/control: add socat to upstream tests for pull #11591
+    File: debian/tests/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=7dff5196e23f50d15c0e0c4cb6742a1cc1cc704a
+
+  * udevadm: Fix segfault with subsystem-match containing '/' (Closes: #919206)
+    Author: Martin Pitt
+    File: debian/patches/udevadm-fix-segfault.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=736973d38676301f276716f22a746aed2489baac
+
+  * Blacklist TEST-10-ISSUE-2467 #11706
+    File: debian/tests/upstream
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f93b9e46b54388370da7b0cd7f858031be3a2578
+
+  * Fix comment about why we disable hwclock.service.
+    Systemd nowadays doesn't do it itself because the kernel does it on its own when necessary,
+    and when not, it is not safe to save the hwclock (eg, there is no certainty the system clock
+    is correct)
+    Author: Felipe Sateler
+    File: debian/systemd.links
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=8473f88fffdb9db1f5ba547bb692a911997f2569
+
+  * udev: Backport upstream preventing mass killings when not running under systemd
+    (Closes: #918764)
+    Author: Felipe Sateler
+    File: debian/patches/udev-check-whether-systemd-is-running-and-do-not-use-cg_k.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=617ee70c31c45ea5d5c6c7b30766d47f0b89446c
+
+  * debian/tests/storage: fix for LUKS2 and avoid interactive password prompts.
+    File: debian/tests/storage
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5594ebf325816e76a8c58043c56fc94f2d52b2a6
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 14 Feb 2019 14:51:37 +0000
+
+systemd (240-5ubuntu3) disco; urgency=medium
+
+  * debian/tests: blacklist upstream test-24-unit-tests on ppc64le.
+    Fails, not a regression as it's a new test case, which was never before
+    executed on ppc64le.
+    File: debian/tests/upstream
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=8062b9a2712c390010d2948eaf764a1b52e68715
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Sat, 02 Feb 2019 11:05:12 +0100
+
+systemd (240-5ubuntu2) disco; urgency=medium
+
+  * core: Revert strict mount namespacing/sandboxing, until LXD allows the needed mounts.
+    (LP: #1813622)
+    File: debian/patches/Revert-namespace-be-more-careful-when-handling-namespacin.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=030919ba5e4931d6ee576d0259fae67fe4ed9770
+
+  * resolved: add support for pipelined requests. (LP: #1811471)
+    Files:
+    - debian/patches/llmnr-add-comment-why-we-install-no-complete-handler-on-s.patch
+    - debian/patches/resolved-add-comment-to-dns_stream_complete-about-its-err.patch
+    - debian/patches/resolved-keep-stub-stream-connections-up-for-as-long-as-c.patch
+    - debian/patches/resolved-only-call-complete-with-zero-argument-in-LLMNR-c.patch
+    - debian/patches/resolved-restart-stream-timeout-whenever-we-managed-to-re.patch
+    - debian/patches/stream-follow-coding-style-don-t-use-degrade-to-bool-for-.patch
+    - debian/patches/stream-track-type-of-DnsStream-object.patch
+    - debian/patches/transaction-simplify-handling-if-we-get-an-unexpected-DNS.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=8ad1db08c2135af098a33957ce7cffbe21fb683f
+
+  * networkd: [Route] PreferredSource not working in *.network files.
+    (LP: #1812760)
+    Files:
+    - debian/patches/Install-routes-after-addresses-are-ready.patch
+    - debian/patches/Move-link_check_ready-to-later-in-the-file.patch
+    - debian/patches/tests-Add-test-for-IPv6-source-routing.patch
+    - debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4e2ee0b2ac1be2ae78952890a56a2d5398df518
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 30 Jan 2019 11:46:53 +0000
+
+systemd (240-5ubuntu1) disco; urgency=medium
+
+  * Reenable pristine-tar in gbp.conf.
+    The pristine-tar bug has been fixed, so we can use it again.
+    This reverts commit 9fcfbbf6fea15eacfa3fad74240431c5f2c3300e.
+    Author: Felipe Sateler
+    File: debian/gbp.conf
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=045998b2a974f9322535fef6018b3c5fff6da342
+
+  * debian/tests/storage: improve cleanups.
+    On fast ppc64el machines, cryptsetup start job may not complete by the time
+    tearDown is executed. In that case stop, causes to simply cancel the start job
+    without actually cleaning up the dmsetup node. This leads to failing subsequent
+    test as it no longer starts with a clean device. Thus ensure the
+    systemd-cryptsetup unit is started, before stopping it.
+    Also rmmod scsi_debug module at the end, to allow re-running the test in a
+    loop.
+    File: debian/tests/storage
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=bfafb0924a59f2a93bcde00fc9eeea5c4d058977
+
+  * d/watch: add version mangle to transform -rc to ~rc.
+    Upstream has started releasing rcs, so let's account for that
+    Author: Felipe Sateler
+    File: debian/watch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=db2dbed693ac75c88ea6ed923537d18d30fc1cdf
+
+  * debian/tests/upstream: Mark TEST-13-NSPAWN-SMOKE as flakey.
+    File: debian/tests/upstream
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=a106d9c60b7b9fc3e16e423ca6a4d376560927cc
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 28 Jan 2019 13:52:58 +0000
+
 systemd (240-5) unstable; urgency=medium
 
   [ Felipe Sateler ]
@@ -742,6 +3003,337 @@ systemd (240-5) unstable; urgency=medium
 
  -- Martin Pitt <mpitt@debian.org>  Sun, 27 Jan 2019 21:33:07 +0000
 
+systemd (240-4ubuntu2) disco; urgency=medium
+
+  * Import patches to support PPC64LE qemu based testing.
+    Files:
+    - debian/tests/control
+    - debian/patches/test-test-functions-on-PP64-use-vmlinux.patch
+    - debian/patches/test-test-functions-on-PPC64-use-hvc0-console.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=483a4daba07f809883883e8e8b9c365cfbf7256e
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 24 Jan 2019 16:55:01 +0000
+
+systemd (240-4ubuntu1) disco; urgency=medium
+
+  * Skip starting systemd-remount-fs.service in containers
+    even when /etc/fstab is present.
+    This allows entering fully running state even when /etc/fstab
+    lists / to be mounted from a device which is not present in the
+    container. (LP: #1576341)
+    Author: Balint Reczey
+    File: debian/patches/debian/Skip-starting-systemd-remount-fs.service-in-containers.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3bde262e129a9d2c60eeff37e63d3da7d58ce5dd
+
+  * Set UseDomains to true, by default, on Ubuntu.
+    On Ubuntu, fallback DNS servers are disabled, therefore we do not leak queries
+    to a preset 3rd party by default. In resolved, dnssec is also disabled by
+    default, as too much of the internet is broken and using Ubuntu users to debug
+    the internet is not very productive - most of the time the end-user cannot fix
+    or know how to notify the site owners about the dnssec mistakes. Inherintally
+    the DHCP acquired DNS servers are therefore trusted, and are free to spoof
+    records. Not trusting DNS search domains, in such scenario, provides limited
+    security or privacy benefits. From user point of view, this also appears to be
+    a regression from previous Ubuntu releases which do trust DHCP acquired search
+    domains by default.
+    Therefore we are enabling UseDomains by default on Ubuntu.
+    Users may override this setting in the .network files by specifying
+    [DHCP|IPv6AcceptRA] UseDomains=no|route options.
+    File: debian/patches/debian/Ubuntu-UseDomains-by-default.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1e5b00cdfd6b9317704e1383d26365a68c041c56
+
+  * Enable systemd-resolved by default
+    File: debian/systemd.postinst
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=05adfa0902115f51c1196ad623165a75bb8b4313
+
+  * Create /etc/resolv.conf at postinst, pointing at the stub resolver.
+    The stub resolver file is dynamically managed by systemd-resolved. It points at
+    the stub resolver as the nameserver, however it also dynamically updates the
+    search stanza, thus non-nss dns tools work correctly with unqualified names and
+    correctly use the DHCP acquired search domains.
+    File: debian/systemd.postinst
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=ef4adf46bbbe2d22508b70b889d23da53b85039d
+
+  * libnss-resolve: do not disable and stop systemd-resolved
+    resolved is always used by default on ubuntu via stub resolver, therefore it
+    should continue to operate without libnss-resolve module installed.
+    File: debian/libnss-resolve.postrm
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=95577d14e84e19b614b83b2e24985d89e8c2dac0
+
+  * Ignore failures to set Nice priority on services in containers.
+    File: debian/patches/debian/Ubuntu-core-in-execute-soft-fail-setting-Nice-priority-when.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5b8e457f8d883fc6f55d33d46b3474926a495d29
+
+  * units: set ConditionVirtualization=!private-users on journald audit socket.
+    It fails to start in unprivileged containers.
+    File: debian/patches/debian/Ubuntu-units-set-ConditionVirtualization-private-users-on-j.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=03ed18a9940731bbf794ad320fabf337488835c6
+
+  * debian/tests: Switch to gdm, enforce udev upgrade.
+    Files:
+    - debian/tests/boot-and-services
+    - debian/tests/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f350b43ccc1aa31c745b4ccebbb4084d5cea41ff
+
+  * Always setup /etc/resolv.conf on new installations.
+    On new installations, /etc/resolv.conf will always exist. Move it to /run
+    and replace it with the desired final symlink. (LP: #1712283)
+    File: debian/systemd.postinst
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=20bc8a37fa3c9620bed21a56a4eabd71db71d861
+
+  * Enable systemd-networkd by default.
+    File: debian/systemd.postinst
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e5ff45174306b17077b907bc25cfd763ac6934f1
+
+  * boot-and-services: skip gdm3 tests when absent, as it is on s390x.
+    Files:
+    - debian/tests/boot-and-services
+    - debian/tests/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=cf05ba013979f53ad69fd2c548ec01c7a5339f64
+
+  * initramfs-tools: trigger udevadm add actions with subsystems first.
+    This updates the initramfs-tools init-top udev script to trigger udevadm
+    actions with type specified. This mimicks the
+    systemd-udev-trigger.service. Without type specified only devices are
+    triggered, but triggering subsystems may also be required and should happen
+    before triggering the devices. This is the case for example on s390x with zdev
+    generated udev rules. (LP: #1713536)
+    File: debian/extra/initramfs-tools/scripts/init-top/udev
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=4016ca5629b6c56b41a4f654e7a808c82e290cac
+
+  * Ubuntu/extra: ship dhclient-enter hook.
+    This allows isc-dhcp dhclient to set search domains and nameservers via
+    resolved.
+    Files:
+    - debian/extra/dhclient-enter-resolved-hook
+    - debian/rules
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f3398a213f80b02bf3db0c1ce9e22d69f6d56764
+
+  * Disable systemd-networkd-wait-online by default.
+    Currently it is not fit for purpose, as it leads to long boot times when
+    networking is unplugged or not yet configured on boot. (LP: #1714301)
+    File: debian/systemd.postinst
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=694473d812b50d2fefd6494d494ca02b91bc8785
+
+  * postinst: drop empty/stock /etc/rc.local (LP: #1716979)
+    File: debian/systemd.postinst
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e7d071a26a79558771303b0b87f007e650eaebbe
+
+  * Improve resolvconf integration.
+    Make the .path|.service unit that feed resolved data into resolvconf not
+    generate failures if resolvconf is not installed.
+    Add a check to make sure that resolved does not read /etc/resolv.conf when that
+    is symlinked to stub-resolv.conf. (LP: #1717995)
+    File: debian/patches/debian/Ubuntu-resolved-resolvconf-integration.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d9f0f89985a141c1588d67e4868ad68cff6956fb
+
+  * Ship systemd sysctl settings.
+    Patch systemd's default sysctl settings to drop things that are set elsewhere
+    already.
+    The promote secondary IP addresses is required for networkd to successfully
+    renew DHCP leases with a change of an IP address.
+    Set default package scheduler to Fair Queue CoDel. (LP: #1721223)
+    Files:
+    - debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch
+    - debian/rules
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=7cd041a6d0ef459e4b2a82d8ea5fa1ce05184dfb
+
+  * resolved.service: set DefaultDependencies=no (LP: #1734167)
+    File: debian/patches/resolved.service-set-DefaultDependencies-no.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=a6ced6331ff7f99704213547a0b94dc06935d508
+
+  * systemd.postinst: enable persistent journal. (LP: #1618188)
+    File: debian/systemd.postinst
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f94f18d9dbc085b6a9ff33c141a6e542142f85b5
+
+  * Disable LLMNR and MulticastDNS by default LP: #1739672
+    Files:
+    - debian/changelog
+    - debian/patches/debian/UBUNTU-resolved-disable-global-LLMNR-and-MulticastDNS.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b4ec428e83696a5cd0405b677a35e97681867629
+
+  * Enable qemu tests on all architectures LP: #1749540
+    Files:
+    - debian/changelog
+    - debian/tests/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b416d1bdfb4f5e33565178e01ba4c4e3939b6176
+
+  * Add "AssumedApparmorLabel=unconfined" to timedate1 dbus service file
+    (LP: #1749000)
+    Author: Michael Vogt
+    File: debian/patches/debian/UBUNTU-Add-AssumedApparmorLabel-unconfined-to-timedate1-dbus.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=5ad0879e10bbe3d641f940260b93c7eb2cf4624c
+
+  * debian/tests/systemd-fsckd: update assertions expectations for v237
+    fsck got rewritten to use "safe_fork" and whilst previously it would ignore the
+    error, when fsck is terminated by signal PIPE, it no longer does so. Thus one
+    should expect systemd-fsck-root.service to have failed in certain test cases.
+    File: debian/tests/systemd-fsckd
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d5becd9a416b55dcdb7b9a7aba60c4e3d304e6a6
+
+  * test/test-functions: launch qemu-system with -vga none.
+    Should resolve booting qemu-system-ppc64 without seabios.
+    File: debian/patches/debian/UBUNTU-test-test-functions-launch-qemu-with-vga-none.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=90af1fa893cce5ed49999d16da0b793da6523394
+
+  * tests/boot-smoke: ignore udevd connection timeouts resolving colord group.
+    File: debian/tests/boot-smoke
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e1477b764fa9ef23f5181ef3d31a1332191c3e0b
+
+  * tests/systemd-fsckd: ignore systemd_fsck_with_plymouth_failure.
+    File: debian/tests/systemd-fsckd
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c392e1ca3da67dbf8a7dfe0dcad470f7636f7405
+
+  * tests/control: ensure boot-smoke uses latest systemd & udev.
+    File: debian/tests/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=b7b66380641755bc21fd7dcbc307760b1d18b8af
+
+  * Drop systemd.prerm safety check.
+    On Ubuntu, systemd is the only choice, and is essential, via init ->
+    systemd-sysv -> systemd dependency chain, thus removing systemd is already
+    quite hard, and appropriate warnings are emitted by dpkg. (LP: #1758438)
+    File: debian/systemd.prerm
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0244c4d56556317f14eecc2f51871969ef02ba7b
+
+  * wait-online: do not wait, if no links are managed (neither configured, or failed).
+    (LP: #1728181)
+    File: debian/patches/debian/UBUNTU-wait-online-exit-if-no-links-are-managed.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=31f04c3fc769dacb3cf2a78240a1710a99a865b8
+
+  * journald.service: set Nice=-1 to dodge watchdog on soft lockups.
+    (LP: #1696970)
+    File: debian/patches/debian/UBUNTU-journald.service-set-Nice-1-to-dodge-watchdog-on-soft-loc.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=e0a9aeffac556492bf517ce2d23313ff7a277926
+
+  * Workaround captive portals not responding to EDNS0 queries (DVE-2018-0001).
+    (LP: #1727237)
+    File: debian/patches/resolved-Mitigate-DVE-2018-0001-by-retrying-NXDOMAIN-with.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=87d3fe81b7281687ecf3c0b9a8356e90cc714d0b
+
+  * Recommend networkd-dispatcher (LP: #1762386)
+    File: debian/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1e3b2c7e4757119da0d550b0b3c0a6626a176dc
+
+  * networkd: if RA was implicit, do not await ndisc_configured.
+    If RA was iplicit, meaning not otherwise requested, and a kernel default was in
+    use. Do not prevent link entering configured state, whilst ndisc configuration
+    is pending. Implicit kernel RA, is expected to be asynchronous and
+    non-blocking. (LP: #1765173)
+    File: debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2f749ff528d1b788aa4ca778e954c16b213ee629
+
+  * udev-udeb: ship modprobe.d snippet to force scsi_mod.scan=sync in d-i.
+    This ensures that all scans are completed, before installer reaches
+    partitioning stage. (LP: #1751813)
+    Files:
+    - debian/extra/modprobe.d-udeb/scsi-mod-scan-sync.conf
+    - debian/udev-udeb.install
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=eb6d8a2b9504917abb7aa2c4035fdbb7b98227f7
+
+  * Disable dh_installinit generation of tmpfiles for the systemd package.
+    Replace with a manual safe call to systemd-tmpfiles which will process any
+    updates to the tmpfiles shipped by systemd package, taking into account any
+    overrides shipped by other packages, sysadmin, or specified in the runtime
+    directories. (LP: #1748147)
+    Files:
+    - debian/rules
+    - debian/systemd.postinst
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fd144cbe31cc7a9383cc76f21f4b84c22a9dd1b
+
+  * Enable EFI/bootctl on armhf.
+    File: debian/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=043122f7d8a1487bfd357e815a6ece1ceea6e7d1
+
+  * boot-and-services: stderr is ok, for status command on the c1 container.
+    systemctl may print warnings on the stderr when checking the status of
+    completed units. This should not, overall fail the autopkgtest run.
+    File: debian/tests/boot-and-services
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=da14d34e7cc33c44ad67e64c9fd092f8cc1675f9
+
+  * Skip systemd-fsckd on arm64, because of broken/lack of clean shutdown.
+    File: debian/tests/systemd-fsckd
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=bf5b501ac934497dbef5f64908ff37643dc7288e
+
+  * adt: boot-and-services: assert any kernel syslog messages.
+    It appears that on arm64 the syslog is truncated and is missing early kernel
+    messages. Print full one, and check for any kernel messages instead.
+    File: debian/tests/boot-and-services
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=29dc34f7a6e5dc505f6212c17c42e4420b47ed16
+
+  * debian/extra/start-udev: Set scsi_mod scan=sync even if it's builtin to the kernel (we previously only set it in modprobe.d) LP: #1779815
+    Files:
+    - debian/changelog
+    - debian/extra/start-udev
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6b72628f8de991e2c67ac4289fc74daf3abe7d14
+
+  * units: conditionalize more units to not start in containers.
+    Files:
+    - debian/changelog
+    - debian/patches/debian/UBUNTU-units-block-CAP_SYS_MODULE-units-in-containers-too.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3689afa1a782de8c19a757459b6360de1195ad55
+
+  * test-sleep: skip test_fiemap upon inapproriate ioctl for device.
+    On v4.4 kernels, on top of btrfs ephemeral lxd v3.0 containers generate this
+    other error code, instead of not supported. Skip the test for both error codes.
+    File: debian/patches/debian/UBUNTU-test-sleep-skip-test_fiemap-upon-inapproriate-ioctl-.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=6ebb5b9f6b77760a5470e8a780d69875b1db76f7
+
+  * Re-add support for /etc/writable for core18. (LP: #1778936)
+    Author: Michael Vogt
+    File: debian/patches/debian/UBUNTU-Support-system-image-read-only-etc.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=a5b5fca66c1127068e4ce0cc9ab497814211f4f7
+
+  * debian/control: strengthen dependencies.
+    Make systemd-sysv depend on matching version of systemd. Autopkgtests at times
+    upgrade systemd-sysv without upgrading systemd. However, upgrading systemd-sysv
+    alone makes little sense.
+    Make systemd conflict, rather than just break, systemd-shim. As there are
+    upgrade failures cause by systemd-shim presence whilst upgrading to new
+    systemd.
+    File: debian/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d1ecf0c372f5212129c85ae60fddf26b2271a1fe
+
+  * Improve autopkgtest success rate, by bumping up timeouts. (LP: #1789841)
+    Author: Christian Ehrhardt
+    File: debian/patches/debian/UBUNTU-bump-selftest-timeouts.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c05586d9da033bbfd6b6a74e10b87520843c7c48
+
+  * units: Disable journald Watchdog (LP: #1773148)
+    File: debian/patches/debian/UBUNTU-units-disable-journald-watchdog.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=64d2b4f1d0d057073fba585f19823332e2a6eed5
+
+  * Add conflicts with upstart and systemd-shim. (LP: #1793092)
+    File: debian/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=83ed7496afc7c27be026014d109855f7d0ad1176
+
+  * Specify Ubuntu's Vcs-Git
+    File: debian/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=fd832930ef280c9a4a9dda2440d5a46a6fdb6232
+
+  * debian/systemd.postinst: Skip daemon-reexec and try-restarts during shutdown
+    (LP: #1803391)
+    Author: Balint Reczey
+    File: debian/systemd.postinst
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=51daab96ae79483b5e5fb62e1e0477c87ee11fd1
+
+  * Switch gbp.conf to disco.
+    File: debian/gbp.conf
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=fea585b259e3e766d8d3dbc9690e879c054ddc87
+
+  * core: set /run size to 10%, like initramfs-tools does.
+    Currently there is a difference between initrd and initrd-less boots,
+    w.r.t. size= mount option of /run. This yields different runtime journald caps
+    (1% vs 10%), and on dense deployments of containers may result in OOM kills.
+    (LP: #1799251)
+    File: debian/patches/debian/UBUNTU-core-set-run-size-to-10-like-initramfs-tools-does.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fac2568fe716dc1a41bada78293dc6327a6df0d
+
+  * Cherrypick proposed patch to fix LinkLocalAddressing post-unify-MTU settings.
+    File: debian/patches/networkd-honour-LinkLocalAddressing.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=cd9ba0d0f47634c9e5d862b8208cdc3178f25496
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 21 Jan 2019 16:09:03 +0000
+
 systemd (240-4) unstable; urgency=medium
 
   [ Benjamin Drung ]
@@ -1033,6 +3625,280 @@ systemd (239-8) unstable; urgency=medium
 
  -- Michael Biebl <biebl@debian.org>  Fri, 07 Sep 2018 08:41:12 +0200
 
+systemd (239-7ubuntu15) disco; urgency=medium
+
+  * core: set /run size to 10%, like initramfs-tools does.
+    Currently there is a difference between initrd and initrd-less boots,
+    w.r.t. size= mount option of /run. This yields different runtime journald caps
+    (1% vs 10%), and on dense deployments of containers may result in OOM kills.
+    (LP: #1799251)
+    File: debian/patches/debian/UBUNTU-core-set-run-size-to-10-like-initramfs-tools-does.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=1fac2568fe716dc1a41bada78293dc6327a6df0d
+
+  * resolved: Increase size of TCP stub replies.
+    DNS_PACKET_PAYLOAD_SIZE_MAX is limiting the size of the stub replies to
+    512 with EDNS off or 4096 with EDNS on, without checking the protocol
+    used. This makes TCP replies for clients without EDNS support to be
+    limited to 512, making the truncate flag useless if the query result is
+    bigger than 512 bytes.
+    This commit increases the size of TCP replies to DNS_PACKET_SIZE_MAX
+    Fixes: #10816
+    (cherry picked from commit e6eed9445956cfa496e1db933bfd3530db23bfce)
+    (LP: #1804487)
+    Author: Victor Tapia
+    File: debian/patches/resolved-Increase-size-of-TCP-stub-replies.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=702a4566174c4d2bd84b70805107cfc1a7c128cc
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Dec 2018 13:49:24 +0000
+
+systemd (239-7ubuntu14) disco; urgency=medium
+
+  * Fix compat with new meson.
+    File: debian/patches/meson-rename-Ddebug-to-Ddebug-extra.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3b764ec1b76768a8c40635019fa5a8acb81b223e
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 29 Nov 2018 16:53:00 +0000
+
+systemd (239-7ubuntu13) disco; urgency=medium
+
+  * Stop testing that gdm3 is up.
+    Ubuntu Desktop is only supported on amd64, and on real hardware. Testing that
+    gdm3 fails to start (yet continues to be running, with a half broken logind
+    session) is not useful on dummy xorg video cards in nested VMs.
+    (LP: #1805358)
+    File: debian/tests/control
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=3006fedda1d1ca3f04c5f593e8018bb6d1196025
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 28 Nov 2018 16:02:25 +0000
+
+systemd (239-7ubuntu12) disco; urgency=medium
+
+  * hwdb: Revert wlan keycode changes, rely on xkeyboard-config fixes instead.
+    (LP: #1799364)
+    Author: seb128
+    File: debian/patches/hwdb-revert-airplane-mode-keys-handling-on-Dell.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=cabc076fdd67ced21fc789e44e0366a2f561a5bc
+
+  * test: Set executable bits on TEST-22-TMPFILES shell scripts. (LP: #1804864)
+    File: debian/patches/test-Set-executable-bits-on-TEST-22-TMPFILES-shell-script.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=0e5b6e44a962f299565949e1006a4ba86d171dc3
+
+  * Switch gbp.conf to disco.
+    File: debian/gbp.conf
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=fea585b259e3e766d8d3dbc9690e879c054ddc87
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 23 Nov 2018 18:38:43 +0000
+
+systemd (239-7ubuntu11) disco; urgency=medium
+
+  * hwdb: Fix wlan keycode for all Dell Latitude and Precision systems
+    (LP: #1799364)
+    Author: Shih-Yuan Lee (FourDollars)
+    File: debian/patches/hwdb-Fix-wlan-keycode-for-all-Dell-Latitude-and-Precision.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=d8ac9a5640be39ede9cebcd8c4cc44e8811e0e49
+
+  * hwdb: Update PNP IDs of Goldstar (now: LG Electronics) (LP: #1804584)
+    File: debian/patches/hwdb-Update-PNP-IDs-of-Goldstar-now-LG-Electronics-.-1005.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=10204fb5761c759be6ddf27dc43c851ef24c96cb
+
+  * btrfs-util: unbreak tmpfiles' subvol creation
+    File: debian/patches/btrfs-util-unbreak-tmpfiles-subvol-creation.patch
+    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=4ab5b8275a0487e301553fb6de6a905abb7ea833
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 22 Nov 2018 16:30:28 +0000
+
+systemd (239-7ubuntu10.4) cosmic-security; urgency=medium
+
+  [ Chris Coulson ]
+  * SECURITY UPDATE: symlink mishandling in systemd-tmpfiles
+    - debian/patches/CVE-2018-6954_2.patch: backport the remaining patches to
+      resolve this completely
+    - CVE-2018-6954
+
+  [ Balint Reczey ]
+  * Fix LP: #1803391 - Skip daemon-reexec and try-restarts during shutdown
+    - update debian/systemd.postinst
+
+ -- Chris Coulson <chris.coulson@canonical.com>  Thu, 15 Nov 2018 20:42:32 +0000
+
+systemd (239-7ubuntu10.3) cosmic-security; urgency=medium
+
+  * SECURITY UPDATE: reexec state injection
+    - debian/patches/CVE-2018-15686.patch: when deserializing state always use
+      read_line(…, LONG_LINE_MAX, …) rather than fgets()
+    - CVE-2018-15686
+  * SECURITY UPDATE: chown_one() can dereference symlinks
+    - debian/patches/CVE-2018-15687.patch: rework recursive logic to use O_PATH
+    - CVE-2018-15687
+
+ -- Chris Coulson <chris.coulson@canonical.com>  Tue, 06 Nov 2018 20:52:41 +0000
+
+systemd (239-7ubuntu10.1) cosmic-security; urgency=medium
+
+  * SECURITY UPDATE: buffer overflow in dhcp6 client
+    - debian/patches/CVE-2018-15688.patch:  make sure we have enough space
+      for the DHCP6 option header in src/libsystemd-network/dhcp6-option.c.
+    - CVE-2018-15688
+
+ -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 31 Oct 2018 11:36:32 -0400
+
+systemd (239-7ubuntu10) cosmic; urgency=medium
+
+  * units: Disable journald Watchdog (LP: #1773148)
+  * Add conflicts with upstart and systemd-shim. (LP: #1773859)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 04 Oct 2018 15:58:51 +0100
+
+systemd (239-7ubuntu9) cosmic; urgency=medium
+
+  * core: export environment when running generators.
+    Ensure that manager's environment (including e.g. PATH) is exported when
+    running generators. Otherwise, one is at a mercy of running without PATH which
+    can lead to buggy generator behaviour. (LP: #1771858)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 26 Sep 2018 11:01:58 +0100
+
+systemd (239-7ubuntu8) cosmic; urgency=medium
+
+  [ Dimitri John Ledkov ]
+  * Cherrypick many bugfixes from master.
+  * systemctl: correctly proceed to immediate shutdown if scheduling fails
+    (LP: #1670291)
+
+  [ Julian Andres Klode ]
+  * Improve networkd states documentation.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 12 Sep 2018 16:03:08 +0100
+
+systemd (239-7ubuntu7) cosmic; urgency=medium
+
+  * boot-and-services: skip gdm test, when gdm-x-session fails.
+    Across all architectures, gdm fails to come up reliably since cosmic.
+    (LP: #1790478)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Sep 2018 16:33:00 +0100
+
+systemd (239-7ubuntu6) cosmic; urgency=medium
+
+  [ Dimitri John Ledkov ]
+  * debian/control: strengthen dependencies.
+    Make systemd-sysv depend on matching version of systemd. Autopkgtests at times
+    upgrade systemd-sysv without upgrading systemd. However, upgrading systemd-sysv
+    alone makes little sense.
+    Make systemd conflict, rather than just break, systemd-shim. As there are
+    upgrade failures cause by systemd-shim presence whilst upgrading to new
+    systemd.
+  * Correct gdm3 exclution on arm64, in boot-and-services test.
+
+  [ Christian Ehrhardt ]
+  * Improve autopkgtest success rate, by bumping up timeouts. (LP: #1789841)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 31 Aug 2018 14:17:54 +0100
+
+systemd (239-7ubuntu5) cosmic; urgency=medium
+
+  [ Michael Biebl ]
+  * Clean up dbus-org.freedesktop.timesync1.service Alias on purge
+    (Closes: #904290)
+
+  [ Martin Pitt ]
+  * timedated: Fix wrong PropertyChanged values and refcounting
+
+  [ Dimitri John Ledkov ]
+  * autopkgtest: drop gdm3 on arm64 as well.
+    The cloud instances are configured without a graphics card, and thus X fails to
+    start, hence the gdm test fails.
+  * Revert "Workaround broken meson copying symlinked data files, as dangling symlinks."
+    This reverts commit 059bfb5349123fabc8c92324e0473193f01fc87c.
+  * Cherrypick v239-stable patches.
+  * cryptsetup: add support for sector-size= option (LP: #1776626)
+  * Cherrypick upstrem patches to fix ftbfs with new glibc.
+
+  [ Michael Vogt ]
+  * Re-add support for /etc/writable for core18. (LP: #1778936)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 28 Aug 2018 17:35:51 +0100
+
+systemd (239-7ubuntu4) cosmic; urgency=medium
+
+  * Workaround broken meson copying symlinked data files, as dangling symlinks.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 22 Aug 2018 14:11:35 +0100
+
+systemd (239-7ubuntu3) cosmic; urgency=medium
+
+  * Revert "networkd: Unify set MTU"
+    This reverts commit 44b598a1c9d11c23420a5ef45ff11bcb0ed195eb due to regression
+    of ignoring LinkLocalAddressing=no.
+    Bug-Upstream: https://github.com/systemd/systemd/issues/9890
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 21 Aug 2018 21:51:31 +0100
+
+systemd (239-7ubuntu2) cosmic; urgency=medium
+
+  * test-sleep: skip test_fiemap upon inapproriate ioctl for device.
+    On v4.4 kernels, on top of btrfs ephemeral lxd v3.0 containers generate this
+    other error code, instead of not supported. Skip the test for both error codes.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 03 Aug 2018 16:49:10 +0100
+
+systemd (239-7ubuntu1) cosmic; urgency=medium
+
+  Merged from Debian Unstable, remaining changes are:
+
+  * Set UseDomains to true, by default, on Ubuntu.
+  * Enable systemd-resolved by default.
+  * postinst: Create /etc/resolv.conf at postinst, pointing at the stub
+    resolver.
+  * postinst: drop empty/stock /etc/rc.local.
+  * postinst: enable persistent journal.
+  * Drop systemd.prerm safety check.
+  * Ship systemd sysctl settings.
+  * libnss-resolve: do not disable and stop systemd-resolved.
+  * boot-smoke: refactor ADT test.
+  * Fix test-functions failing with Ubuntu units.
+  * units: set ConditionVirtualization=!private-users on journald audit socket.
+  * units: drop resolvconf.conf drop-in, resolved integration moved to
+    resolvconf package.
+  * debian/tests: Switch to gdm3, enforce udev upgrade.
+  * Ubuntu/extra: ship dhclient-enter hook.
+  * Ignore failures to set Nice priority on services in containers.
+  * systemd-fsckd: Fix ADT tests to work on s390x too.
+  * Disable LLMNR and MulticastDNS by default.
+  * Enable qemu tests on most architectures.
+  * debian/tests/systemd-fsckd: update assertions expectations for v237.
+  * test/test-fs-util: detect container, in addition to root.
+  * test/test-functions: launch qemu-system with -vga none.
+  * Blacklist TEST-16-EXTEND-TIMEOUT.
+  * tests/boot-smoke: ignore udevd connection timeouts resolving colord group.
+  * tests/systemd-fsckd: ignore systemd_fsck_with_plymouth_failure.
+  * tests/control: ensure boot-smoke uses latest systemd & udev.
+  * wait-online: do not wait, if no links are managed (neither configured, or
+    failed).
+  * journald.service: set Nice=-1 to dodge watchdog on soft lockups.
+  * Workaround captive portals not responding to EDNS0 queries.
+  * resolved: Listen on both TCP and UDP by default.
+  * Recommend networkd-dispatcher
+  * networkd: if RA was implicit, do not await ndisc_configured.
+  * udev-udeb: ship modprobe.d snippet to force scsi_mod.scan=sync in d-i.
+  * Skip starting systemd-remount-fs.service in containers.
+  * Add "AssumedApparmorLabel=unconfined" to timedate1 dbus service file.
+  * Disable dh_installinit generation of tmpfiles for the systemd package.
+    Replace with a manual safe call to systemd-tmpfiles which will process any
+    updates to the tmpfiles shipped by systemd package, taking into account any
+    overrides shipped by other packages, sysadmin, or specified in the runtime
+    directories. (LP: #1748147)
+  * Enable EFI/bootctl on armhf.
+  * boot-and-services: stderr is ok, for status command on the c1 container.
+  * Skip systemd-fsckd on arm64, because of broken/lack of clean shutdown.
+  * adt: boot-and-services: assert any kernel syslog messages.
+  * debian/extra/start-udev: Set scsi_mod scan=sync even if it's builtin to the
+    kernel (we previously only set it in modprobe.d) LP: #1779815
+  * units: conditionalize more units to not start in containers.
+  * tests: conditionalize more unit tests to pass in LXD container.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 26 Jul 2018 16:26:22 +0100
+
 systemd (239-7) unstable; urgency=medium
 
   * autopkgtest: Add iputils-ping dependency to root-unittests.
@@ -1191,6 +4057,83 @@ systemd (239-1) unstable; urgency=medium
 
  -- Michael Biebl <biebl@debian.org>  Sat, 23 Jun 2018 00:18:08 +0200
 
+systemd (238-5ubuntu3) cosmic; urgency=medium
+
+  * debian/extra/start-udev: Set scsi_mod scan=sync even if it's builtin
+    to the kernel (we previously only set it in modprobe.d) LP: #1779815
+
+ -- Adam Conrad <adconrad@ubuntu.com>  Fri, 20 Jul 2018 11:13:58 -0600
+
+systemd (238-5ubuntu2) cosmic; urgency=medium
+
+  * Disable dh_installinit generation of tmpfiles for the systemd package.
+    Replace with a manual safe call to systemd-tmpfiles which will process any
+    updates to the tmpfiles shipped by systemd package, taking into account any
+    overrides shipped by other packages, sysadmin, or specified in the runtime
+    directories. (LP: #1748147)
+  * Re-cherrypick keyring setreuid/setregid tricks, as that was merged post-v238.
+  * Enable EFI/bootctl on armhf.
+  * boot-and-services: stderr is ok, for status command on the c1 container.
+    systemctl may print warnings on the stderr when checking the status of
+    completed units. This should not, overall fail the autopkgtest run.
+
+ -- Dimitri John Ledkov 🌈 <xnox@ubuntu.com>  Tue, 26 Jun 2018 10:55:51 +0100
+
+systemd (238-5ubuntu1) cosmic; urgency=medium
+
+  Merged from Debian Unstable, remaining changes are:
+
+  * Set UseDomains to true, by default, on Ubuntu.
+  * Enable systemd-resolved by default.
+  * postinst: Create /etc/resolv.conf at postinst, pointing at the stub
+    resolver.
+  * postinst: drop empty/stock /etc/rc.local.
+  * postinst: enable persistent journal.
+  * Drop systemd.prerm safety check.
+  * Ship systemd sysctl settings.
+  * libnss-resolve: do not disable and stop systemd-resolved.
+  * boot-smoke: refactor ADT test.
+  * Fix test-functions failing with Ubuntu units.
+  * units: set ConditionVirtualization=!private-users on journald audit socket.
+  * units: drop resolvconf.conf drop-in, resolved integration moved to
+    resolvconf package.
+  * debian/tests: Switch to gdm3, enforce udev upgrade.
+  * Ubuntu/extra: ship dhclient-enter hook.
+  * Ignore failures to set Nice priority on services in containers.
+  * tests: Do not use nested kvm during ADT tests.
+  * systemd-fsckd: Fix ADT tests to work on s390x too.
+  * Disable LLMNR and MulticastDNS by default.
+  * Enable qemu tests on most architectures.
+  * debian/tests/systemd-fsckd: update assertions expectations for v237.
+  * test/test-fs-util: detect container, in addition to root.
+  * test/test-functions: launch qemu-system with -vga none.
+  * Blacklist TEST-16-EXTEND-TIMEOUT.
+  * tests/boot-smoke: ignore udevd connection timeouts resolving colord group.
+  * tests/systemd-fsckd: ignore systemd_fsck_with_plymouth_failure.
+  * tests/control: ensure boot-smoke uses latest systemd & udev.
+  * wait-online: do not wait, if no links are managed (neither configured, or
+    failed).
+  * journald.service: set Nice=-1 to dodge watchdog on soft lockups.
+  * Workaround captive portals not responding to EDNS0 queries.
+  * resolved: Listen on both TCP and UDP by default.
+  * Recommend networkd-dispatcher
+  * networkd: if RA was implicit, do not await ndisc_configured.
+  * udev-udeb: ship modprobe.d snippet to force scsi_mod.scan=sync in d-i.
+  * Skip starting systemd-remount-fs.service in containers.
+  * Add "AssumedApparmorLabel=unconfined" to timedate1 dbus service file.
+
+  * Apply systemd-stable/v238-stable patches.
+
+  * Cherrypick feature to hibernate with disk offsets.
+
+  * Remove dropped patches
+  * Drop merged keyring patch
+  * Drop write_persistent_net_s390x_virtio, as an LTS release was made.
+  * Revert debian/tests/upstream to be more like Debian's.
+  * Do not skip test-execute anymore, should be fixed on armhf now.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 30 May 2018 14:30:45 +0100
+
 systemd (238-5) unstable; urgency=medium
 
   [ Evgeny Vereshchagin ]
@@ -1316,6 +4259,138 @@ systemd (237-4) unstable; urgency=medium
 
  -- Michael Biebl <biebl@debian.org>  Wed, 28 Feb 2018 19:18:34 +0100
 
+systemd (237-3ubuntu11) cosmic; urgency=medium
+
+  [ Dimitri John Ledkov ]
+  * hwdb: Fix wlan/rfkill keycode on Dell systems. (LP: #1762385)
+  * Cherrypick upstream fix for corrected detection of Virtualbox & Xen.
+    (LP: #1768104)
+  * Further improve captive portal workarounds.
+    Retry any NXDOMAIN results with lower feature levels, instead of just those
+    with 'secure' in the domain name. (LP: #1766969)
+  * Bump gbp.conf to cosmic
+
+  [ Michael Biebl ]
+  * Add dependencies of libsystemd-shared to Pre-Depends.
+    This is necessary so systemctl is functional at all times during a
+    dist-upgrade. (Closes: #897986) (LP: #1771791)
+  * basic/macros: Rename noreturn into _noreturn_
+    "noreturn" is reserved and can be used in other header files we include.
+    (Closes: #893426)
+
+  [ Mario Limonciello ]
+  * Fix hibernate disk offsets.
+    Configure resume offset via sysfs, to enable resume from a swapfile.
+    (LP: #1760106)
+
+  [ Felipe Sateler ]
+  * Don't include libmount.h in a header file.
+    Kernel and glibc headers both use MS_* constants, but are not in sync, so
+    only one of them can be used at a time. Thus, only import them where needed
+    Works around #898743
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Sat, 19 May 2018 00:35:30 +0100
+
+systemd (237-3ubuntu10) bionic; urgency=medium
+
+  * Create tmpfiles for persistent journal in postinst only when running
+    systemd (LP: #1748659)
+
+ -- Balint Reczey <rbalint@ubuntu.com>  Fri, 20 Apr 2018 18:55:56 +0200
+
+systemd (237-3ubuntu9) bionic; urgency=medium
+
+  * networkd: if RA was implicit, do not await ndisc_configured.
+    If RA was iplicit, meaning not otherwise requested, and a kernel default was in
+    use. Do not prevent link entering configured state, whilst ndisc configuration
+    is pending. Implicit kernel RA, is expected to be asynchronous and
+    non-blocking. (LP: #1765173)
+  * udev-udeb: ship modprobe.d snippet to force scsi_mod.scan=sync in d-i.
+    This ensures that all scans are completed, before installer reaches
+    partitioning stage. (LP: #1751813)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 20 Apr 2018 04:35:33 +0100
+
+systemd (237-3ubuntu8) bionic; urgency=medium
+
+  * Workaround captive portals not responding to EDNS0 queries (DVE-2018-0001).
+    (LP: #1727237)
+  * resolved: Listen on both TCP and UDP by default. (LP: #1731522)
+  * Recommend networkd-dispatcher (LP: #1762386)
+  * Refresh patches
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 12 Apr 2018 12:12:24 +0100
+
+systemd (237-3ubuntu7) bionic; urgency=medium
+
+  * Introduce suspend then hibernate (LP: #1756006)
+
+ -- Mario Limonciello <mario.limonciello@dell.com>  Mon, 02 Apr 2018 14:25:04 -0500
+
+systemd (237-3ubuntu6) bionic; urgency=medium
+
+  * Adjust the new dropin test, for v237 systemd.
+  * Refresh the keyring patch, to the one merged.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 27 Mar 2018 13:40:09 +0100
+
+systemd (237-3ubuntu5) bionic; urgency=medium
+
+  * Drop old keyring/invocation_id patch, which made keyring setup be skipped in containers.
+  * Use new patch, which sets up session keyring without relying on chown operation.
+  * Drop systemd.prerm safety check.
+    On Ubuntu, systemd is the only choice, and is essential, via init ->
+    systemd-sysv -> systemd dependency chain, thus removing systemd is already
+    quite hard, and appropriate warnings are emitted by dpkg. (LP: #1758438)
+  * Detect Masked unit with drop-ins. (LP: #1752722)
+  * wait-online: do not wait, if no links are managed (neither configured, or failed).
+    (LP: #1728181)
+  * journald.service: set Nice=-1 to dodge watchdog on soft lockups.
+    (LP: #1696970)
+  * Refresh all patches.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 26 Mar 2018 15:55:25 +0100
+
+systemd (237-3ubuntu4) bionic; urgency=medium
+
+  * systemd-sysv-install: fix name initialisation.
+    Only initialise NAME, after --root optional argument has been parsed, otherwise
+    NAME is initialized to e.g. `enable', instead of to the `unit-name`, resulting
+    in failures. (LP: #1752882)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Mar 2018 09:57:58 +0100
+
+systemd (237-3ubuntu3) bionic; urgency=medium
+
+  * tests/control: drop qemu-system-ppc.
+    Whilst some tests pass, many regress / fail to boot. This is not a regression,
+    as qemu-based tests were not run previously.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 20 Feb 2018 17:40:02 +0000
+
+systemd (237-3ubuntu2) bionic; urgency=medium
+
+  * tests/boot-smoke: ignore udevd connection timeouts resolving colord group.
+  * tests/systemd-fsckd: ignore systemd_fsck_with_plymouth_failure.
+  * tests/control: ensure boot-smoke uses latest systemd & udev.
+  * test/test-functions: on PPC64 use hvc0 console.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 20 Feb 2018 12:03:14 +0000
+
+systemd (237-3ubuntu1) bionic; urgency=medium
+
+  [ Gunnar Hjalmarsson ]
+  * Fix PO template creation.
+    Cherry-pick upstream patches to build a correct systemd.pot including
+    the polkit policy files even without policykit-1 being installed.
+    (LP: #1707898)
+
+  [ Dimitri John Ledkov ]
+  * Blacklist TEST-16-EXTEND-TIMEOUT
+  * test/test-functions: use vmlinux for ppc64 tests.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 19 Feb 2018 21:15:23 +0000
+
 systemd (237-3) unstable; urgency=medium
 
   [ Martin Pitt ]
@@ -1338,6 +4413,52 @@ systemd (237-3) unstable; urgency=medium
 
  -- Michael Biebl <biebl@debian.org>  Wed, 14 Feb 2018 23:07:17 +0100
 
+systemd (237-2ubuntu3) bionic; urgency=medium
+
+  * test/test-fs-util: detect container, in addition to root.
+    On armhf, during autopkgtests, whilst root is avilable, full capabilities in
+    parent namespace are not, since the tests are run in an LXD container.
+    This should resolve armhf autopkgtest failure.
+  * test/test-functions: launch qemu-system with -vga none.
+    Should resolve booting qemu-system-ppc64 without seabios.
+  * tests/upstream: skip parts of extend time out tests, regressed.
+    (LP: #1750364)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 19 Feb 2018 13:32:07 +0000
+
+systemd (237-2ubuntu2) bionic; urgency=medium
+
+  * Fix cryptsetup tests by shipping 95-dm-notify udev rule. (LP: #1749432)
+  * debian/tests/systemd-fsckd: update assertions expectations for v237
+    fsck got rewritten to use "safe_fork" and whilst previously it would ignore the
+    error, when fsck is terminated by signal PIPE, it no longer does so. Thus one
+    should expect systemd-fsck-root.service to have failed in certain test cases.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 15 Feb 2018 00:32:54 +0000
+
+systemd (237-2ubuntu1) bionic; urgency=medium
+
+  [ Michael Vogt ]
+  * Add "AssumedApparmorLabel=unconfined" to timedate1 dbus service file
+    (LP: #1749000)
+
+  [ Martin Pitt ]
+  * debian/tests/boot-smoke: More robust journal checking.
+    Also fail the test if calling journalctl fails, and avoid calling it
+    twice. See https://github.com/systemd/systemd/pull/8032
+
+  [ Gunnar Hjalmarsson ]
+  * Fix creation of translation template
+    - State the gettext package domain "systemd" explicitly, as with the
+      move to meson it ended up as "untitled.pot"
+    - Call xgettext to extract strings from polkit *.policy.in files, which
+      intltool-update ignores. (LP: #1707898)
+
+  [ Dimitri John Ledkov ]
+  * Enable qemu tests on all architectures LP: #1749540
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 14 Feb 2018 16:43:12 +0000
+
 systemd (237-2) unstable; urgency=medium
 
   * Drop debian/extra/rules/70-debian-uaccess.rules.
@@ -1350,6 +4471,47 @@ systemd (237-2) unstable; urgency=medium
 
  -- Michael Biebl <biebl@debian.org>  Fri, 09 Feb 2018 23:35:31 +0100
 
+systemd (237-1ubuntu3) bionic; urgency=medium
+
+  * Re-enable gnu-efi on arm64, binutils is fixed
+  * Cherrpick PR8133 to resolve too strict PidFile handling, which breaks
+    services starting with potentially insecure pidfiles e.g. munin
+  * Disable LLMNR and MulticastDNS by default LP: #1739672
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 09 Feb 2018 15:49:01 +0000
+
+systemd (237-1ubuntu2) bionic; urgency=medium
+
+  * Disable gnu-efi on arm64, due to FTBFS. LP: #1746765
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 02 Feb 2018 23:30:05 +0000
+
+systemd (237-1ubuntu1) bionic; urgency=medium
+
+  * Remaining delta from Debian:
+    - ship dhclient enter hook for dhclient integration with resolved
+    - Use stub-resolv.conf as the default provider of /etc/resolv.conf
+    - ship s390x virtio interface names migration
+    - do not disable systemd-resolved upon libnss-resolve removal
+    - do not remount fs in containers, for non-degrated boot
+    - Unlink invocation id key, upon chown failure in containers
+    - Change default to UseDomains by default
+    - Do not treat failure to set Nice= setting as error in containers
+    - Add a condition to systemd-journald-audit.socet to not start in
+      containers (fails)
+    - Build without any built-in/fallback DNS server setting
+    - Enable resolved by default
+    - Update autopkgtests for reliability/raciness, and testing for typical
+      defaults
+    - Always upgrade udev, when running adt tests
+    - Skip test-execute on armhf
+    - Cherry-pick a few testsuite fixes
+    - Do not use nested kvm during ADT tests
+    - Fix ADT systemd-fsckd tests to work on s390x too
+    - Enable persistent journal by default
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 30 Jan 2018 13:52:27 +0000
+
 systemd (237-1) unstable; urgency=medium
 
   * New upstream version 237
@@ -1458,6 +4620,51 @@ systemd (236-1) unstable; urgency=medium
 
  -- Michael Biebl <biebl@debian.org>  Sun, 17 Dec 2017 21:45:51 +0100
 
+systemd (235-3ubuntu3) bionic; urgency=medium
+
+  * netwokrd: add support for RequiredForOnline stanza. (LP: #1737570)
+  * resolved.service: set DefaultDependencies=no (LP: #1734167)
+  * systemd.postinst: enable persistent journal. (LP: #1618188)
+  * core: add support for non-writable unified cgroup hierarchy for container support.
+    (LP: #1734410)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 12 Dec 2017 13:25:32 +0000
+
+systemd (235-3ubuntu2) bionic; urgency=medium
+
+  * systemd-fsckd: Fix ADT tests to work on s390x too.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 21 Nov 2017 16:41:15 +0000
+
+systemd (235-3ubuntu1) bionic; urgency=medium
+
+  * Merge 235-3 from debian:
+    - Drop UBUNTU-CVE-2017-15908 included in Debian.
+
+  * Remaining delta from Debian:
+    - ship dhclient enter hook for dhclient integration with resolved
+    - ship resolvconf integration via stub-resolv.conf
+    - ship s390x virtio interface names migration
+    - do not disable systemd-resolved upon libnss-resolve removal
+    - do not remote fs in containers, for non-degrated boot
+    - CVE-2017-15908 in resolved fix loop on packets with pseudo dns types
+    - Unlink invocation id key, upon chown failure in containers
+    - Change default to UseDomains by default
+    - Do not treat failure to set Nice= setting as error in containers
+    - Add a condition to systemd-journald-audit.socet to not start in
+      containers (fails)
+    - Build without any built-in/fallback DNS server setting
+    - Enable resolved by default
+    - Update autopkgtests for reliability/raciness, and testing for typical
+      defaults
+    - Always upgrade udev, when running adt tests
+    - Skip test-execute on armhf
+    - Cherry-pick a few testsuite fixes
+
+  * UBUNTU Do not use nested kvm during ADT tests.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 21 Nov 2017 09:34:14 +0000
+
 systemd (235-3) unstable; urgency=medium
 
   [ Michael Biebl ]
@@ -1498,6 +4705,63 @@ systemd (235-3) unstable; urgency=medium
 
  -- Martin Pitt <mpitt@debian.org>  Wed, 15 Nov 2017 09:34:00 +0100
 
+systemd (235-2ubuntu3) bionic; urgency=medium
+
+  * Revert "Skip test-bpf in autopkgtest, currently is failing."
+    This reverts commit 75cf986e450e062a3d5780d1976e9efef41e6c4c.
+  * Fix test-bpf test case on ubuntu.
+  * Skip rename tests in containers, crude fix for now.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 13 Nov 2017 00:06:42 +0000
+
+systemd (235-2ubuntu2) bionic; urgency=medium
+
+  * Fix test-functions failing with Ubuntu units.
+  * tests: switch to using ext4 by default, instead of ext3.
+  * Skip test-bpf in autopkgtest, currently is failing.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 06 Nov 2017 18:33:39 +0000
+
+systemd (235-2ubuntu1) bionic; urgency=medium
+
+  [ Dimitri John Ledkov ]
+  * Merge 235-2 from debian:
+    - Drop all upstream cherry-picks
+    - Drop test-copy dh_strip size override, fixed upstream
+
+  * Remaining delta from Debian:
+    - ship dhclient enter hook for dhclient integration with resolved
+    - ship resolvconf integration via stub-resolv.conf
+    - ship s390x virtio interface names migration
+    - do not disable systemd-resolved upon libnss-resolve removal
+    - do not remote fs in containers, for non-degrated boot
+    - CVE-2017-15908 in resolved fix loop on packets with pseudo dns types
+    - Unlink invocation id key, upon chown failure in containers
+    - Change default to UseDomains by default
+    - Do not treat failure to set Nice= setting as error in containers
+    - Add a condition to systemd-journald-audit.socet to not start in
+      containers (fails)
+    - Build without any built-in/fallback DNS server setting
+    - Enable resolved by default
+    - Update autopkgtests for reliability/raciness, and testing for typical
+      defaults
+    - Always upgrade udev, when running adt tests
+    - Skip test-execute on armhf
+
+  * Fix up write_persistent_net_s390x for nullglob
+
+  * Ship systemd sysctl settings.
+    Patch systemd's default sysctl settings to drop things that are set
+    elsewhere already. The promote secondary IP addresses is required for
+    networkd to successfully renew DHCP leases with a change of an IP address.
+    Set default package scheduler to Fair Queue CoDel. (LP: #1721223)
+
+  [ Michael Biebl ]
+  * Install modprobe configuration file to /lib/modprobe.d.
+    Otherwise it is not read by kmod. (Closes: #879191)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 30 Oct 2017 17:20:54 +0000
+
 systemd (235-2) unstable; urgency=medium
 
   * Revert "tests: when running a manager object in a test, migrate to private
@@ -1607,6 +4871,187 @@ systemd (234-2.1) unstable; urgency=high
 
  -- Cyril Brulebois <kibi@debian.org>  Wed, 23 Aug 2017 20:41:33 +0200
 
+systemd (234-2ubuntu12.1) artful-security; urgency=medium
+
+  * SECURITY UPDATE: remote DoS in resolve (LP: #1725351)
+    - debian/patches/CVE-2017-15908.patch: fix loop on packets with pseudo
+      dns types in src/resolve/resolved-dns-packet.c.
+    - CVE-2017-15908
+
+ -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 26 Oct 2017 07:56:42 -0400
+
+systemd (234-2ubuntu12) artful; urgency=medium
+
+  [ Dimitri John Ledkov ]
+  * debian/rules: do not strip test-copy.
+    This insures test-copy is large enough for test-copy tests to pass.
+    (LP: #1721203)
+
+  [ Michael Biebl ]
+  * Drop systemd-timesyncd.service.d/disable-with-time-daemon.conf.
+    All major NTP implementations ship a native service file nowadays with a
+    Conflicts=systemd-timesyncd.service so this drop-in is no longer
+    necessary. (Closes: #873185) (LP: #1721204)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 04 Oct 2017 13:28:34 +0100
+
+systemd (234-2ubuntu11) artful; urgency=medium
+
+  * Ubuntu/extra: ship dhclient-enter hook.
+    This allows isc-dhcp dhclient to set search domains and nameservers via
+    resolved.
+  * Disable systemd-networkd-wait-online by default.
+    Currently it is not fit for purpose, as it leads to long boot times when
+    networking is unplugged or not yet configured on boot. (LP: #1714301)
+  * networkd: change UseMTU default to true.
+    Cherry-pick upstream change. (LP: #1717471)
+  * postinst: drop empty/stock /etc/rc.local (LP: #1716979)
+  * Imporve resolvconf integration.
+    Make the .path|.service unit that feed resolved data into resolvconf not
+    generate failures if resolvconf is not installed.
+    Add a check to make sure that resolved does not read /etc/resolv.conf when that
+    is symlinked to stub-resolv.conf. (LP: #1717995)
+  * core: gracefully bail out keyring operations when chown fails (LP: #1691096)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 26 Sep 2017 11:38:02 -0400
+
+systemd (234-2ubuntu10) artful; urgency=medium
+
+  * Do not fail debootstrap if /etc/resolv.conf is immutable. (LP: #1713212)
+  * Revert "Create /etc/resolv.conf on resolved start, if it is an empty file."
+    As it is ineffective, and correct creation of /etc/resolv.conf has been fixed.
+    This reverts commit ccba42504f216f6ffbc54eb2c9af347355f8d86b.
+  * initramfs-tools: trigger udevadm add actions with subsystems first.
+    This updates the initramfs-tools init-top udev script to trigger udevadm
+    actions with type specified. This mimicks the
+    systemd-udev-trigger.service. Without type specified only devices are
+    triggered, but triggering subsystems may also be required and should happen
+    before triggering the devices. This is the case for example on s390x with zdev
+    generated udev rules. (LP: #1713536)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 30 Aug 2017 11:22:41 +0100
+
+systemd (234-2ubuntu9) artful; urgency=medium
+
+  * boot-and-services: skip gdm3 tests when absent, as it is on s390x.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 23 Aug 2017 11:58:57 +0100
+
+systemd (234-2ubuntu8) artful; urgency=medium
+
+  * Enable systemd-networkd by default.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 22 Aug 2017 17:50:59 +0100
+
+systemd (234-2ubuntu7) artful; urgency=medium
+
+  * Always setup /etc/resolv.conf on new installations.
+    On new installations, /etc/resolv.conf will always exist. Move it to /run
+    and replace it with the desired final symlink. (LP: #1712283)
+  * Create /etc/resolv.conf on resolved start, if it is an empty file.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 22 Aug 2017 16:13:35 +0100
+
+systemd (234-2ubuntu6) artful; urgency=medium
+
+  * Disable KillUserProcesses, yet again, with meson this time.
+  * Re-enable reboot tests.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 17 Aug 2017 15:22:35 +0100
+
+systemd (234-2ubuntu5) artful; urgency=medium
+
+  * debian/tests: disable i386 & amd64 systemd-fsck test, and add environment
+    overrides to allow force execution of those tests locally. LP: #1708051.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 16 Aug 2017 13:04:48 +0100
+
+systemd (234-2ubuntu4) artful; urgency=medium
+
+  * debian/tests: disable i386 & amd64 boot-smoke, passes locally. LP:
+    #1708051.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 15 Aug 2017 14:20:12 +0100
+
+systemd (234-2ubuntu3) artful; urgency=medium
+
+  * debian/tests: Switch to gdm, enforce udev upgrade.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 14 Aug 2017 12:02:37 +0100
+
+systemd (234-2ubuntu2) artful; urgency=medium
+
+  * Ignore failures to set Nice priority on services in containers.
+  * Disable execute test on armhf.
+  * units: set ConditionVirtualization=!private-users on journald audit socket.
+    It fails to start in unprivileged containers.
+  * boot-smoke: refactor ADT test.
+    Wait for system to settle down and get to either running or degraded state,
+    then collect all metrics, and exit with an error if any of the tests failed.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 02 Aug 2017 03:02:03 +0100
+
+systemd (234-2ubuntu1) artful; urgency=medium
+
+  [ Dimitri John Ledkov ]
+  * ubuntu: udev.postinst preserve virtio interfaces names on upgrades, on s390x.
+    New udev generates stable interface names on s390x kvm instances, however, upon
+    upgrades existing ethX names should be preserved to prevent breaking networking
+    and software configurations.
+    This patch only affects Ubuntu systems. (Closes: #860246) (LP: #1682437)
+  * Set UseDomains to true, by default, on Ubuntu.
+    On Ubuntu, fallback DNS servers are disabled, therefore we do not leak queries
+    to a preset 3rd party by default. In resolved, dnssec is also disabled by
+    default, as too much of the internet is broken and using Ubuntu users to debug
+    the internet is not very productive - most of the time the end-user cannot fix
+    or know how to notify the site owners about the dnssec mistakes. Inherintally
+    the DHCP acquired DNS servers are therefore trusted, and are free to spoof
+    records. Not trusting DNS search domains, in such scenario, provides limited
+    security or privacy benefits. From user point of view, this also appears to be
+    a regression from previous Ubuntu releases which do trust DHCP acquired search
+    domains by default.
+    Therefore we are enabling UseDomains by default on Ubuntu.
+    Users may override this setting in the .network files by specifying
+    [DHCP|IPv6AcceptRA] UseDomains=no|route options.
+  * resolved: create private stub resolve file for integration with resolvconf.
+    The stub-resolve.conf file points at resolved stub resolver, but also lists the
+    available search domains. This is required to correctly resolve domains without
+    using resolve nss module.
+  * Enable systemd-resolved by default
+  * Create /etc/resolv.conf at postinst, pointing at the stub resolver.
+    The stub resolver file is dynamically managed by systemd-resolved. It points at
+    the stub resolver as the nameserver, however it also dynamically updates the
+    search stanza, thus non-nss dns tools work correctly with unqualified names and
+    correctly use the DHCP acquired search domains.
+  * libnss-resolve: do not disable and stop systemd-resolved
+    resolved is always used by default on ubuntu via stub resolver, therefore it
+    should continue to operate without libnss-resolve module installed.
+  * modprobe.d: set max_bonds=0 for bonding module to prevent bond0 creation.
+    This prevents confusing networkd, and allows networkd to manage bond0.
+  * Cherrypick upstream networkd-test.py assertion/check fixes.
+    This resolves ADT test suite failures, when running tests under lxc/lxd
+    providers.
+  * Cherrypick arm* seccomp fixes.
+    This should resolve ADT test failures, on arm64, when running as root.
+  * Re-enable seccomp and execute tests on arm.
+
+  [ Balint Reczey ]
+  * Skip starting systemd-remount-fs.service in containers
+    even when /etc/fstab is present.
+    This allows entering fully running state even when /etc/fstab
+    lists / to be mounted from a device which is not present in the
+    container. (LP: #1576341)
+
+  [ Michael Biebl ]
+  * selinux: Enable labeling and access checks for unprivileged users.
+    Revert commit that inadvertently broke a lot of SELinux related
+    functionality for both unprivileged users and systemd instances running
+    as MANAGER_USER and instead deal with the auditd issue by checking for
+    the CAP_AUDIT_WRITE capability before opening an audit netlink socket.
+    (Closes: #863800)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 25 Jul 2017 13:30:58 +0100
+
 systemd (234-2) unstable; urgency=medium
 
   [ Martin Pitt ]
@@ -1627,6 +5072,64 @@ systemd (234-2) unstable; urgency=medium
 
  -- Michael Biebl <biebl@debian.org>  Thu, 20 Jul 2017 15:13:42 +0200
 
+systemd (234-1ubuntu2) artful; urgency=medium
+
+  * Set UseDomains to true, by default, on Ubuntu.
+    On Ubuntu, fallback DNS servers are disabled, therefore we do not leak queries
+    to a preset 3rd party by default. In resolved, dnssec is also disabled by
+    default, as too much of the internet is broken and using Ubuntu users to debug
+    the internet is not very productive - most of the time the end-user cannot fix
+    or know how to notify the site owners about the dnssec mistakes. Inherintally
+    the DHCP acquired DNS servers are therefore trusted, and are free to spoof
+    records. Not trusting DNS search domains, in such scenario, provides limited
+    security or privacy benefits. From user point of view, this also appears to be
+    a regression from previous Ubuntu releases which do trust DHCP acquired search
+    domains by default.
+    Therefore we are enabling UseDomains by default on Ubuntu.
+    Users may override this setting in the .network files by specifying
+    [DHCP|IPv6AcceptRA] UseDomains=no|route options.
+  * resolved: create private stub resolve file for integration with resolvconf.
+    The stub-resolve.conf file points at resolved stub resolver, but also lists the
+    available search domains. This is required to correctly resolve domains without
+    using resolve nss module.
+  * Enable systemd-resolved by default
+  * Create /etc/resolv.conf at postinst, pointing at the stub resolver.
+    The stub resolver file is dynamically managed by systemd-resolved. It points at
+    the stub resolver as the nameserver, however it also dynamically updates the
+    search stanza, thus non-nss dns tools work correctly with unqualified names and
+    correctly use the DHCP acquired search domains.
+  * libnss-resolve: do not disable and stop systemd-resolved
+    resolved is always used by default on ubuntu via stub resolver, therefore it
+    should continue to operate without libnss-resolve module installed.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 21 Jul 2017 17:07:17 +0100
+
+systemd (234-1ubuntu1) artful; urgency=medium
+
+  [ Dimitri John Ledkov ]
+  * Merge with debian, outstanding delta below.
+  * ubuntu: udev.postinst preserve virtio interfaces names on upgrades, on s390x.
+    New udev generates stable interface names on s390x kvm instances, however, upon
+    upgrades existing ethX names should be preserved to prevent breaking networking
+    and software configurations.
+    This patch only affects Ubuntu systems. (Closes: #860246) (LP: #1682437)
+  * debian/tests/root-unittests: disable execute and seccomp tests on arm
+    test-seccomp and test-execute fail on arm64 kernels. Marking both tests as
+    expected failures. An upstream bug report is filed to resolve these.
+    (LP: #1672499)
+  * Disable fallback DNS servers.
+    This causes resolved to call-home to google, attempt to access network when
+    none is available, and spams logs. (LP: #1449001, #1698734)
+
+  [ Balint Reczey ]
+  * Skip starting systemd-remount-fs.service in containers
+    even when /etc/fstab is present.
+    This allows entering fully running state even when /etc/fstab
+    lists / to be mounted from a device which is not present in the
+    container. (LP: #1576341)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 17 Jul 2017 10:59:34 +0100
+
 systemd (234-1) unstable; urgency=medium
 
   [ Michael Biebl ]
@@ -1708,6 +5211,52 @@ systemd (233-9) unstable; urgency=medium
 
  -- Michael Biebl <biebl@debian.org>  Mon, 19 Jun 2017 15:10:14 +0200
 
+systemd (233-8ubuntu2) artful; urgency=medium
+
+  * Disable fallback DNS servers.
+    This causes resolved to call-home to google, attempt to access network when
+    none is available, and spams logs. (LP: #1449001, #1698734)
+  * SECURITY UPDATE: Out-of-bounds write in systemd-resolved.
+    CVE-2017-9445 (LP: #1695546)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 28 Jun 2017 13:27:28 +0100
+
+systemd (233-8ubuntu1) artful; urgency=medium
+
+  Merge from experimental. Existing Ubuntu cherry-picks:
+  * TEST-12: cherry-pick upstream fix for compat with new netcat-openbsd.
+  * networkd: cherry-pick support for setting bridge port's priority.
+    This is a useful feature/bugfix to improve feature parity of networkd with
+    ifupdown. This matches netplan's expectations to be able to set bridge port's
+    priorities via networked. This featue is to be used by netplan/MAAS/OpenStack.
+  * Cherrypick upstream commit to enable system use kernel maximum limit for RLIMIT_NOFILE isntead of hard-coded (low) limit of 65536.
+  * debian/tests/root-unittests: disable execute and seccomp tests on arm
+    test-seccomp and test-execute fail on arm64 kernels. Marking both tests as
+    expected failures. An upstream bug report is filed to resolve these.
+  * Cherrypick upstream patch for vio predictable interface names.
+  * Cherrypick upstream patch for platform predictable interface names.
+
+  Ubuntu cherry-picks, now also applied in Debian:
+  * resolved: fix null pointer dereference crash
+
+  Remaining Ubuntu delta:
+  * ubuntu: udev.postinst preserve virtio interfaces names on upgrades, on s390x.
+    New udev generates stable interface names on s390x kvm instances, however, upon
+    upgrades existing ethX names should be preserved to prevent breaking networking
+    and software configurations.
+    This patch only affects Ubuntu systems.
+  * Skip starting systemd-remount-fs.service in containers
+    even when /etc/fstab is present.
+    This allows entering fully running state even when /etc/fstab
+    lists / to be mounted from a device which is not present in the
+    container.
+
+  New Ubuntu cherry-picks:
+  * loginctl: Chrerry-pick upstream fix to not ignore multiple session ids.
+    (LP: #1682154)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 19 Jun 2017 15:24:30 +0100
+
 systemd (233-8) experimental; urgency=medium
 
   * Bump debhelper compatibility level to 10
@@ -1746,6 +5295,57 @@ systemd (233-7) experimental; urgency=me
 
  -- Michael Biebl <biebl@debian.org>  Wed, 24 May 2017 12:26:18 +0200
 
+systemd (233-6ubuntu3) artful; urgency=medium
+
+  * resolved: fix null pointer dereference crash (LP: #1621396)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 22 May 2017 09:29:22 +0100
+
+systemd (233-6ubuntu2) artful; urgency=medium
+
+  [ Michael Biebl ]
+  * basic/journal-importer: Fix unaligned access in get_data_size()
+    (Closes: #862062)
+
+  [ Dimitri John Ledkov ]
+  * ubuntu: disable dnssec on any ubuntu releases (LP: #1690605)
+  * Cherrypick upstream patch for vio predictable interface names.
+  * Cherrypick upstream patch for platform predictable interface names.
+    (LP: #1686784)
+
+  [ Balint Reczey ]
+  * Skip starting systemd-remount-fs.service in containers
+    even when /etc/fstab is present.
+    This allows entering fully running state even when /etc/fstab
+    lists / to be mounted from a device which is not present in the
+    container. (LP: #1576341)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 17 May 2017 19:24:03 +0100
+
+systemd (233-6ubuntu1) artful; urgency=medium
+
+  Merge from Debian, existing changes:
+  * ubuntu: udev.postinst preserve virtio interfaces names on upgrades, on s390x.
+    New udev generates stable interface names on s390x kvm instances, however, upon
+    upgrades existing ethX names should be preserved to prevent breaking networking
+    and software configurations.
+    This patch only affects Ubuntu systems. (Closes: #860246) (LP: #1682437)
+  * TEST-12: cherry-pick upstream fix for compat with new netcat-openbsd.
+  * networkd: cherry-pick support for setting bridge port's priority.
+    This is a useful feature/bugfix to improve feature parity of networkd with
+    ifupdown. This matches netplan's expectations to be able to set bridge port's
+    priorities via networked. This featue is to be used by netplan/MAAS/OpenStack.
+
+  New changes:
+  * Cherrypick upstream commit to enable system use kernel maximum limit for
+    RLIMIT_NOFILE isntead of hard-coded (low) limit of 65536.  (LP: #1686361)
+  * debian/tests/root-unittests: disable execute and seccomp tests on arm
+    test-seccomp and test-execute fail on arm64 kernels. Marking both tests as
+    expected failures. An upstream bug report is filed to resolve these.
+    (LP: #1672499)
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 02 May 2017 11:23:19 +0100
+
 systemd (233-6) experimental; urgency=medium
 
   [ Felipe Sateler ]
@@ -1786,6 +5386,52 @@ systemd (233-6) experimental; urgency=me
 
  -- Michael Biebl <biebl@debian.org>  Fri, 28 Apr 2017 21:47:14 +0200
 
+systemd (233-5ubuntu1) artful; urgency=medium
+
+  [ Felipe Sateler ]
+  * Backport upstream PR #5531.
+    This delays opening the mdns and llmnr sockets until a network has enabled them.
+    This silences annoying messages when networkd receives such packets without
+    expecting them:
+      Got mDNS UDP packet on unknown scope.
+
+  [ Martin Pitt ]
+  * resolved: Disable DNSSEC by default on stretch and zesty.
+    Both Debian stretch and Ubuntu zesty are close to releasing, switch to
+    DNSSEC=off by default for those. Users can still turn it back on with
+    DNSSEC=allow-downgrade (or even "yes").
+
+  [ Michael Biebl ]
+  * Add Conflicts against hal.
+    Since v183, udev no longer supports RUN+="socket:". This feature is
+    still used by hal, but now generates vast amounts of errors in the
+    journal. Thus force the removal of hal by adding a Conflicts to the udev
+    package. This is safe, as hal is long dead and no longer useful.
+  * Drop systemd-ui Suggests
+    systemd-ui is unmaintained upstream and not particularly useful anymore.
+  * journal: fix up syslog facility when forwarding native messages.
+    Native journal messages (_TRANSPORT=journal) typically don't have a
+    syslog facility attached to it. As a result when forwarding the
+    messages to syslog they ended up with facility 0 (LOG_KERN).
+    Apply syslog_fixup_facility() so we use LOG_USER instead. (Closes: #837893)
+  * Split upstream tests into systemd-tests binary package (Closes: #859152)
+  * Get PACKAGE_VERSION from config.h.
+    This also works with meson and is not autotools specific.
+
+  [ Dimitri John Ledkov ]
+  * ubuntu: udev.postinst preserve virtio interfaces names on upgrades, on s390x.
+    New udev generates stable interface names on s390x kvm instances, however, upon
+    upgrades existing ethX names should be preserved to prevent breaking networking
+    and software configurations.
+    This patch only affects Ubuntu systems. (Closes: #860246) (LP: #1682437)
+  * TEST-12: cherry-pick upstream fix for compat with new netcat-openbsd.
+  * networkd: cherry-pick support for setting bridge port's priority.
+    This is a useful feature/bugfix to improve feature parity of networkd with
+    ifupdown. This matches netplan's expectations to be able to set bridge port's
+    priorities via networked. This featue is to be used by netplan/MAAS/OpenStack.
+
+ -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 21 Apr 2017 14:36:34 +0100
+
 systemd (233-5) experimental; urgency=medium
 
   * Do not throw a warning in emergency and rescue mode if plymouth is not
diff -pruN 245.4-4/debian/control 245.4-4ubuntu3/debian/control
--- 245.4-4/debian/control	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/control	2020-04-22 09:04:26.000000000 +0000
@@ -1,7 +1,8 @@
 Source: systemd
 Section: admin
 Priority: optional
-Maintainer: Debian systemd Maintainers <pkg-systemd-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian systemd Maintainers <pkg-systemd-maintainers@lists.alioth.debian.org>
 Uploaders: Michael Biebl <biebl@debian.org>,
            Marco d'Itri <md@linux.it>,
            Sjoerd Simons <sjoerd@debian.org>,
@@ -9,8 +10,8 @@ Uploaders: Michael Biebl <biebl@debian.o
            Felipe Sateler <fsateler@debian.org>
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
-Vcs-Git: https://salsa.debian.org/systemd-team/systemd.git
-Vcs-Browser: https://salsa.debian.org/systemd-team/systemd
+Vcs-Git: https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd
+Vcs-Browser:  https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd
 Homepage: https://www.freedesktop.org/wiki/Software/systemd
 Build-Depends: debhelper (>= 10.4~),
                pkg-config,
@@ -21,7 +22,7 @@ Build-Depends: debhelper (>= 10.4~),
                meson (>= 0.49),
                gettext,
                gperf,
-               gnu-efi [amd64 i386 arm64],
+               gnu-efi [amd64 i386 arm64 armhf],
                libcap-dev (>= 1:2.24-9~),
                libpam0g-dev,
                libapparmor-dev (>= 2.9.0-3+exp2) <!stage1>,
@@ -45,7 +46,7 @@ Build-Depends: debhelper (>= 10.4~),
                libkmod-dev (>= 15),
                libblkid-dev (>= 2.24),
                libmount-dev (>= 2.30),
-               libseccomp-dev (>= 2.3.1) [amd64 arm64 armel armhf i386 mips mipsel mips64 mips64el x32 powerpc ppc64 ppc64el s390x],
+               libseccomp-dev (>= 2.3.1) [amd64 arm64 armel armhf i386 mips mipsel mips64 mips64el x32 powerpc ppc64 ppc64el riscv64 s390x],
                libdw-dev (>= 0.158) <!stage1>,
                libpolkit-gobject-1-dev <!stage1>,
                linux-base <!nocheck>,
@@ -63,7 +64,8 @@ Architecture: linux-any
 Multi-Arch: foreign
 Section: admin
 Priority: important
-Recommends: dbus
+Recommends: dbus,
+            networkd-dispatcher
 Suggests: systemd-container,
           policykit-1
 Pre-Depends: ${shlibs:Pre-Depends},
@@ -76,6 +78,7 @@ Depends: ${shlibs:Depends},
          mount (>= 2.26),
          adduser,
 Conflicts: consolekit,
+           systemd-shim, upstart,
            libpam-ck-connector,
 Breaks: systemd-shim (<< 10-4~),
         python-dbusmock (<< 0.18),
@@ -106,7 +109,8 @@ Replaces: sysvinit-core,
           upstart (<< 1.13.2-0ubuntu10~),
 Pre-Depends: systemd
 Depends: ${shlibs:Depends},
-         ${misc:Depends}
+         ${misc:Depends},
+         systemd (= ${binary:Version}),
 Recommends: libpam-systemd,
             libnss-systemd
 Description: system and service manager - SysV links
diff -pruN 245.4-4/debian/extra/dhclient-enter-resolved-hook 245.4-4ubuntu3/debian/extra/dhclient-enter-resolved-hook
--- 245.4-4/debian/extra/dhclient-enter-resolved-hook	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/extra/dhclient-enter-resolved-hook	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,83 @@
+#
+# Script fragment to make dhclient supply nameserver information to resolvconf
+#
+
+# Tips:
+# * Be careful about changing the environment since this is sourced
+# * This script fragment uses bash features
+# * As of isc-dhcp-client 4.2 the "reason" (for running the script) can be one of the following.
+#   (Listed on man page:) MEDIUM(0) PREINIT(0)  BOUND(M)  RENEW(M)  REBIND(M)  REBOOT(M)         EXPIRE(D)  FAIL(D) RELEASE(D)  STOP(D) NBI(-) TIMEOUT(M)
+#   (Also used in master script:)                                                                                                                         ARPCHECK(0), ARPSEND(0)
+#   (Also used in master script:)   PREINIT6(0) BOUND6(M) RENEW6(M) REBIND6(M)        DEPREF6(0) EXPIRE6(D)         RELEASE6(D) STOP6(D)
+#   (0) = master script does not run make_resolv_conf
+#   (M) = master script runs make_resolv_conf
+#   (D) = master script downs interface
+#   (-) = master script does nothing with this
+
+if [ -x /lib/systemd/systemd-resolved ] ; then
+        # For safety, first undefine the nasty default make_resolv_conf()
+        make_resolv_conf() { : ; }
+        case "$reason" in
+          BOUND|RENEW|REBIND|REBOOT|TIMEOUT|BOUND6|RENEW6|REBIND6)
+                # Define a resolvconf-compatible m_r_c() function
+                # It gets run later (or, in the TIMEOUT case, MAY get run later)
+          make_resolv_conf() {
+              local statedir
+              if [ ! "$interface" ] ; then
+                  return
+              fi
+              statedir="/run/systemd/resolved.conf.d"
+              mkdir -p $statedir
+
+              oldstate="$(mktemp)"
+              md5sum $statedir/isc-dhcp-v4-$interface.conf $statedir/isc-dhcp-v6-$interface.conf > $oldstate 2> /dev/null
+              if [ -n "$new_domain_name_servers" ] ; then
+                  cat <<EOF >$statedir/isc-dhcp-v4-$interface.conf
+[Resolve]
+DNS=$new_domain_name_servers
+EOF
+                  if [ -n "$new_domain_name" ] || [ -n "$new_domain_search" ] ; then
+                      cat <<EOF >>$statedir/isc-dhcp-v4-$interface.conf
+Domains=$new_domain_search $new_domain_name
+EOF
+                  fi
+              fi
+              if [ -n "$new_dhcp6_name_servers" ] ; then
+                  cat <<EOF >$statedir/isc-dhcp-v6-$interface.conf
+[Resolve]
+DNS=$new_dhcp6_name_servers
+EOF
+                  if [ -n "$new_dhcp6_domain_search" ] ; then
+                      cat <<EOF >>$statedir/isc-dhcp-v6-$interface.conf
+Domains=$new_dhcp6_domain_search
+EOF
+                  fi
+              fi
+
+              newstate="$(mktemp)"
+              md5sum $statedir/isc-dhcp-v4-$interface.conf $statedir/isc-dhcp-v6-$interface.conf > $newstate 2> /dev/null
+              if ! cmp $oldstate $newstate; then
+                  systemctl try-reload-or-restart systemd-resolved.service
+              fi
+
+              rm $oldstate
+              rm $newstate
+          }
+                ;;
+
+          EXPIRE|FAIL|RELEASE|STOP)
+              if [ ! "$interface" ] ; then
+                  return
+              fi
+              rm -f /run/systemd/resolved.conf.d/isc-dhcp-v4-$interface.conf
+              systemctl try-reload-or-restart systemd-resolved.service
+              ;;
+          EXPIRE6|RELEASE6|STOP6)
+              if [ ! "$interface" ] ; then
+                  return
+              fi
+              rm -f /run/systemd/resolved.conf.d/isc-dhcp-v6-$interface.conf
+              systemctl try-reload-or-restart systemd-resolved.service
+              ;;
+        esac
+fi
diff -pruN 245.4-4/debian/extra/modprobe.d-udeb/scsi-mod-scan-sync.conf 245.4-4ubuntu3/debian/extra/modprobe.d-udeb/scsi-mod-scan-sync.conf
--- 245.4-4/debian/extra/modprobe.d-udeb/scsi-mod-scan-sync.conf	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/extra/modprobe.d-udeb/scsi-mod-scan-sync.conf	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,4 @@
+# Use synchronous scanning, to block update-dev in d-i/hw-detect until after the scan is done
+# This ensures that partitioning stage has all the drives detected
+
+options scsi_mod scan=sync
diff -pruN 245.4-4/debian/extra/start-udev 245.4-4ubuntu3/debian/extra/start-udev
--- 245.4-4/debian/extra/start-udev	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/extra/start-udev	2020-04-22 09:04:26.000000000 +0000
@@ -8,6 +8,12 @@ if ! grep -E -q "^[^[:space:]]+ /dev dev
     mount -n -o mode=0755 -t devtmpfs devtmpfs /dev
 fi
 
+# This covers the same case as lib/modprobe.d/scsi-mod-scan-sync.conf
+# in the event that scsi_mod is built in to the kernel, not a module:
+if [ -f /sys/module/scsi_mod/parameters/scan ]; then
+    echo sync > /sys/module/scsi_mod/parameters/scan
+fi
+
 SYSTEMD_LOG_LEVEL=notice /lib/systemd/systemd-udevd --daemon --resolve-names=never
 
 udevadm trigger --action=add
diff -pruN 245.4-4/debian/extra/units/systemd-resolved.service.d/resolvconf.conf 245.4-4ubuntu3/debian/extra/units/systemd-resolved.service.d/resolvconf.conf
--- 245.4-4/debian/extra/units/systemd-resolved.service.d/resolvconf.conf	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/extra/units/systemd-resolved.service.d/resolvconf.conf	1970-01-01 00:00:00.000000000 +0000
@@ -1,8 +0,0 @@
-# tell resolvconf about resolved's builtin DNS server, so that DNS servers
-# picked up via networkd are respected when using resolvconf, and that software
-# like Chrome that does not do NSS (libnss-resolve) still gets proper DNS
-# resolution; do not remove the entry after stop though, as that leads to
-# timeouts on shutdown via the resolvconf hooks (see LP: #1648068)
-[Service]
-ExecStartPost=+/bin/sh -c '[ ! -e /run/resolvconf/enable-updates ] || echo "nameserver 127.0.0.53" | /sbin/resolvconf -a systemd-resolved'
-ReadWritePaths=-/run/resolvconf
diff -pruN 245.4-4/debian/extra/wrap_cl.py 245.4-4ubuntu3/debian/extra/wrap_cl.py
--- 245.4-4/debian/extra/wrap_cl.py	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/extra/wrap_cl.py	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,26 @@
+# Simple changelog entry formatter
+#
+# It simply uses the built in formatter and linewraps the text
+#
+# Use git-dch --customizations=/usr/share/doc/git-buildpackage/examples/wrap_cl.py
+# or set it via gbp.conf
+
+import gbp.dch
+import os
+from itertools import chain
+
+def format_changelog_entry(commit_info, options, last_commit=False):
+    entry = gbp.dch.format_changelog_entry(commit_info, options, last_commit)
+    if not entry:
+        return
+    if commit_info['author'].name != os.environ['DEBFULLNAME']:
+        entry.append(f"Author: {commit_info['author'].name}")
+
+    cfs = [i.decode() for i in chain.from_iterable(commit_info['files'].values()) if i != b'debian/patches/series']
+    if len(cfs) == 1:
+        entry.append(f"File: {cfs[0]}")
+    else:
+        entry.append("Files:")
+        [entry.append(f"- {i}") for i in cfs]
+    entry.append(f"https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id={commit_info['id']}")
+    return entry
diff -pruN 245.4-4/debian/gbp.conf 245.4-4ubuntu3/debian/gbp.conf
--- 245.4-4/debian/gbp.conf	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/gbp.conf	2020-04-22 09:04:26.000000000 +0000
@@ -1,9 +1,11 @@
 [DEFAULT]
 pristine-tar = True
 patch-numbers = False
-debian-branch = debian/master
+debian-branch = ubuntu-focal
+debian-tag = ubuntu/%(version)s
 upstream-branch = upstream/latest
 
 [dch]
 full = True
 multimaint-merge = True
+customizations = debian/extra/wrap_cl.py
diff -pruN 245.4-4/debian/libnss-resolve.postrm 245.4-4ubuntu3/debian/libnss-resolve.postrm
--- 245.4-4/debian/libnss-resolve.postrm	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/libnss-resolve.postrm	2020-04-22 09:04:26.000000000 +0000
@@ -24,10 +24,6 @@ remove_nss_entry() {
 
 if [ "$1" = remove ]; then
     remove_nss_entry /etc/nsswitch.conf libnss-resolve resolve
-    systemctl disable systemd-resolved.service
-    if [ -d /run/systemd/system ]; then
-        deb-systemd-invoke stop systemd-resolved.service || true
-    fi
 fi
 
 #DEBHELPER#
diff -pruN 245.4-4/debian/patches/debian/fsckd-daemon-for-inter-fsckd-communication.patch 245.4-4ubuntu3/debian/patches/debian/fsckd-daemon-for-inter-fsckd-communication.patch
--- 245.4-4/debian/patches/debian/fsckd-daemon-for-inter-fsckd-communication.patch	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/fsckd-daemon-for-inter-fsckd-communication.patch	2020-04-22 09:04:26.000000000 +0000
@@ -1000,7 +1000,7 @@ index 042081c..bea6c16 100644
  
  [Service]
 diff --git a/units/systemd-fsck@.service.in b/units/systemd-fsck@.service.in
-index 3322083..bfa565b 100644
+index 33220835..bfa565b 100644
 --- a/units/systemd-fsck@.service.in
 +++ b/units/systemd-fsck@.service.in
 @@ -13,7 +13,8 @@ Documentation=man:systemd-fsck@.service(8)
diff -pruN 245.4-4/debian/patches/debian/UBUNTU-Add-AssumedApparmorLabel-unconfined-to-timedate1-dbus.patch 245.4-4ubuntu3/debian/patches/debian/UBUNTU-Add-AssumedApparmorLabel-unconfined-to-timedate1-dbus.patch
--- 245.4-4/debian/patches/debian/UBUNTU-Add-AssumedApparmorLabel-unconfined-to-timedate1-dbus.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/UBUNTU-Add-AssumedApparmorLabel-unconfined-to-timedate1-dbus.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,28 @@
+From: Michael Vogt <michael.vogt@ubuntu.com>
+Date: Wed, 14 Feb 2018 16:38:13 +0000
+Subject: Add "AssumedApparmorLabel=unconfined" to timedate1 dbus service file
+
+A change in apparmor mediates auto-activation attempts now through
+AppArmor: https://cgit.freedesktop.org/dbus/dbus/commit/?id=dc25979eb
+
+This breaks the snapd time{zone,server}-control interfaces which limt
+sending dbus message to a (label=unconfined) org.freedesktop.timedate1
+peers.
+
+By adding the AssumedApparmorLabel=unconfined label the snapd interfaces
+work again.
+
+LP: #1749000
+---
+ src/timedate/org.freedesktop.timedate1.service | 1 +
+ 1 file changed, 1 insertion(+)
+
+diff --git a/src/timedate/org.freedesktop.timedate1.service b/src/timedate/org.freedesktop.timedate1.service
+index d5f3a6e..c498b82 100644
+--- a/src/timedate/org.freedesktop.timedate1.service
++++ b/src/timedate/org.freedesktop.timedate1.service
+@@ -12,3 +12,4 @@ Name=org.freedesktop.timedate1
+ Exec=/bin/false
+ User=root
+ SystemdService=dbus-org.freedesktop.timedate1.service
++AssumedAppArmorLabel=unconfined
diff -pruN 245.4-4/debian/patches/debian/Ubuntu-core-in-execute-soft-fail-setting-Nice-priority-when.patch 245.4-4ubuntu3/debian/patches/debian/Ubuntu-core-in-execute-soft-fail-setting-Nice-priority-when.patch
--- 245.4-4/debian/patches/debian/Ubuntu-core-in-execute-soft-fail-setting-Nice-priority-when.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/Ubuntu-core-in-execute-soft-fail-setting-Nice-priority-when.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,29 @@
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Tue, 1 Aug 2017 17:38:05 +0100
+Subject: core: in execute, soft fail setting Nice priority,
+ when permissions are denied
+
+In unpriviledged containers Nice priority setting may not be permitted. Thus
+log and ignore permission failure to set Nice priority in such
+environments. This is similar to how OOMScoreAdjust is treated.
+---
+ src/core/execute.c | 6 +++++-
+ 1 file changed, 5 insertions(+), 1 deletion(-)
+
+diff --git a/src/core/execute.c b/src/core/execute.c
+index 3d50a08..5f88877 100644
+--- a/src/core/execute.c
++++ b/src/core/execute.c
+@@ -3325,7 +3325,11 @@ static int exec_child(
+ 
+         if (context->nice_set) {
+                 r = setpriority_closest(context->nice);
+-                if (r < 0)
++                if (ERRNO_IS_PRIVILEGE(r)) {
++                        log_open();
++                        log_unit_debug_errno(unit, r, "Failed to adjust Nice setting, assuming containerized execution, ignoring: %m");
++                        log_close();
++                } else if (r < 0)
+                         return log_unit_error_errno(unit, r, "Failed to set up process scheduling priority (nice level): %m");
+         }
+ 
diff -pruN 245.4-4/debian/patches/debian/UBUNTU-core-set-run-size-to-10-like-initramfs-tools-does.patch 245.4-4ubuntu3/debian/patches/debian/UBUNTU-core-set-run-size-to-10-like-initramfs-tools-does.patch
--- 245.4-4/debian/patches/debian/UBUNTU-core-set-run-size-to-10-like-initramfs-tools-does.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/UBUNTU-core-set-run-size-to-10-like-initramfs-tools-does.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,30 @@
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Mon, 3 Dec 2018 12:31:20 +0000
+Subject: core: set /run size to 10%, like initramfs-tools does.
+
+Currently there is a difference between initrd and initrd-less boots,
+w.r.t. size= mount option of /run. This yields different runtime journald caps
+(1% vs 10%), and on dense deployments of containers may result in OOM kills.
+
+LP: #1799251
+---
+ src/core/mount-setup.c | 4 ++--
+ 1 file changed, 2 insertions(+), 2 deletions(-)
+
+diff --git a/src/core/mount-setup.c b/src/core/mount-setup.c
+index d528a4c..c3cd0f9 100644
+--- a/src/core/mount-setup.c
++++ b/src/core/mount-setup.c
+@@ -79,10 +79,10 @@ static const MountPoint mount_table[] = {
+         { "devpts",      "/dev/pts",                  "devpts",     "mode=620,gid=" STRINGIFY(TTY_GID), MS_NOSUID|MS_NOEXEC,
+           NULL,          MNT_IN_CONTAINER           },
+ #if ENABLE_SMACK
+-        { "tmpfs",       "/run",                      "tmpfs",      "mode=755,smackfsroot=*",  MS_NOSUID|MS_NODEV|MS_STRICTATIME,
++        { "tmpfs",       "/run",                      "tmpfs",      "mode=755,size=10%,smackfsroot=*",  MS_NOSUID|MS_NODEV|MS_STRICTATIME,
+           mac_smack_use, MNT_FATAL                  },
+ #endif
+-        { "tmpfs",       "/run",                      "tmpfs",      "mode=755",                MS_NOSUID|MS_NODEV|MS_STRICTATIME,
++        { "tmpfs",       "/run",                      "tmpfs",      "mode=755,size=10%",                MS_NOSUID|MS_NODEV|MS_STRICTATIME,
+           NULL,          MNT_FATAL|MNT_IN_CONTAINER },
+         { "tmpfs",       "/run/lock",                 "tmpfs",      "mode=1777,size=5242880",  MS_NOSUID|MS_NODEV|MS_NOEXEC,
+           NULL,          MNT_FATAL|MNT_IN_CONTAINER },
diff -pruN 245.4-4/debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch 245.4-4ubuntu3/debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch
--- 245.4-4/debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,51 @@
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Wed, 11 Oct 2017 12:17:03 +0100
+Subject: UBUNTU: drop unrelated settings from sysctl defaults shipped by
+ systemd.
+
+---
+ sysctl.d/50-default.conf | 24 ------------------------
+ 1 file changed, 24 deletions(-)
+
+diff --git a/sysctl.d/50-default.conf b/sysctl.d/50-default.conf
+index 14378b2..a830167 100644
+--- a/sysctl.d/50-default.conf
++++ b/sysctl.d/50-default.conf
+@@ -11,26 +11,6 @@
+ # (e.g. /etc/sysctl.d/90-override.conf), and put any assignments
+ # there.
+ 
+-# System Request functionality of the kernel (SYNC)
+-#
+-# Use kernel.sysrq = 1 to allow all keys.
+-# See https://www.kernel.org/doc/html/latest/admin-guide/sysrq.html for a list
+-# of values and keys.
+-kernel.sysrq = 16
+-
+-# Append the PID to the core filename
+-kernel.core_uses_pid = 1
+-
+-# Source route verification
+-net.ipv4.conf.default.rp_filter = 2
+-net.ipv4.conf.*.rp_filter = 2
+--net.ipv4.conf.all.rp_filter
+-
+-# Do not accept source routing
+-net.ipv4.conf.default.accept_source_route = 0
+-net.ipv4.conf.*.accept_source_route = 0
+--net.ipv4.conf.all.accept_source_route
+-
+ # Promote secondary addresses when the primary address is removed
+ net.ipv4.conf.default.promote_secondaries = 1
+ net.ipv4.conf.*.promote_secondaries = 1
+@@ -47,10 +27,6 @@ net.ipv4.conf.*.promote_secondaries = 1
+ # Fair Queue CoDel packet scheduler to fight bufferbloat
+ net.core.default_qdisc = fq_codel
+ 
+-# Enable hard and soft link protection
+-fs.protected_hardlinks = 1
+-fs.protected_symlinks = 1
+-
+ # Enable regular file and FIFO protection
+ fs.protected_regular = 1
+ fs.protected_fifos = 1
diff -pruN 245.4-4/debian/patches/debian/UBUNTU-journald.service-set-Nice-1-to-dodge-watchdog-on-soft-loc.patch 245.4-4ubuntu3/debian/patches/debian/UBUNTU-journald.service-set-Nice-1-to-dodge-watchdog-on-soft-loc.patch
--- 245.4-4/debian/patches/debian/UBUNTU-journald.service-set-Nice-1-to-dodge-watchdog-on-soft-loc.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/UBUNTU-journald.service-set-Nice-1-to-dodge-watchdog-on-soft-loc.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,22 @@
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Mon, 26 Mar 2018 13:41:15 +0100
+Subject: journald.service: set Nice=-1 to dodge watchdog on soft lockups.
+
+LP: #1696970
+(cherry picked from commit c5b77c35b4ec0e1812702240f272fbeea3ad4152)
+---
+ units/systemd-journald.service.in | 1 +
+ 1 file changed, 1 insertion(+)
+
+diff --git a/units/systemd-journald.service.in b/units/systemd-journald.service.in
+index 5144868..804fb7d 100644
+--- a/units/systemd-journald.service.in
++++ b/units/systemd-journald.service.in
+@@ -27,6 +27,7 @@ NoNewPrivileges=yes
+ OOMScoreAdjust=-250
+ Restart=always
+ RestartSec=0
++Nice=-1
+ RestrictAddressFamilies=AF_UNIX AF_NETLINK
+ RestrictNamespaces=yes
+ RestrictRealtime=yes
diff -pruN 245.4-4/debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch 245.4-4ubuntu3/debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
--- 245.4-4/debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,66 @@
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Fri, 20 Apr 2018 03:24:13 +0100
+Subject: UBUNTU: networkd: if RA was implicit, do not await ndisc_configured.
+
+If RA was iplicit, meaning not otherwise requested, and a kernel default was in
+use. Do not prevent link entering configured state, whilst ndisc configuration
+is pending. Implicit kernel RA, is expected to be asynchronous and
+non-blocking.
+
+LP: #1765173
+(cherry picked from commit 4b784890d000aab33a36f95e565469d5b76e6cbf)
+---
+ src/network/networkd-link.c | 17 +++++++++++++----
+ 1 file changed, 13 insertions(+), 4 deletions(-)
+
+diff --git a/src/network/networkd-link.c b/src/network/networkd-link.c
+index b281e05..ce5ea89 100644
+--- a/src/network/networkd-link.c
++++ b/src/network/networkd-link.c
+@@ -260,7 +260,7 @@ static bool link_proxy_arp_enabled(Link *link) {
+         return true;
+ }
+ 
+-static bool link_ipv6_accept_ra_enabled(Link *link) {
++static bool link_ipv6_accept_ra_enabled_implicit(Link *link, bool * implicit) {
+         assert(link);
+ 
+         if (!socket_ipv6_is_supported())
+@@ -279,9 +279,12 @@ static bool link_ipv6_accept_ra_enabled(Link *link) {
+          * disabled if local forwarding is enabled).
+          * If set, ignore or enforce RA independent of local forwarding state.
+          */
+-        if (link->network->ipv6_accept_ra < 0)
++        if (link->network->ipv6_accept_ra < 0) {
+                 /* default to accept RA if ip_forward is disabled and ignore RA if ip_forward is enabled */
++                if (implicit)
++                        *implicit = true;
+                 return !link_ipv6_forward_enabled(link);
++        }
+         else if (link->network->ipv6_accept_ra > 0)
+                 /* accept RA even if ip_forward is enabled */
+                 return true;
+@@ -290,6 +293,10 @@ static bool link_ipv6_accept_ra_enabled(Link *link) {
+                 return false;
+ }
+ 
++static bool link_ipv6_accept_ra_enabled(Link *link) {
++        return link_ipv6_accept_ra_enabled_implicit(link, NULL);
++}
++
+ static IPv6PrivacyExtensions link_ipv6_privacy_extensions(Link *link) {
+         assert(link);
+ 
+@@ -1136,8 +1143,10 @@ void link_check_ready(Link *link) {
+                          * an IPv4ll fallback address must be configured. */
+                         return;
+ 
+-                if (link_ipv6_accept_ra_enabled(link) && !link->ndisc_configured)
+-                        return;
++                 bool implicit = false;
++                 if (link_ipv6_accept_ra_enabled_implicit(link, &implicit) && !link->ndisc_configured)
++                         if (!implicit)
++                                 return;
+         }
+ 
+         if (link->state != LINK_STATE_CONFIGURED)
diff -pruN 245.4-4/debian/patches/debian/UBUNTU-resolved-default-no-negative-caching.patch 245.4-4ubuntu3/debian/patches/debian/UBUNTU-resolved-default-no-negative-caching.patch
--- 245.4-4/debian/patches/debian/UBUNTU-resolved-default-no-negative-caching.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/UBUNTU-resolved-default-no-negative-caching.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,55 @@
+From: Balint Reczey <balint.reczey@canonical.com>
+Date: Wed, 11 Dec 2019 22:01:13 +0100
+Subject: systemd-resolved: Default to Cache=no-negative
+
+Thanks: Dimitri John Ledkov for the suggestion
+---
+ man/resolved.conf.xml            | 4 ++--
+ src/resolve/resolved-gperf.gperf | 2 +-
+ src/resolve/resolved-manager.c   | 2 +-
+ 3 files changed, 4 insertions(+), 4 deletions(-)
+
+diff --git a/man/resolved.conf.xml b/man/resolved.conf.xml
+index 0f70ced..b112a0c 100644
+--- a/man/resolved.conf.xml
++++ b/man/resolved.conf.xml
+@@ -231,11 +231,11 @@
+ 
+       <varlistentry>
+         <term><varname>Cache=</varname></term>
+-        <listitem><para>Takes a boolean or <literal>no-negative</literal> as argument. If <literal>yes</literal> (the default), resolving a domain name
++        <listitem><para>Takes a boolean or <literal>no-negative</literal> as argument. If <literal>yes</literal>, resolving a domain name
+         which already got queried earlier will return the previous result as long as it is still valid, and thus does
+         not result in a new network request. Be aware that turning off caching comes at a performance penalty, which
+         is particularly high when DNSSEC is used.</para>
+-        If <literal>no-negative</literal>, only positive answers are cached.
++        If <literal>no-negative</literal> (the default), only positive answers are cached.
+ 
+         <para>Note that caching is turned off implicitly if the configured DNS server is on a host-local IP address
+         (such as 127.0.0.1 or ::1), in order to avoid duplicate local caching.</para></listitem>
+diff --git a/src/resolve/resolved-gperf.gperf b/src/resolve/resolved-gperf.gperf
+index 049fe9e..5db0b2a 100644
+--- a/src/resolve/resolved-gperf.gperf
++++ b/src/resolve/resolved-gperf.gperf
+@@ -24,6 +24,6 @@ Resolve.LLMNR,           config_parse_resolve_support,        0,
+ Resolve.MulticastDNS,    config_parse_resolve_support,        0,                   offsetof(Manager, mdns_support)
+ Resolve.DNSSEC,          config_parse_dnssec_mode,            0,                   offsetof(Manager, dnssec_mode)
+ Resolve.DNSOverTLS,      config_parse_dns_over_tls_mode,      0,                   offsetof(Manager, dns_over_tls_mode)
+-Resolve.Cache,           config_parse_dns_cache_mode,         DNS_CACHE_MODE_YES,  offsetof(Manager, enable_cache)
++Resolve.Cache,           config_parse_dns_cache_mode,         DNS_CACHE_MODE_NO_NEGATIVE,  offsetof(Manager, enable_cache)
+ Resolve.DNSStubListener, config_parse_dns_stub_listener_mode, 0,                   offsetof(Manager, dns_stub_listener_mode)
+ Resolve.ReadEtcHosts,    config_parse_bool,                   0,                   offsetof(Manager, read_etc_hosts)
+\ No newline at end of file
+diff --git a/src/resolve/resolved-manager.c b/src/resolve/resolved-manager.c
+index f7508b6..6e8f9a0 100644
+--- a/src/resolve/resolved-manager.c
++++ b/src/resolve/resolved-manager.c
+@@ -585,7 +585,7 @@ int manager_new(Manager **ret) {
+                 .mdns_support = RESOLVE_SUPPORT_NO,
+                 .dnssec_mode = DEFAULT_DNSSEC_MODE,
+                 .dns_over_tls_mode = DEFAULT_DNS_OVER_TLS_MODE,
+-                .enable_cache = DNS_CACHE_MODE_YES,
++                .enable_cache = DNS_CACHE_MODE_NO_NEGATIVE,
+                 .dns_stub_listener_mode = DNS_STUB_LISTENER_YES,
+                 .read_resolv_conf = true,
+                 .need_builtin_fallbacks = true,
diff -pruN 245.4-4/debian/patches/debian/UBUNTU-resolved-disable-global-LLMNR-and-MulticastDNS.patch 245.4-4ubuntu3/debian/patches/debian/UBUNTU-resolved-disable-global-LLMNR-and-MulticastDNS.patch
--- 245.4-4/debian/patches/debian/UBUNTU-resolved-disable-global-LLMNR-and-MulticastDNS.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/UBUNTU-resolved-disable-global-LLMNR-and-MulticastDNS.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,40 @@
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Fri, 9 Feb 2018 15:57:54 +0000
+Subject: UBUNTU: resolved: disable global LLMNR and MulticastDNS by default.
+
+LP: #1739672
+---
+ src/resolve/resolved-manager.c | 4 ++--
+ src/resolve/resolved.conf.in   | 4 ++--
+ 2 files changed, 4 insertions(+), 4 deletions(-)
+
+diff --git a/src/resolve/resolved-manager.c b/src/resolve/resolved-manager.c
+index 4f72077..f7508b6 100644
+--- a/src/resolve/resolved-manager.c
++++ b/src/resolve/resolved-manager.c
+@@ -581,8 +581,8 @@ int manager_new(Manager **ret) {
+                 .dns_stub_tcp_fd = -1,
+                 .hostname_fd = -1,
+ 
+-                .llmnr_support = RESOLVE_SUPPORT_YES,
+-                .mdns_support = RESOLVE_SUPPORT_YES,
++                .llmnr_support = RESOLVE_SUPPORT_NO,
++                .mdns_support = RESOLVE_SUPPORT_NO,
+                 .dnssec_mode = DEFAULT_DNSSEC_MODE,
+                 .dns_over_tls_mode = DEFAULT_DNS_OVER_TLS_MODE,
+                 .enable_cache = DNS_CACHE_MODE_YES,
+diff --git a/src/resolve/resolved.conf.in b/src/resolve/resolved.conf.in
+index 6898c78..d6dab77 100644
+--- a/src/resolve/resolved.conf.in
++++ b/src/resolve/resolved.conf.in
+@@ -15,8 +15,8 @@
+ #DNS=
+ #FallbackDNS=@DNS_SERVERS@
+ #Domains=
+-#LLMNR=yes
+-#MulticastDNS=yes
++#LLMNR=no
++#MulticastDNS=no
+ #DNSSEC=@DEFAULT_DNSSEC_MODE@
+ #DNSOverTLS=@DEFAULT_DNS_OVER_TLS_MODE@
+ #Cache=yes
diff -pruN 245.4-4/debian/patches/debian/UBUNTU-Support-system-image-read-only-etc.patch 245.4-4ubuntu3/debian/patches/debian/UBUNTU-Support-system-image-read-only-etc.patch
--- 245.4-4/debian/patches/debian/UBUNTU-Support-system-image-read-only-etc.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/UBUNTU-Support-system-image-read-only-etc.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,153 @@
+From: Martin Pitt <martin.pitt@ubuntu.com>
+Date: Sat, 26 Apr 2014 23:49:32 +0200
+Subject: Support system-image read-only /etc
+
+On Ubuntu Phone with readonly /etc we symlink
+/etc/{adjtime,localtime,timezone,hostname,machine-info} to /etc/writable/, so
+we need to update those files instead if the original files are symlinks into
+/etc/writable/.
+
+Forwarded: OMGno, this is a rather nasty hack until we fix system-image to get a writable /etc
+Bug-Ubuntu: https://launchpad.net/bugs/1227520
+---
+ src/hostname/hostnamed.c | 28 ++++++++++++++++++++++++----
+ src/timedate/timedated.c | 31 +++++++++++++++++++++++++------
+ 2 files changed, 49 insertions(+), 10 deletions(-)
+
+diff --git a/src/hostname/hostnamed.c b/src/hostname/hostnamed.c
+index 21f6471..5990b7f 100644
+--- a/src/hostname/hostnamed.c
++++ b/src/hostname/hostnamed.c
+@@ -24,6 +24,7 @@
+ #include "os-util.h"
+ #include "parse-util.h"
+ #include "path-util.h"
++#include "fs-util.h"
+ #include "selinux-util.h"
+ #include "signal-util.h"
+ #include "strv.h"
+@@ -73,6 +74,25 @@ static void context_clear(Context *c) {
+         bus_verify_polkit_async_registry_free(c->polkit_registry);
+ }
+ 
++/* Hack for Ubuntu phone: check if path is an existing symlink to
++ * /etc/writable; if it is, update that instead */
++static const char* writable_filename(const char *path) {
++        ssize_t r;
++        static char realfile_buf[PATH_MAX];
++        _cleanup_free_ char *realfile = NULL;
++        const char *result = path;
++        int orig_errno = errno;
++
++        r = readlink_and_make_absolute(path, &realfile);
++        if (r >= 0 && startswith(realfile, "/etc/writable")) {
++                snprintf(realfile_buf, sizeof(realfile_buf), "%s", realfile);
++                result = realfile_buf;
++        }
++
++        errno = orig_errno;
++        return result;
++}
++
+ static int context_read_data(Context *c) {
+         int r;
+         struct utsname u;
+@@ -306,12 +326,12 @@ static int context_write_data_static_hostname(Context *c) {
+ 
+         if (isempty(c->data[PROP_STATIC_HOSTNAME])) {
+ 
+-                if (unlink("/etc/hostname") < 0)
++                if (unlink(writable_filename("/etc/hostname")) < 0)
+                         return errno == ENOENT ? 0 : -errno;
+ 
+                 return 0;
+         }
+-        return write_string_file_atomic_label("/etc/hostname", c->data[PROP_STATIC_HOSTNAME]);
++        return write_string_file_atomic_label(writable_filename("/etc/hostname"), c->data[PROP_STATIC_HOSTNAME]);
+ }
+ 
+ static int context_write_data_machine_info(Context *c) {
+@@ -356,13 +376,13 @@ static int context_write_data_machine_info(Context *c) {
+         }
+ 
+         if (strv_isempty(l)) {
+-                if (unlink("/etc/machine-info") < 0)
++                if (unlink(writable_filename("/etc/machine-info")) < 0)
+                         return errno == ENOENT ? 0 : -errno;
+ 
+                 return 0;
+         }
+ 
+-        return write_env_file_label("/etc/machine-info", l);
++        return write_env_file_label(writable_filename("/etc/machine-info"), l);
+ }
+ 
+ static int property_get_icon_name(
+diff --git a/src/timedate/timedated.c b/src/timedate/timedated.c
+index 0ed4511..9dfe454 100644
+--- a/src/timedate/timedated.c
++++ b/src/timedate/timedated.c
+@@ -275,6 +275,25 @@ static int context_read_data(Context *c) {
+         return 0;
+ }
+ 
++/* Hack for Ubuntu phone: check if path is an existing symlink to
++ * /etc/writable; if it is, update that instead */
++static const char* writable_filename(const char *path) {
++        ssize_t r;
++        static char realfile_buf[PATH_MAX];
++        _cleanup_free_ char *realfile = NULL;
++        const char *result = path;
++        int orig_errno = errno;
++
++        r = readlink_and_make_absolute(path, &realfile);
++        if (r >= 0 && startswith(realfile, "/etc/writable")) {
++                snprintf(realfile_buf, sizeof(realfile_buf), "%s", realfile);
++                result = realfile_buf;
++        }
++
++        errno = orig_errno;
++        return result;
++}
++
+ static int context_write_data_timezone(Context *c) {
+         _cleanup_free_ char *p = NULL;
+         const char *source;
+@@ -292,10 +311,10 @@ static int context_write_data_timezone(Context *c) {
+ 
+                 if (access("/usr/share/zoneinfo/UTC", F_OK) < 0) {
+ 
+-                        if (unlink("/etc/localtime") < 0 && errno != ENOENT)
++                        if (unlink(writable_filename("/etc/localtime")) < 0 && errno != ENOENT)
+                                 r = -errno;
+ 
+-                        if (unlink("/etc/timezone") < 0 && errno != ENOENT)
++                        if (unlink(writable_filename("/etc/timezone")) < 0 && errno != ENOENT)
+                                 r = -errno;
+ 
+                         return r;
+@@ -310,12 +329,12 @@ static int context_write_data_timezone(Context *c) {
+                 source = p;
+         }
+ 
+-        r = symlink_atomic(source, "/etc/localtime");
++        r = symlink_atomic(source, writable_filename("/etc/localtime"));
+         if (r < 0)
+                 return r;
+ 
+-        if (stat("/etc/timezone", &st) == 0 && S_ISREG(st.st_mode)) {
+-                r = write_string_file("/etc/timezone", c->zone, WRITE_STRING_FILE_CREATE|WRITE_STRING_FILE_ATOMIC);
++        if (stat(writable_filename("/etc/timezone"), &st) == 0 && S_ISREG(st.st_mode)) {
++                r = write_string_file(writable_filename("/etc/timezone"), c->zone, WRITE_STRING_FILE_CREATE|WRITE_STRING_FILE_ATOMIC);
+                 if (r < 0)
+                         return r;
+         }
+@@ -381,7 +400,7 @@ static int context_write_data_local_rtc(Context *c) {
+                 *(char*) mempcpy(stpcpy(stpcpy(mempcpy(w, s, a), prepend), c->local_rtc ? "LOCAL" : "UTC"), e, b) = 0;
+ 
+                 if (streq(w, NULL_ADJTIME_UTC)) {
+-                        if (unlink("/etc/adjtime") < 0)
++                        if (unlink(writable_filename("/etc/adjtime")) < 0)
+                                 if (errno != ENOENT)
+                                         return -errno;
+ 
diff -pruN 245.4-4/debian/patches/debian/UBUNTU-test-sleep-skip-test_fiemap-upon-inapproriate-ioctl-.patch 245.4-4ubuntu3/debian/patches/debian/UBUNTU-test-sleep-skip-test_fiemap-upon-inapproriate-ioctl-.patch
--- 245.4-4/debian/patches/debian/UBUNTU-test-sleep-skip-test_fiemap-upon-inapproriate-ioctl-.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/UBUNTU-test-sleep-skip-test_fiemap-upon-inapproriate-ioctl-.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,23 @@
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Wed, 1 Aug 2018 20:09:39 +0100
+Subject: test-sleep: skip test_fiemap upon inapproriate ioctl for device.
+
+On v4.4 kernels, on top of btrfs ephemeral lxd v3.0 containers generate this
+other error code, instead of not supported. Skip the test for both error codes.
+---
+ src/test/test-sleep.c | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/src/test/test-sleep.c b/src/test/test-sleep.c
+index 014b1aa..753e3d2 100644
+--- a/src/test/test-sleep.c
++++ b/src/test/test-sleep.c
+@@ -53,7 +53,7 @@ static int test_fiemap(const char *path) {
+         if (fd < 0)
+                 return log_error_errno(errno, "failed to open %s: %m", path);
+         r = read_fiemap(fd, &fiemap);
+-        if (r == -EOPNOTSUPP)
++        if (IN_SET(r, -EOPNOTSUPP, -ENOTTY))
+                 exit(log_tests_skipped("Not supported"));
+         if (r < 0)
+                 return log_error_errno(r, "Unable to read extent map for '%s': %m", path);
diff -pruN 245.4-4/debian/patches/debian/UBUNTU-test-test-functions-launch-qemu-with-vga-none.patch 245.4-4ubuntu3/debian/patches/debian/UBUNTU-test-test-functions-launch-qemu-with-vga-none.patch
--- 245.4-4/debian/patches/debian/UBUNTU-test-test-functions-launch-qemu-with-vga-none.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/UBUNTU-test-test-functions-launch-qemu-with-vga-none.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,23 @@
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Fri, 16 Feb 2018 13:28:31 +0000
+Subject: test/test-functions: launch qemu with -vga none
+
+When booting ppc64el virtual machines, they require seabios, unless -vga none
+is specified. Since we do a direct kernel & initrd boot, with -nographic, we
+really have no need for vga or seabios in this case.
+---
+ test/test-functions | 1 +
+ 1 file changed, 1 insertion(+)
+
+diff --git a/test/test-functions b/test/test-functions
+index 66cd60b..9032eef1 100644
+--- a/test/test-functions
++++ b/test/test-functions
+@@ -220,6 +220,7 @@ $KERNEL_APPEND \
+ -net none \
+ -m $QEMU_MEM \
+ -nographic \
++-vga none \
+ -kernel $KERNEL_BIN \
+ -drive format=raw,cache=unsafe,file=${TESTDIR}/rootdisk.img \
+ $QEMU_OPTIONS \
diff -pruN 245.4-4/debian/patches/debian/UBUNTU-units-block-CAP_SYS_MODULE-units-in-containers-too.patch 245.4-4ubuntu3/debian/patches/debian/UBUNTU-units-block-CAP_SYS_MODULE-units-in-containers-too.patch
--- 245.4-4/debian/patches/debian/UBUNTU-units-block-CAP_SYS_MODULE-units-in-containers-too.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/UBUNTU-units-block-CAP_SYS_MODULE-units-in-containers-too.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,38 @@
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Thu, 26 Jul 2018 14:22:25 +0100
+Subject: units: block CAP_SYS_MODULE units in containers too
+
+lxd/lxc usually keep the usernamespace capabilities, whilst in practice one
+does not have these in the initial namespace. Thus add additional condition
+!container, such that sys-kernel-config.mount and systemd-modules.load.service
+are not started in the lxd containers. This should make default lxd containers
+start non-degraded.
+---
+ units/sys-kernel-config.mount         | 1 +
+ units/systemd-modules-load.service.in | 1 +
+ 2 files changed, 2 insertions(+)
+
+diff --git a/units/sys-kernel-config.mount b/units/sys-kernel-config.mount
+index e699788..3e0ec92 100644
+--- a/units/sys-kernel-config.mount
++++ b/units/sys-kernel-config.mount
+@@ -14,6 +14,7 @@ Documentation=https://www.freedesktop.org/wiki/Software/systemd/APIFileSystems
+ DefaultDependencies=no
+ ConditionPathExists=/sys/kernel/config
+ ConditionCapability=CAP_SYS_RAWIO
++ConditionVirtualization=!container
+ After=systemd-modules-load.service
+ Before=sysinit.target
+ 
+diff --git a/units/systemd-modules-load.service.in b/units/systemd-modules-load.service.in
+index 26abe21..73a8d67 100644
+--- a/units/systemd-modules-load.service.in
++++ b/units/systemd-modules-load.service.in
+@@ -14,6 +14,7 @@ DefaultDependencies=no
+ Conflicts=shutdown.target
+ Before=sysinit.target shutdown.target
+ ConditionCapability=CAP_SYS_MODULE
++ConditionVirtualization=!container
+ ConditionDirectoryNotEmpty=|/lib/modules-load.d
+ ConditionDirectoryNotEmpty=|/usr/lib/modules-load.d
+ ConditionDirectoryNotEmpty=|/usr/local/lib/modules-load.d
diff -pruN 245.4-4/debian/patches/debian/UBUNTU-units-disable-journald-watchdog.patch 245.4-4ubuntu3/debian/patches/debian/UBUNTU-units-disable-journald-watchdog.patch
--- 245.4-4/debian/patches/debian/UBUNTU-units-disable-journald-watchdog.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/UBUNTU-units-disable-journald-watchdog.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,22 @@
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Thu, 4 Oct 2018 15:25:50 +0100
+Subject: units: Disable journald Watchdog
+ https://github.com/systemd/systemd/issues/9079
+
+LP: #1773148
+---
+ units/systemd-journald.service.in | 1 -
+ 1 file changed, 1 deletion(-)
+
+diff --git a/units/systemd-journald.service.in b/units/systemd-journald.service.in
+index 804fb7d..f6d8024 100644
+--- a/units/systemd-journald.service.in
++++ b/units/systemd-journald.service.in
+@@ -40,7 +40,6 @@ SystemCallArchitectures=native
+ SystemCallErrorNumber=EPERM
+ SystemCallFilter=@system-service
+ Type=notify
+-@SERVICE_WATCHDOG@
+ 
+ # If there are many split up journal files we need a lot of fds to access them
+ # all in parallel.
diff -pruN 245.4-4/debian/patches/debian/Ubuntu-units-set-ConditionVirtualization-private-users-on-j.patch 245.4-4ubuntu3/debian/patches/debian/Ubuntu-units-set-ConditionVirtualization-private-users-on-j.patch
--- 245.4-4/debian/patches/debian/Ubuntu-units-set-ConditionVirtualization-private-users-on-j.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/Ubuntu-units-set-ConditionVirtualization-private-users-on-j.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,22 @@
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Wed, 2 Aug 2017 00:40:28 +0100
+Subject: units: set ConditionVirtualization=!private-users on journald audit
+ socket
+
+As it fails to start in an unpriviledged container.
+---
+ units/systemd-journald-audit.socket | 1 +
+ 1 file changed, 1 insertion(+)
+
+diff --git a/units/systemd-journald-audit.socket b/units/systemd-journald-audit.socket
+index cb8b774..6649934 100644
+--- a/units/systemd-journald-audit.socket
++++ b/units/systemd-journald-audit.socket
+@@ -14,6 +14,7 @@ DefaultDependencies=no
+ Before=sockets.target
+ ConditionSecurity=audit
+ ConditionCapability=CAP_AUDIT_READ
++ConditionVirtualization=!private-users
+ 
+ [Socket]
+ Service=systemd-journald.service
diff -pruN 245.4-4/debian/patches/debian/Ubuntu-UseDomains-by-default.patch 245.4-4ubuntu3/debian/patches/debian/Ubuntu-UseDomains-by-default.patch
--- 245.4-4/debian/patches/debian/Ubuntu-UseDomains-by-default.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/Ubuntu-UseDomains-by-default.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,75 @@
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Thu, 20 Jul 2017 13:48:31 +0100
+Subject: Set UseDomains to true, by default, on Ubuntu.
+
+On Ubuntu, fallback DNS servers are disabled, therefore we do not leak queries
+to a preset 3rd party by default. In resolved, dnssec is also disabled by
+default, as too much of the internet is broken and using Ubuntu users to debug
+the internet is not very productive - most of the time the end-user cannot fix
+or know how to notify the site owners about the dnssec mistakes. Inherintally
+the DHCP acquired DNS servers are therefore trusted, and are free to spoof
+records. Not trusting DNS search domains, in such scenario, provides limited
+security or privacy benefits. From user point of view, this also appears to be
+a regression from previous Ubuntu releases which do trust DHCP acquired search
+domains by default.
+
+Therefore we are enabling UseDomains by default on Ubuntu.
+
+Users may override this setting in the .network files by specifying
+[DHCP|IPv6AcceptRA] UseDomains=no|route options.
+---
+ man/systemd.network.xml        | 6 +++---
+ src/network/networkd-network.c | 2 ++
+ 2 files changed, 5 insertions(+), 3 deletions(-)
+
+diff --git a/man/systemd.network.xml b/man/systemd.network.xml
+index bd19b76..4283c54 100644
+--- a/man/systemd.network.xml
++++ b/man/systemd.network.xml
+@@ -257,7 +257,7 @@
+             <literal>IPv6AcceptRA=</literal>.</para>
+ 
+             <para>Furthermore, note that by default the domain name
+-            specified through DHCP is not used for name resolution.
++            specified through DHCP, on Ubuntu, are used for name resolution.
+             See option <option>UseDomains=</option> below.</para>
+ 
+             <para>See the <literal>[DHCPv4]</literal> or <literal>[DHCPv6]</literal> section below for
+@@ -1453,7 +1453,7 @@
+             the <option>Domains=</option> setting. If set to <literal>route</literal>, the domain name received from
+             the DHCP server will be used for routing DNS queries only, but not for searching, similar to the effect of
+             the <option>Domains=</option> setting when the argument is prefixed with <literal>~</literal>. Defaults to
+-            false.</para>
++            true on Ubuntu.</para>
+ 
+             <para>It is recommended to enable this option only on trusted networks, as setting this affects resolution
+             of all host names, in particular of single-label names. It is generally safer to use the supplied domain
+@@ -1723,7 +1723,7 @@
+             the effect of the <option>Domains=</option> setting. If set to <literal>route</literal>, the domain name
+             received via IPv6 RA will be used for routing DNS queries only, but not for searching, similar to the
+             effect of the <option>Domains=</option> setting when the argument is prefixed with
+-            <literal>~</literal>. Defaults to false.</para>
++            <literal>~</literal>. Defaults to true on Ubuntu.</para>
+ 
+             <para>It is recommended to enable this option only on trusted networks, as setting this affects resolution
+             of all host names, in particular of single-label names. It is generally safer to use the supplied domain
+diff --git a/src/network/networkd-network.c b/src/network/networkd-network.c
+index 2e716b2..983322e 100644
+--- a/src/network/networkd-network.c
++++ b/src/network/networkd-network.c
+@@ -386,6 +386,7 @@ int network_load_one(Manager *manager, OrderedHashmap **networks, const char *fi
+                 /* NOTE: this var might be overwritten by network_apply_anonymize_if_set */
+                 .dhcp_send_hostname = true,
+                 .dhcp_send_release = true,
++                .dhcp_use_domains = DHCP_USE_DOMAINS_YES,
+                 /* To enable/disable RFC7844 Anonymity Profiles */
+                 .dhcp_anonymize = false,
+                 .dhcp_route_metric = DHCP_ROUTE_METRIC,
+@@ -447,6 +448,7 @@ int network_load_one(Manager *manager, OrderedHashmap **networks, const char *fi
+                 .multicast = -1,
+                 .allmulticast = -1,
+                 .ipv6_accept_ra_use_dns = true,
++                .ipv6_accept_ra_use_domains = DHCP_USE_DOMAINS_YES,
+                 .ipv6_accept_ra_use_autonomous_prefix = true,
+                 .ipv6_accept_ra_use_onlink_prefix = true,
+                 .ipv6_accept_ra_route_table = RT_TABLE_MAIN,
diff -pruN 245.4-4/debian/patches/debian/UBUNTU-wait-online-exit-if-no-links-are-managed.patch 245.4-4ubuntu3/debian/patches/debian/UBUNTU-wait-online-exit-if-no-links-are-managed.patch
--- 245.4-4/debian/patches/debian/UBUNTU-wait-online-exit-if-no-links-are-managed.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/debian/UBUNTU-wait-online-exit-if-no-links-are-managed.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,40 @@
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Mon, 26 Mar 2018 13:17:01 +0100
+Subject: wait-online: exit, if no links are managed.
+
+(cherry picked from commit 19d11f607ac0f8b1e31f72a8e9d3d44371b9dadb)
+---
+ src/network/wait-online/manager.c | 7 ++++++-
+ 1 file changed, 6 insertions(+), 1 deletion(-)
+
+diff --git a/src/network/wait-online/manager.c b/src/network/wait-online/manager.c
+index 40a29f1..5c9d025 100644
+--- a/src/network/wait-online/manager.c
++++ b/src/network/wait-online/manager.c
+@@ -66,6 +66,7 @@ static int manager_link_is_online(Manager *m, Link *l, LinkOperationalStateRange
+ 
+ bool manager_configured(Manager *m) {
+         bool one_ready = false;
++        bool none_managed = true;
+         Iterator i;
+         const char *ifname;
+         void *p;
+@@ -117,13 +118,17 @@ bool manager_configured(Manager *m) {
+                                                                          _LINK_OPERSTATE_INVALID });
+                 if (r < 0 && !m->any)
+                         return false;
++                if (l->state && STR_IN_SET(l->state, "configured", "failed")) {
++                        log_info("managing: %s", l->ifname);
++                        none_managed = false;
++                }
+                 if (r > 0)
+                         /* we wait for at least one link to be ready,
+                          * regardless of who manages it */
+                         one_ready = true;
+         }
+ 
+-        return one_ready;
++        return one_ready || none_managed;
+ }
+ 
+ static int manager_process_link(sd_netlink *rtnl, sd_netlink_message *mm, void *userdata) {
diff -pruN 245.4-4/debian/patches/dhcp-Allow-setting-request-options-again.patch 245.4-4ubuntu3/debian/patches/dhcp-Allow-setting-request-options-again.patch
--- 245.4-4/debian/patches/dhcp-Allow-setting-request-options-again.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/dhcp-Allow-setting-request-options-again.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,87 @@
+From: Balint Reczey <balint.reczey@canonical.com>
+Date: Tue, 21 Apr 2020 23:45:54 +0200
+Subject: dhcp: Allow setting request options again
+
+link_configure() may be called multiple times on a link causing request options
+set multiple times.
+
+LP: #1870410
+---
+ src/libsystemd-network/sd-dhcp-client.c   |  6 ++++--
+ src/libsystemd-network/test-dhcp-client.c | 18 +++++++++---------
+ 2 files changed, 13 insertions(+), 11 deletions(-)
+
+diff --git a/src/libsystemd-network/sd-dhcp-client.c b/src/libsystemd-network/sd-dhcp-client.c
+index 4122d08..54a5dcc 100644
+--- a/src/libsystemd-network/sd-dhcp-client.c
++++ b/src/libsystemd-network/sd-dhcp-client.c
+@@ -188,8 +188,10 @@ int sd_dhcp_client_set_request_option(sd_dhcp_client *client, uint8_t option) {
+         }
+ 
+         for (i = 0; i < client->req_opts_size; i++)
+-                if (client->req_opts[i] == option)
+-                        return -EEXIST;
++                if (client->req_opts[i] == option) {
++                        log_dhcp_client(client, "Setting already set request option %d", option);
++                        return 0;
++                }
+ 
+         if (!GREEDY_REALLOC(client->req_opts, client->req_opts_allocated,
+                             client->req_opts_size + 1))
+diff --git a/src/libsystemd-network/test-dhcp-client.c b/src/libsystemd-network/test-dhcp-client.c
+index 4e9b388..071a2c3 100644
+--- a/src/libsystemd-network/test-dhcp-client.c
++++ b/src/libsystemd-network/test-dhcp-client.c
+@@ -71,17 +71,17 @@ static void test_request_basic(sd_event *e) {
+         assert_se(sd_dhcp_client_set_hostname(client, "~host.domain") == -EINVAL);
+ 
+         assert_se(sd_dhcp_client_set_request_option(client,
+-                                        SD_DHCP_OPTION_SUBNET_MASK) == -EEXIST);
++                                        SD_DHCP_OPTION_SUBNET_MASK) == 0);
+         assert_se(sd_dhcp_client_set_request_option(client,
+-                                        SD_DHCP_OPTION_ROUTER) == -EEXIST);
++                                        SD_DHCP_OPTION_ROUTER) == 0);
+         /* This PRL option is not set when using Anonymize, but in this test
+          * Anonymize settings are not being used. */
+         assert_se(sd_dhcp_client_set_request_option(client,
+-                                        SD_DHCP_OPTION_HOST_NAME) == -EEXIST);
++                                        SD_DHCP_OPTION_HOST_NAME) == 0);
+         assert_se(sd_dhcp_client_set_request_option(client,
+-                                        SD_DHCP_OPTION_DOMAIN_NAME) == -EEXIST);
++                                        SD_DHCP_OPTION_DOMAIN_NAME) == 0);
+         assert_se(sd_dhcp_client_set_request_option(client,
+-                                        SD_DHCP_OPTION_DOMAIN_NAME_SERVER) == -EEXIST);
++                                        SD_DHCP_OPTION_DOMAIN_NAME_SERVER) == 0);
+ 
+         assert_se(sd_dhcp_client_set_request_option(client,
+                                         SD_DHCP_OPTION_PAD) == -EINVAL);
+@@ -101,9 +101,9 @@ static void test_request_basic(sd_event *e) {
+          * Options not set by default (using or not anonymize) are option 17
+          * (SD_DHCP_OPTION_ROOT_PATH) and 42 (SD_DHCP_OPTION_NTP_SERVER) */
+         assert_se(sd_dhcp_client_set_request_option(client, 17) == 0);
+-        assert_se(sd_dhcp_client_set_request_option(client, 17) == -EEXIST);
++        assert_se(sd_dhcp_client_set_request_option(client, 17) == 0);
+         assert_se(sd_dhcp_client_set_request_option(client, 42) == 0);
+-        assert_se(sd_dhcp_client_set_request_option(client, 17) == -EEXIST);
++        assert_se(sd_dhcp_client_set_request_option(client, 17) == 0);
+ 
+         sd_dhcp_client_unref(client);
+ }
+@@ -126,7 +126,7 @@ static void test_request_anonymize(sd_event *e) {
+         assert_se(r >= 0);
+ 
+         assert_se(sd_dhcp_client_set_request_option(client,
+-                                        SD_DHCP_OPTION_NETBIOS_NAMESERVER) == -EEXIST);
++                                        SD_DHCP_OPTION_NETBIOS_NAMESERVER) == 0);
+         /* This PRL option is not set when using Anonymize */
+         assert_se(sd_dhcp_client_set_request_option(client,
+                                         SD_DHCP_OPTION_HOST_NAME) == 0);
+@@ -137,7 +137,7 @@ static void test_request_anonymize(sd_event *e) {
+         /* RFC7844: option 101 (SD_DHCP_OPTION_NEW_TZDB_TIMEZONE) is not set in the
+          * default PRL when using Anonymize, */
+         assert_se(sd_dhcp_client_set_request_option(client, 101) == 0);
+-        assert_se(sd_dhcp_client_set_request_option(client, 101) == -EEXIST);
++        assert_se(sd_dhcp_client_set_request_option(client, 101) == 0);
+ 
+         sd_dhcp_client_unref(client);
+ }
diff -pruN 245.4-4/debian/patches/lp1845909/0002-network-add-link-setting_genmode-flag.patch 245.4-4ubuntu3/debian/patches/lp1845909/0002-network-add-link-setting_genmode-flag.patch
--- 245.4-4/debian/patches/lp1845909/0002-network-add-link-setting_genmode-flag.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/lp1845909/0002-network-add-link-setting_genmode-flag.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,27 @@
+From: Dan Streetman <ddstreet@canonical.com>
+Date: Thu, 19 Dec 2019 13:17:45 -0500
+Subject: network: add link->setting_genmode flag
+
+Similar to the link->setting_mtu flag, this delays continued configuration
+until after the genmode has been successfully set; this is important
+because we do not want networkd to raise the interface before the genmode
+has been set, as if we're disabling the genmode, raising the interface
+before we have successfully disabled the genmode will result in the kernel
+creating a ipv6ll address, even though we don't want that.
+---
+ src/network/networkd-link.c | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/src/network/networkd-link.c b/src/network/networkd-link.c
+index 553dd28..9b34f00 100644
+--- a/src/network/networkd-link.c
++++ b/src/network/networkd-link.c
+@@ -1622,7 +1622,7 @@ static int link_address_genmode_handler(sd_netlink *rtnl, sd_netlink_message *m,
+         else
+                 log_link_debug(link, "Setting address genmode done.");
+ 
+-        if (link->state == LINK_STATE_INITIALIZED) {
++        if (link->state == LINK_STATE_PENDING) {
+                 r = link_configure_continue(link);
+                 if (r < 0)
+                         link_enter_failed(link);
diff -pruN 245.4-4/debian/patches/network-attach-sd-event-in-link_load-when-creating-link-d.patch 245.4-4ubuntu3/debian/patches/network-attach-sd-event-in-link_load-when-creating-link-d.patch
--- 245.4-4/debian/patches/network-attach-sd-event-in-link_load-when-creating-link-d.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/network-attach-sd-event-in-link_load-when-creating-link-d.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,48 @@
+From: Dan Streetman <ddstreet@canonical.com>
+Date: Mon, 23 Mar 2020 17:34:17 -0400
+Subject: network: attach sd-event in link_load() when creating link
+ dhcp_client or ipv4ll
+
+Commit 08c588d18b1e337f856e6541f3f711be48718279 moved attachment of the
+sd-event into creation of the dhcp_client or ipv4ll in dhcp4_configure()
+or ipv4ll_configure(), but these can also be created in link_load(),
+so that creation needs to also perform sd-event attachment.
+
+Without this, dhcp_client or ipv4ll created in link_load() will not have
+an ->event and will fail assertion, causing networkd to fail, e.g.:
+
+Assertion 'client->event' failed at src/libsystemd-network/sd-dhcp-client.c:1283, function client_start_delayed(). Ignoring.
+ens2: Could not acquire DHCPv4 lease: Invalid argument
+ens2: Failed
+
+(cherry picked from commit 1b43e24602010403e8684df7539977264a478688)
+---
+ src/network/networkd-link.c | 8 ++++++++
+ 1 file changed, 8 insertions(+)
+
+diff --git a/src/network/networkd-link.c b/src/network/networkd-link.c
+index 99d4b29..b281e05 100644
+--- a/src/network/networkd-link.c
++++ b/src/network/networkd-link.c
+@@ -3446,6 +3446,10 @@ network_file_fail:
+                 if (r < 0)
+                         return log_link_error_errno(link, r, "Failed to create DHCPv4 client: %m");
+ 
++                r = sd_dhcp_client_attach_event(link->dhcp_client, NULL, 0);
++                if (r < 0)
++                        return log_link_error_errno(link, r, "Failed to attach DHCPv4 event: %m");
++
+                 r = sd_dhcp_client_set_request_address(link->dhcp_client, &address.in);
+                 if (r < 0)
+                         return log_link_error_errno(link, r, "Failed to set initial DHCPv4 address %s: %m", dhcp4_address);
+@@ -3464,6 +3468,10 @@ dhcp4_address_fail:
+                 if (r < 0)
+                         return log_link_error_errno(link, r, "Failed to create IPv4LL client: %m");
+ 
++                r = sd_ipv4ll_attach_event(link->ipv4ll, NULL, 0);
++                if (r < 0)
++                        return log_link_error_errno(link, r, "Failed to attach IPv4LL event: %m");
++
+                 r = sd_ipv4ll_set_address(link->ipv4ll, &address.in);
+                 if (r < 0)
+                         return log_link_error_errno(link, r, "Failed to set initial IPv4LL address %s: %m", ipv4ll_address);
diff -pruN 245.4-4/debian/patches/network-do-not-re-attach-sd-event-object.patch 245.4-4ubuntu3/debian/patches/network-do-not-re-attach-sd-event-object.patch
--- 245.4-4/debian/patches/network-do-not-re-attach-sd-event-object.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/network-do-not-re-attach-sd-event-object.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,58 @@
+From: Yu Watanabe <watanabe.yu+github@gmail.com>
+Date: Mon, 16 Mar 2020 16:17:04 +0900
+Subject: network: do not re-attach sd-event object
+
+Fixes #15126.
+
+(cherry picked from commit 08c588d18b1e337f856e6541f3f711be48718279)
+---
+ src/network/networkd-dhcp4.c  | 8 ++++----
+ src/network/networkd-ipv4ll.c | 8 ++++----
+ 2 files changed, 8 insertions(+), 8 deletions(-)
+
+diff --git a/src/network/networkd-dhcp4.c b/src/network/networkd-dhcp4.c
+index 13e3e32..226c73c 100644
+--- a/src/network/networkd-dhcp4.c
++++ b/src/network/networkd-dhcp4.c
+@@ -1334,11 +1334,11 @@ int dhcp4_configure(Link *link) {
+                         return log_oom();
+                 if (r < 0)
+                         return log_link_error_errno(link, r, "DHCP4 CLIENT: Failed to create DHCP4 client: %m");
+-        }
+ 
+-        r = sd_dhcp_client_attach_event(link->dhcp_client, NULL, 0);
+-        if (r < 0)
+-                return log_link_error_errno(link, r, "DHCP4 CLIENT: Failed to attach event: %m");
++                r = sd_dhcp_client_attach_event(link->dhcp_client, NULL, 0);
++                if (r < 0)
++                        return log_link_error_errno(link, r, "DHCP4 CLIENT: Failed to attach event: %m");
++        }
+ 
+         r = sd_dhcp_client_set_mac(link->dhcp_client,
+                                    (const uint8_t *) &link->mac,
+diff --git a/src/network/networkd-ipv4ll.c b/src/network/networkd-ipv4ll.c
+index 5750ea0..8dac99f 100644
+--- a/src/network/networkd-ipv4ll.c
++++ b/src/network/networkd-ipv4ll.c
+@@ -154,6 +154,10 @@ int ipv4ll_configure(Link *link) {
+                 r = sd_ipv4ll_new(&link->ipv4ll);
+                 if (r < 0)
+                         return r;
++
++                r = sd_ipv4ll_attach_event(link->ipv4ll, NULL, 0);
++                if (r < 0)
++                        return r;
+         }
+ 
+         if (link->sd_device &&
+@@ -163,10 +167,6 @@ int ipv4ll_configure(Link *link) {
+                         return r;
+         }
+ 
+-        r = sd_ipv4ll_attach_event(link->ipv4ll, NULL, 0);
+-        if (r < 0)
+-                return r;
+-
+         r = sd_ipv4ll_set_mac(link->ipv4ll, &link->mac);
+         if (r < 0)
+                 return r;
diff -pruN 245.4-4/debian/patches/network-Set-link-state-to-LINK_STATE_PENDING-instead-of-t.patch 245.4-4ubuntu3/debian/patches/network-Set-link-state-to-LINK_STATE_PENDING-instead-of-t.patch
--- 245.4-4/debian/patches/network-Set-link-state-to-LINK_STATE_PENDING-instead-of-t.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/network-Set-link-state-to-LINK_STATE_PENDING-instead-of-t.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,23 @@
+From: Balint Reczey <balint.reczey@canonical.com>
+Date: Tue, 11 Feb 2020 20:48:31 +0100
+Subject: network: Set link state to LINK_STATE_PENDING instead of to
+ LINK_STATE_INITIALIZED
+
+Changes introducing LINK_STATE_INITIALIZED broke netplan.io's ethernets autopkgtest.
+---
+ src/network/networkd-link-bus.c | 2 +-
+ 1 file changed, 1 insertion(+), 1 deletion(-)
+
+diff --git a/src/network/networkd-link-bus.c b/src/network/networkd-link-bus.c
+index efb72b6..2f7b8f2 100644
+--- a/src/network/networkd-link-bus.c
++++ b/src/network/networkd-link-bus.c
+@@ -621,7 +621,7 @@ int bus_link_method_reconfigure(sd_bus_message *message, void *userdata, sd_bus_
+         if (r < 0)
+                 return r;
+ 
+-        link_set_state(l, LINK_STATE_INITIALIZED);
++        link_set_state(l, LINK_STATE_PENDING);
+         r = link_save(l);
+         if (r < 0)
+                 return r;
diff -pruN 245.4-4/debian/patches/resolved-Mitigate-DVE-2018-0001-by-retrying-NXDOMAIN-with.patch 245.4-4ubuntu3/debian/patches/resolved-Mitigate-DVE-2018-0001-by-retrying-NXDOMAIN-with.patch
--- 245.4-4/debian/patches/resolved-Mitigate-DVE-2018-0001-by-retrying-NXDOMAIN-with.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/resolved-Mitigate-DVE-2018-0001-by-retrying-NXDOMAIN-with.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,78 @@
+From: Dimitri John Ledkov <xnox@ubuntu.com>
+Date: Wed, 28 Mar 2018 23:05:17 +0100
+Subject: resolved: Mitigate DVE-2018-0001,
+ by retrying NXDOMAIN without EDNS0.
+
+Some captive portals, lie and do not respond with the captive portal IP
+address, if the query is with EDNS0 enabled and DO bit set to zero. Thus retry
+all domain name look ups with less secure methods, upon NXDOMAIN. Unless strict
+DNSSEC validation is enabled.
+
+Refreshed patch from new upstream patch from xnox.
+
+Bug-Ubuntu: https://bugs.launchpad.net/ubuntu/bionic/+source/systemd/+bug/1766969
+Bug-Ubuntu: https://bugs.launchpad.net/ubuntu/bionic/+source/systemd/+bug/1727237
+Bug-Ubuntu: https://bugs.launchpad.net/ubuntu/+source/systemd/+bug/1796501
+Bug-DNS: https://github.com/dns-violations/dns-violations/blob/master/2018/DVE-2018-0001.md
+(cherry picked from commit cc0a0eb1a9379a81256d68d65f8450a487c0ab12)
+---
+ src/resolve/resolved-dns-transaction.c | 38 +++++++++++++++++++++++++++++-----
+ 1 file changed, 33 insertions(+), 5 deletions(-)
+
+diff --git a/src/resolve/resolved-dns-transaction.c b/src/resolve/resolved-dns-transaction.c
+index fb54d16..3a2722f 100644
+--- a/src/resolve/resolved-dns-transaction.c
++++ b/src/resolve/resolved-dns-transaction.c
+@@ -376,12 +376,12 @@ static int dns_transaction_pick_server(DnsTransaction *t) {
+         if (!server)
+                 return -ESRCH;
+ 
+-        /* If we changed the server invalidate the feature level clamping, as the new server might have completely
+-         * different properties. */
+-        if (server != t->server)
++        /* If we changed the server invalidate the current & clamp feature levels, as the new server might have
++         * completely different properties. */
++        if (server != t->server) {
+                 t->clamp_feature_level = _DNS_SERVER_FEATURE_LEVEL_INVALID;
+-
+-        t->current_feature_level = dns_server_possible_feature_level(server);
++                t->current_feature_level = dns_server_possible_feature_level(server);
++        }
+ 
+         /* Clamp the feature level if that is requested. */
+         if (t->clamp_feature_level != _DNS_SERVER_FEATURE_LEVEL_INVALID &&
+@@ -1023,6 +1023,34 @@ void dns_transaction_process_reply(DnsTransaction *t, DnsPacket *p) {
+                         return;
+                 }
+ 
++                /* Some captive portals are special in that the Aruba/Datavalet hardware will miss replacing the
++                 * packets with the local server IP to point to the authenticated side of the network if EDNS0 is
++                 * enabled. Instead they return NXDOMAIN, with DO bit set to zero... nothing to see here, yet respond
++                 * with the captive portal IP, when using the more simple UDP level.
++                 *
++                 * Common portal names that fail like so are:
++                 * secure.datavalet.io
++                 * securelogin.arubanetworks.com
++                 * securelogin.networks.mycompany.com
++                 *
++                 * Thus retry NXDOMAIN RCODES with a lower feature level.
++                 *
++                 * Do not "clamp" the feature level down, as the captive portal should not be lying for the wider
++                 * internet (e.g. _other_ queries were observed fine with EDNS0 on these networks, post auth)
++                 *
++                 * This is reported as https://github.com/dns-violations/dns-violations/blob/master/2018/DVE-2018-0001.md
++                 */
++                if (DNS_PACKET_RCODE(p) == DNS_RCODE_NXDOMAIN && t->current_feature_level >= DNS_SERVER_FEATURE_LEVEL_EDNS0 && t->scope->dnssec_mode != DNSSEC_YES) {
++                        char key_str[DNS_RESOURCE_KEY_STRING_MAX];
++                        dns_resource_key_to_string(t->key, key_str, sizeof key_str);
++                        t->current_feature_level = DNS_SERVER_FEATURE_LEVEL_UDP;
++                        log_warning("Server returned error %s, mitigating potential DNS violation DVE-2018-0001, retrying transaction with reduced feature level %s.",
++                                    dns_rcode_to_string(DNS_PACKET_RCODE(p)),
++                                    dns_server_feature_level_to_string(t->current_feature_level));
++                        dns_transaction_retry(t, false /* use the same server */);
++                        return;
++                }
++
+                 if (DNS_PACKET_RCODE(p) == DNS_RCODE_REFUSED) {
+                         /* This server refused our request? If so, try again, use a different server */
+                         log_debug("Server returned REFUSED, switching servers, and retrying.");
diff -pruN 245.4-4/debian/patches/Revert-cgroup-Continue-unit-reset-if-cgroup-is-busy.patch 245.4-4ubuntu3/debian/patches/Revert-cgroup-Continue-unit-reset-if-cgroup-is-busy.patch
--- 245.4-4/debian/patches/Revert-cgroup-Continue-unit-reset-if-cgroup-is-busy.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/Revert-cgroup-Continue-unit-reset-if-cgroup-is-busy.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,33 @@
+From: Balint Reczey <balint.reczey@canonical.com>
+Date: Sat, 21 Sep 2019 18:53:49 +0200
+Subject: Revert "cgroup: Continue unit reset if cgroup is busy"
+
+LP: #1844879
+
+This reverts commit 0219b3524f414e23589e63c6de6a759811ef8474.
+---
+ src/core/cgroup.c | 11 ++++-------
+ 1 file changed, 4 insertions(+), 7 deletions(-)
+
+diff --git a/src/core/cgroup.c b/src/core/cgroup.c
+index ddd3f40..c5ef41f 100644
+--- a/src/core/cgroup.c
++++ b/src/core/cgroup.c
+@@ -2447,13 +2447,10 @@ void unit_prune_cgroup(Unit *u) {
+         is_root_slice = unit_has_name(u, SPECIAL_ROOT_SLICE);
+ 
+         r = cg_trim_everywhere(u->manager->cgroup_supported, u->cgroup_path, !is_root_slice);
+-        if (r < 0)
+-                /* One reason we could have failed here is, that the cgroup still contains a process.
+-                 * However, if the cgroup becomes removable at a later time, it might be removed when
+-                 * the containing slice is stopped. So even if we failed now, this unit shouldn't assume
+-                 * that the cgroup is still realized the next time it is started. Do not return early
+-                 * on error, continue cleanup. */
+-                log_unit_full(u, r == -EBUSY ? LOG_DEBUG : LOG_WARNING, r, "Failed to destroy cgroup %s, ignoring: %m", u->cgroup_path);
++        if (r < 0) {
++                log_unit_debug_errno(u, r, "Failed to destroy cgroup %s, ignoring: %m", u->cgroup_path);
++                return;
++        }
+ 
+         if (is_root_slice)
+                 return;
diff -pruN 245.4-4/debian/patches/Revert-namespace-be-more-careful-when-handling-namespacin.patch 245.4-4ubuntu3/debian/patches/Revert-namespace-be-more-careful-when-handling-namespacin.patch
--- 245.4-4/debian/patches/Revert-namespace-be-more-careful-when-handling-namespacin.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/Revert-namespace-be-more-careful-when-handling-namespacin.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,34 @@
+From: Balint Reczey <balint.reczey@canonical.com>
+Date: Thu, 12 Dec 2019 12:56:44 +0100
+Subject: Revert "namespace: be more careful when handling namespacing
+ failures gracefully"
+
+This partially reverts commit 1beab8b0d0ff2d7d1436b52d4a0c3d56dc908962.
+
+Until after the lowest LXD version running this packaged systemd contains
+https://github.com/lxc/lxd/commit/a6b780703350faff8328f3d565f6bac7b6dcf59f
+
+The first LXD version fixed is 3.10. Ubuntu 18.04 LTS has LXD 3.0.3 and is
+supported until 2028.
+---
+ src/core/execute.c | 7 +++++++
+ 1 file changed, 7 insertions(+)
+
+diff --git a/src/core/execute.c b/src/core/execute.c
+index 5f88877..a77334d 100644
+--- a/src/core/execute.c
++++ b/src/core/execute.c
+@@ -2664,6 +2664,13 @@ static int apply_mount_namespace(
+         }
+ 
+         bind_mount_free_many(bind_mounts, n_bind_mounts);
++
++        /* If we couldn't set up the namespace this is probably due to a
++         * missing capability. In this case, silently proceeed. */
++        if (IN_SET(r, -EPERM, -EACCES)) {
++                log_unit_debug_errno(u, r, "Failed to set up namespace, assuming containerized execution, ignoring: %m");
++                return 0;
++        }
+         return r;
+ }
+ 
diff -pruN 245.4-4/debian/patches/Revert-network-do-not-drop-foreign-config-if-interface-is.patch 245.4-4ubuntu3/debian/patches/Revert-network-do-not-drop-foreign-config-if-interface-is.patch
--- 245.4-4/debian/patches/Revert-network-do-not-drop-foreign-config-if-interface-is.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/Revert-network-do-not-drop-foreign-config-if-interface-is.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,32 @@
+From: Balint Reczey <balint.reczey@canonical.com>
+Date: Tue, 17 Dec 2019 21:33:44 +0100
+Subject: Revert "network: do not drop foreign config if interface is in
+ initialized state"
+
+This reverts commit e8b53300c4160f55447c2f6b02fcde05b47faedc.
+---
+ src/network/networkd-link.c | 4 ++--
+ 1 file changed, 2 insertions(+), 2 deletions(-)
+
+diff --git a/src/network/networkd-link.c b/src/network/networkd-link.c
+index 4492407..553dd28 100644
+--- a/src/network/networkd-link.c
++++ b/src/network/networkd-link.c
+@@ -3078,7 +3078,7 @@ static int link_reconfigure_internal(Link *link, sd_netlink_message *m, bool for
+         if (r < 0)
+                 return r;
+ 
+-        if (!IN_SET(link->state, LINK_STATE_UNMANAGED, LINK_STATE_PENDING, LINK_STATE_INITIALIZED)) {
++        if (!IN_SET(link->state, LINK_STATE_UNMANAGED, LINK_STATE_PENDING)) {
+                 log_link_debug(link, "State is %s, dropping config", link_state_to_string(link->state));
+                 r = link_drop_foreign_config(link);
+                 if (r < 0)
+@@ -3641,7 +3641,7 @@ static int link_carrier_lost(Link *link) {
+         if (r < 0)
+                 return r;
+ 
+-        if (!IN_SET(link->state, LINK_STATE_UNMANAGED, LINK_STATE_PENDING, LINK_STATE_INITIALIZED)) {
++        if (!IN_SET(link->state, LINK_STATE_UNMANAGED, LINK_STATE_PENDING)) {
+                 log_link_debug(link, "State is %s, dropping config", link_state_to_string(link->state));
+                 r = link_drop_foreign_config(link);
+                 if (r < 0)
diff -pruN 245.4-4/debian/patches/Revert-network-fix-assertion-when-link-get-carrier.patch 245.4-4ubuntu3/debian/patches/Revert-network-fix-assertion-when-link-get-carrier.patch
--- 245.4-4/debian/patches/Revert-network-fix-assertion-when-link-get-carrier.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/Revert-network-fix-assertion-when-link-get-carrier.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,31 @@
+From: Balint Reczey <balint.reczey@canonical.com>
+Date: Mon, 21 Oct 2019 17:49:06 +0200
+Subject: Revert "network: fix assertion when link get carrier"
+
+This reverts commit b9ea3d2e47b3741f3f46ba9c5e19640136933b71.
+---
+ src/network/networkd-link.c | 4 ++--
+ 1 file changed, 2 insertions(+), 2 deletions(-)
+
+diff --git a/src/network/networkd-link.c b/src/network/networkd-link.c
+index ce5ea89..8d22a1b 100644
+--- a/src/network/networkd-link.c
++++ b/src/network/networkd-link.c
+@@ -3569,7 +3569,7 @@ int link_ipv6ll_gained(Link *link, const struct in6_addr *address) {
+         link->ipv6ll_address = *address;
+         link_check_ready(link);
+ 
+-        if (IN_SET(link->state, LINK_STATE_CONFIGURING, LINK_STATE_CONFIGURED)) {
++        if (!IN_SET(link->state, LINK_STATE_PENDING, LINK_STATE_UNMANAGED, LINK_STATE_FAILED)) {
+                 r = link_acquire_ipv6_conf(link);
+                 if (r < 0) {
+                         link_enter_failed(link);
+@@ -3596,7 +3596,7 @@ static int link_carrier_gained(Link *link) {
+                 }
+         }
+ 
+-        if (IN_SET(link->state, LINK_STATE_CONFIGURING, LINK_STATE_CONFIGURED)) {
++        if (!IN_SET(link->state, LINK_STATE_PENDING, LINK_STATE_UNMANAGED, LINK_STATE_FAILED)) {
+                 r = link_acquire_conf(link);
+                 if (r < 0) {
+                         link_enter_failed(link);
diff -pruN 245.4-4/debian/patches/Revert-network-if-sys-is-rw-then-udev-should-be-around.patch 245.4-4ubuntu3/debian/patches/Revert-network-if-sys-is-rw-then-udev-should-be-around.patch
--- 245.4-4/debian/patches/Revert-network-if-sys-is-rw-then-udev-should-be-around.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/Revert-network-if-sys-is-rw-then-udev-should-be-around.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,67 @@
+From: Balint Reczey <balint.reczey@canonical.com>
+Date: Wed, 22 Jan 2020 16:12:03 +0100
+Subject: Revert "network: if /sys is rw, then udev should be around"
+
+The change broke networking in LXD containers
+
+This reverts commit 96d7083c5499b264ecebd6a30a92e0e8fda14cd5.
+
+LP: #1857123
+---
+ src/network/networkd-link.c | 12 ++++++------
+ 1 file changed, 6 insertions(+), 6 deletions(-)
+
+diff --git a/src/network/networkd-link.c b/src/network/networkd-link.c
+index 9b34f00..fafd102 100644
+--- a/src/network/networkd-link.c
++++ b/src/network/networkd-link.c
+@@ -37,7 +37,6 @@
+ #include "qdisc.h"
+ #include "set.h"
+ #include "socket-util.h"
+-#include "stat-util.h"
+ #include "stdio-util.h"
+ #include "string-table.h"
+ #include "strv.h"
+@@ -45,6 +44,7 @@
+ #include "tmpfile-util.h"
+ #include "udev-util.h"
+ #include "util.h"
++#include "virt.h"
+ #include "vrf.h"
+ 
+ uint32_t link_get_vrf_table(Link *link) {
+@@ -3512,8 +3512,8 @@ int link_add(Manager *m, sd_netlink_message *message, Link **ret) {
+         if (r < 0)
+                 return r;
+ 
+-        if (path_is_read_only_fs("/sys") <= 0) {
+-                /* udev should be around */
++        if (detect_container() <= 0) {
++                /* not in a container, udev will be around */
+                 sprintf(ifindex_str, "n%d", link->ifindex);
+                 r = sd_device_new_from_device_id(&device, ifindex_str);
+                 if (r < 0) {
+@@ -3523,7 +3523,7 @@ int link_add(Manager *m, sd_netlink_message *message, Link **ret) {
+ 
+                 r = sd_device_get_is_initialized(device);
+                 if (r < 0) {
+-                        log_link_warning_errno(link, r, "Could not determine whether the device is initialized: %m");
++                        log_link_warning_errno(link, r, "Could not determine whether the device is initialized or not: %m");
+                         goto failed;
+                 }
+                 if (r == 0) {
+@@ -3534,11 +3534,11 @@ int link_add(Manager *m, sd_netlink_message *message, Link **ret) {
+ 
+                 r = device_is_renaming(device);
+                 if (r < 0) {
+-                        log_link_warning_errno(link, r, "Failed to determine the device is being renamed: %m");
++                        log_link_warning_errno(link, r, "Failed to determine the device is renamed or not: %m");
+                         goto failed;
+                 }
+                 if (r > 0) {
+-                        log_link_debug(link, "Interface is being renamed, pending initialization.");
++                        log_link_debug(link, "Interface is under renaming, pending initialization.");
+                         return 0;
+                 }
+ 
diff -pruN 245.4-4/debian/patches/Revert-network-prevent-interfaces-to-be-initialized-multi.patch 245.4-4ubuntu3/debian/patches/Revert-network-prevent-interfaces-to-be-initialized-multi.patch
--- 245.4-4/debian/patches/Revert-network-prevent-interfaces-to-be-initialized-multi.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/Revert-network-prevent-interfaces-to-be-initialized-multi.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,115 @@
+From: Balint Reczey <balint.reczey@canonical.com>
+Date: Mon, 21 Oct 2019 17:56:39 +0200
+Subject: Revert "network: prevent interfaces to be initialized multiple
+ times"
+
+The change broke netplan.io's ethernets autopkgtest.
+
+This reverts commit bd08ce56156751d58584a44e766ef61340cdae2d.
+---
+ src/network/networkd-link.c | 15 ++++++---------
+ src/network/networkd-link.h | 13 ++++++-------
+ 2 files changed, 12 insertions(+), 16 deletions(-)
+
+diff --git a/src/network/networkd-link.c b/src/network/networkd-link.c
+index 8d22a1b..4492407 100644
+--- a/src/network/networkd-link.c
++++ b/src/network/networkd-link.c
+@@ -1337,7 +1337,7 @@ static int set_mtu_handler(sd_netlink *rtnl, sd_netlink_message *m, Link *link)
+         else
+                 log_link_debug(link, "Setting MTU done.");
+ 
+-        if (link->state == LINK_STATE_INITIALIZED) {
++        if (link->state == LINK_STATE_PENDING) {
+                 r = link_configure_continue(link);
+                 if (r < 0)
+                         link_enter_failed(link);
+@@ -2186,7 +2186,7 @@ static int link_enter_join_netdev(Link *link) {
+ 
+         assert(link);
+         assert(link->network);
+-        assert(link->state == LINK_STATE_INITIALIZED);
++        assert(link->state == LINK_STATE_PENDING);
+ 
+         link_set_state(link, LINK_STATE_CONFIGURING);
+ 
+@@ -2738,7 +2738,7 @@ static int link_configure(Link *link) {
+ 
+         assert(link);
+         assert(link->network);
+-        assert(link->state == LINK_STATE_INITIALIZED);
++        assert(link->state == LINK_STATE_PENDING);
+ 
+         r = link_configure_qdiscs(link);
+         if (r < 0)
+@@ -2870,7 +2870,7 @@ static int link_configure_continue(Link *link) {
+ 
+         assert(link);
+         assert(link->network);
+-        assert(link->state == LINK_STATE_INITIALIZED);
++        assert(link->state == LINK_STATE_PENDING);
+ 
+         if (link->setting_mtu || link->setting_genmode)
+                 return 0;
+@@ -3098,7 +3098,7 @@ static int link_reconfigure_internal(Link *link, sd_netlink_message *m, bool for
+         if (r < 0)
+                 return r;
+ 
+-        link_set_state(link, LINK_STATE_INITIALIZED);
++        link_set_state(link, LINK_STATE_PENDING);
+         link_dirty(link);
+ 
+         /* link_configure_duid() returns 0 if it requests product UUID. In that case,
+@@ -3167,11 +3167,10 @@ static int link_initialized_and_synced(Link *link) {
+ 
+         /* We may get called either from the asynchronous netlink callback,
+          * or directly for link_add() if running in a container. See link_add(). */
+-        if (!IN_SET(link->state, LINK_STATE_PENDING, LINK_STATE_INITIALIZED))
++        if (link->state != LINK_STATE_PENDING)
+                 return 0;
+ 
+         log_link_debug(link, "Link state is up-to-date");
+-        link_set_state(link, LINK_STATE_INITIALIZED);
+ 
+         r = link_new_bound_by_list(link);
+         if (r < 0)
+@@ -3271,7 +3270,6 @@ int link_initialized(Link *link, sd_device *device) {
+                 return 0;
+ 
+         log_link_debug(link, "udev initialized link");
+-        link_set_state(link, LINK_STATE_INITIALIZED);
+ 
+         link->sd_device = sd_device_ref(device);
+ 
+@@ -4308,7 +4306,6 @@ void link_clean(Link *link) {
+ 
+ static const char* const link_state_table[_LINK_STATE_MAX] = {
+         [LINK_STATE_PENDING] = "pending",
+-        [LINK_STATE_INITIALIZED] = "initialized",
+         [LINK_STATE_CONFIGURING] = "configuring",
+         [LINK_STATE_CONFIGURED] = "configured",
+         [LINK_STATE_UNMANAGED] = "unmanaged",
+diff --git a/src/network/networkd-link.h b/src/network/networkd-link.h
+index 59a5107..afcaada 100644
+--- a/src/network/networkd-link.h
++++ b/src/network/networkd-link.h
+@@ -24,13 +24,12 @@
+ #include "set.h"
+ 
+ typedef enum LinkState {
+-        LINK_STATE_PENDING,     /* udev has not initialized the link */
+-        LINK_STATE_INITIALIZED, /* udev has initialized the link */
+-        LINK_STATE_CONFIGURING, /* configuring addresses, routes, etc. */
+-        LINK_STATE_CONFIGURED,  /* everything is configured */
+-        LINK_STATE_UNMANAGED,   /* Unmanaged=yes is set */
+-        LINK_STATE_FAILED,      /* at least one configuration process failed */
+-        LINK_STATE_LINGER,      /* RTM_DELLINK for the link has been received */
++        LINK_STATE_PENDING,
++        LINK_STATE_CONFIGURING,
++        LINK_STATE_CONFIGURED,
++        LINK_STATE_UNMANAGED,
++        LINK_STATE_FAILED,
++        LINK_STATE_LINGER,
+         _LINK_STATE_MAX,
+         _LINK_STATE_INVALID = -1
+ } LinkState;
diff -pruN 245.4-4/debian/patches/riscv64-seccomp.patch 245.4-4ubuntu3/debian/patches/riscv64-seccomp.patch
--- 245.4-4/debian/patches/riscv64-seccomp.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/riscv64-seccomp.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,87 @@
+From: William Grant <wgrant@ubuntu.com>
+Date: Mon, 6 Apr 2020 13:42:57 +0200
+Subject: Add riscv64 seccomp support
+
+---
+ src/shared/seccomp-util.c | 15 +++++++++++----
+ src/test/test-seccomp.c   |  1 +
+ 2 files changed, 12 insertions(+), 4 deletions(-)
+
+diff --git a/src/shared/seccomp-util.c b/src/shared/seccomp-util.c
+index eeca17f..d65a4bd 100644
+--- a/src/shared/seccomp-util.c
++++ b/src/shared/seccomp-util.c
+@@ -85,6 +85,8 @@ const uint32_t seccomp_local_archs[] = {
+                 SCMP_ARCH_PPC64LE,     /* native */
+ #elif defined(__powerpc__)
+                 SCMP_ARCH_PPC,
++#elif defined(__riscv) && __riscv_xlen == 64
++		SCMP_ARCH_RISCV64,
+ #elif defined(__s390x__)
+                 SCMP_ARCH_S390,
+                 SCMP_ARCH_S390X,      /* native */
+@@ -131,6 +133,8 @@ const char* seccomp_arch_to_string(uint32_t c) {
+                 return "ppc64";
+         case SCMP_ARCH_PPC64LE:
+                 return "ppc64-le";
++        case SCMP_ARCH_RISCV64:
++                return "riscv64";
+         case SCMP_ARCH_S390:
+                 return "s390";
+         case SCMP_ARCH_S390X:
+@@ -176,6 +180,8 @@ int seccomp_arch_from_string(const char *n, uint32_t *ret) {
+                 *ret = SCMP_ARCH_PPC64;
+         else if (streq(n, "ppc64-le"))
+                 *ret = SCMP_ARCH_PPC64LE;
++        else if (streq(n, "riscv64"))
++                *ret = SCMP_ARCH_RISCV64;
+         else if (streq(n, "s390"))
+                 *ret = SCMP_ARCH_S390;
+         else if (streq(n, "s390x"))
+@@ -1253,7 +1259,7 @@ int seccomp_protect_sysctl(void) {
+ 
+                 log_debug("Operating on architecture: %s", seccomp_arch_to_string(arch));
+ 
+-                if (IN_SET(arch, SCMP_ARCH_X32, SCMP_ARCH_AARCH64))
++                if (IN_SET(arch, SCMP_ARCH_X32, SCMP_ARCH_AARCH64, SCMP_ARCH_RISCV64))
+                         /* No _sysctl syscall */
+                         continue;
+ 
+@@ -1575,7 +1581,7 @@ static int add_seccomp_syscall_filter(scmp_filter_ctx seccomp,
+ }
+ 
+ /* For known architectures, check that syscalls are indeed defined or not. */
+-#if defined(__x86_64__) || defined(__arm__) || defined(__aarch64__)
++#if defined(__x86_64__) || defined(__arm__) || defined(__aarch64__) || (defined(__riscv) && __riscv_xlen == 64)
+ assert_cc(SCMP_SYS(shmget) > 0);
+ assert_cc(SCMP_SYS(shmat) > 0);
+ assert_cc(SCMP_SYS(shmdt) > 0);
+@@ -1620,13 +1626,14 @@ int seccomp_memory_deny_write_execute(void) {
+                 case SCMP_ARCH_X86_64:
+                 case SCMP_ARCH_X32:
+                 case SCMP_ARCH_AARCH64:
+-                        filter_syscall = SCMP_SYS(mmap); /* amd64, x32 and arm64 have only mmap */
++                case SCMP_ARCH_RISCV64:
++                        filter_syscall = SCMP_SYS(mmap); /* amd64, x32, arm64 and riscv64 have only mmap */
+                         shmat_syscall = SCMP_SYS(shmat);
+                         break;
+ 
+                 /* Please add more definitions here, if you port systemd to other architectures! */
+ 
+-#if !defined(__i386__) && !defined(__x86_64__) && !defined(__powerpc__) && !defined(__powerpc64__) && !defined(__arm__) && !defined(__aarch64__) && !defined(__s390__) && !defined(__s390x__)
++#if !defined(__i386__) && !defined(__x86_64__) && !defined(__powerpc__) && !defined(__powerpc64__) && !defined(__arm__) && !defined(__aarch64__) && !defined(__s390__) && !defined(__s390x__) && !(defined(__riscv) && __riscv_xlen == 64)
+ #warning "Consider adding the right mmap() syscall definitions here!"
+ #endif
+                 }
+diff --git a/src/test/test-seccomp.c b/src/test/test-seccomp.c
+index 67900d8..8c13b69 100644
+--- a/src/test/test-seccomp.c
++++ b/src/test/test-seccomp.c
+@@ -72,6 +72,7 @@ static void test_architecture_table(void) {
+                        "ppc\0"
+                        "ppc64\0"
+                        "ppc64-le\0"
++                       "riscv64\0"
+                        "s390\0"
+                        "s390x\0") {
+                 uint32_t c;
diff -pruN 245.4-4/debian/patches/series 245.4-4ubuntu3/debian/patches/series
--- 245.4-4/debian/patches/series	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/series	2020-04-22 09:04:26.000000000 +0000
@@ -9,6 +9,9 @@ core-automatically-add-dependency-on-sys
 units-drop-dependency-on-systemd-remount-fs.service-from-.patch
 units-drop-systemd-remount-fs.service-dependency-from-mor.patch
 units-make-sure-systemd-pstore-stops-at-shutdown.patch
+network-do-not-re-attach-sd-event-object.patch
+network-attach-sd-event-in-link_load-when-creating-link-d.patch
+shared-Don-t-try-calling-NULL-callback-in-bus_wait_for_un.patch
 debian/Use-Debian-specific-config-files.patch
 debian/Bring-tmpfiles.d-tmp.conf-in-line-with-Debian-defaul.patch
 debian/Make-run-lock-tmpfs-an-API-fs.patch
@@ -28,3 +31,31 @@ debian/blacklist-upstream-test-25.patch
 debian/blacklist-upstream-test-24-ppc64el.patch
 debian/udev-drop-SystemCallArchitectures-native-from-systemd-ude.patch
 debian/Revert-job-Don-t-mark-as-redundant-if-deps-are-relevant.patch
+debian/Ubuntu-UseDomains-by-default.patch
+debian/Ubuntu-core-in-execute-soft-fail-setting-Nice-priority-when.patch
+debian/Ubuntu-units-set-ConditionVirtualization-private-users-on-j.patch
+debian/UBUNTU-drop-kernel.-settings-from-sysctl-defaults-shipped.patch
+debian/UBUNTU-resolved-disable-global-LLMNR-and-MulticastDNS.patch
+debian/UBUNTU-Add-AssumedApparmorLabel-unconfined-to-timedate1-dbus.patch
+debian/UBUNTU-test-test-functions-launch-qemu-with-vga-none.patch
+debian/UBUNTU-wait-online-exit-if-no-links-are-managed.patch
+debian/UBUNTU-journald.service-set-Nice-1-to-dodge-watchdog-on-soft-loc.patch
+debian/UBUNTU-networkd-if-RA-was-implicit-do-not-await-ndisc_con.patch
+debian/UBUNTU-units-block-CAP_SYS_MODULE-units-in-containers-too.patch
+debian/UBUNTU-test-sleep-skip-test_fiemap-upon-inapproriate-ioctl-.patch
+debian/UBUNTU-Support-system-image-read-only-etc.patch
+debian/UBUNTU-units-disable-journald-watchdog.patch
+debian/UBUNTU-core-set-run-size-to-10-like-initramfs-tools-does.patch
+resolved-Mitigate-DVE-2018-0001-by-retrying-NXDOMAIN-with.patch
+Revert-namespace-be-more-careful-when-handling-namespacin.patch
+Skip-falling-back-to-device-name-when-net_get_name-device.patch
+Revert-cgroup-Continue-unit-reset-if-cgroup-is-busy.patch
+Revert-network-fix-assertion-when-link-get-carrier.patch
+Revert-network-prevent-interfaces-to-be-initialized-multi.patch
+debian/UBUNTU-resolved-default-no-negative-caching.patch
+Revert-network-do-not-drop-foreign-config-if-interface-is.patch
+lp1845909/0002-network-add-link-setting_genmode-flag.patch
+Revert-network-if-sys-is-rw-then-udev-should-be-around.patch
+network-Set-link-state-to-LINK_STATE_PENDING-instead-of-t.patch
+riscv64-seccomp.patch
+dhcp-Allow-setting-request-options-again.patch
diff -pruN 245.4-4/debian/patches/shared-Don-t-try-calling-NULL-callback-in-bus_wait_for_un.patch 245.4-4ubuntu3/debian/patches/shared-Don-t-try-calling-NULL-callback-in-bus_wait_for_un.patch
--- 245.4-4/debian/patches/shared-Don-t-try-calling-NULL-callback-in-bus_wait_for_un.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/shared-Don-t-try-calling-NULL-callback-in-bus_wait_for_un.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,24 @@
+From: Balint Reczey <balint.reczey@canonical.com>
+Date: Wed, 22 Apr 2020 09:51:53 +0200
+Subject: shared: Don't try calling NULL callback in bus_wait_for_units_clear
+
+BugLink: https://bugs.launchpad.net/bugs/1870930
+(cherry picked from commit 16d14b4474243f6e06db579582c1fb1bcd13131b)
+---
+ src/shared/bus-wait-for-units.c | 3 ++-
+ 1 file changed, 2 insertions(+), 1 deletion(-)
+
+diff --git a/src/shared/bus-wait-for-units.c b/src/shared/bus-wait-for-units.c
+index 78b2a60..ed0442f 100644
+--- a/src/shared/bus-wait-for-units.c
++++ b/src/shared/bus-wait-for-units.c
+@@ -91,7 +91,8 @@ static void bus_wait_for_units_clear(BusWaitForUnits *d) {
+         while ((item = hashmap_first(d->items))) {
+                 d->current = item;
+ 
+-                item->unit_callback(d, item->bus_path, false, item->userdata);
++                if (item->unit_callback)
++                        item->unit_callback(d, item->bus_path, false, item->userdata);
+                 wait_for_item_free(item);
+         }
+ 
diff -pruN 245.4-4/debian/patches/Skip-falling-back-to-device-name-when-net_get_name-device.patch 245.4-4ubuntu3/debian/patches/Skip-falling-back-to-device-name-when-net_get_name-device.patch
--- 245.4-4/debian/patches/Skip-falling-back-to-device-name-when-net_get_name-device.patch	1970-01-01 00:00:00.000000000 +0000
+++ 245.4-4ubuntu3/debian/patches/Skip-falling-back-to-device-name-when-net_get_name-device.patch	2020-04-22 09:04:26.000000000 +0000
@@ -0,0 +1,23 @@
+From: Balint Reczey <balint.reczey@canonical.com>
+Date: Tue, 10 Sep 2019 17:17:28 +0200
+Subject: Skip falling back to device name when net_get_name(device) fails
+
+This fixes network-manager and netplan.io autopkgtests by partially reverting
+upstream commit 6d36464065601f79a352367cf099be8907d8f9aa
+---
+ src/libsystemd-network/network-internal.c | 2 --
+ 1 file changed, 2 deletions(-)
+
+diff --git a/src/libsystemd-network/network-internal.c b/src/libsystemd-network/network-internal.c
+index 13a0a5d..d4d5f6f 100644
+--- a/src/libsystemd-network/network-internal.c
++++ b/src/libsystemd-network/network-internal.c
+@@ -53,8 +53,6 @@ int net_get_unique_predictable_data(sd_device *device, bool use_sysname, uint64_
+         /* net_get_name_persistent() will return one of the device names based on stable information about
+          * the device. If this is not available, we fall back to using the actual device name. */
+         name = net_get_name_persistent(device);
+-        if (!name && use_sysname)
+-                (void) sd_device_get_sysname(device, &name);
+         if (!name)
+                 return log_device_debug_errno(device, SYNTHETIC_ERRNO(ENODATA),
+                                               "No stable identifying information found");
diff -pruN 245.4-4/debian/rules 245.4-4ubuntu3/debian/rules
--- 245.4-4/debian/rules	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/rules	2020-04-22 09:04:26.000000000 +0000
@@ -10,7 +10,7 @@ include /usr/share/dpkg/default.mk
 ifeq ($(DEB_VENDOR),Ubuntu)
     DEFAULT_NTP_SERVERS = ntp.ubuntu.com
     SUPPORT_URL = http://www.ubuntu.com/support
-    CONFFLAGS_DISTRO =
+    CONFFLAGS_DISTRO = -Dtpm-pcrindex=12
 else
     DEFAULT_NTP_SERVERS = 0.debian.pool.ntp.org 1.debian.pool.ntp.org 2.debian.pool.ntp.org 3.debian.pool.ntp.org
     SUPPORT_URL = https://www.debian.org/support
@@ -40,6 +40,7 @@ CONFFLAGS = \
 	-Db_pie=true \
 	-Drootlibdir=/lib/$(DEB_HOST_MULTIARCH) \
 	-Dsplit-usr=true \
+	-Duser-path=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin \
 	-Dversion-tag="$(DEB_VERSION)" \
 	-Dquotaon-path=/sbin/quotaon \
 	-Dquotacheck-path=/sbin/quotacheck \
@@ -224,7 +225,6 @@ override_dh_install:
 	rm -f debian/install/*/usr/share/doc/systemd/LICENSE.*
 	rm -f debian/install/*/var/log/README
 	rm -f debian/install/*/etc/init.d/README
-	rm -f debian/install/*/usr/lib/sysctl.d/50-default.conf
 	rm -f debian/install/*/etc/X11/xinit/xinitrc.d/50-systemd-user.sh
 	rmdir -p --ignore-fail-on-non-empty debian/install/*/etc/X11/xinit/xinitrc.d/
 	# remove files related to factory-reset feature
@@ -275,13 +275,15 @@ ifeq ($(DEB_VENDOR),Ubuntu)
 	install --mode=644 debian/extra/rules-ubuntu/*.rules debian/udev/lib/udev/rules.d/
 	cp -a debian/extra/units-ubuntu/* debian/systemd/lib/systemd/system/
 	install --mode=755 debian/extra/set-cpufreq debian/systemd/lib/systemd/
+	install -D --mode=755 debian/extra/dhclient-enter-resolved-hook debian/systemd/etc/dhcp/dhclient-enter-hooks.d/resolved
 endif
 
 override_dh_missing:
 	dh_missing --sourcedir debian/install/deb $(DH_MISSING)
 
 override_dh_installinit:
-	dh_installinit --no-start
+	dh_installinit --no-scripts -psystemd
+	dh_installinit --no-start -Nsystemd
 
 override_dh_systemd_enable:
 	dh_systemd_enable -psystemd-timesyncd
diff -pruN 245.4-4/debian/systemd.postinst 245.4-4ubuntu3/debian/systemd.postinst
--- 245.4-4/debian/systemd.postinst	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/systemd.postinst	2020-04-22 09:04:26.000000000 +0000
@@ -34,6 +34,32 @@ if [ -z "$2" ]; then
     systemctl enable remote-fs.target || true
 fi
 
+# Enable resolved by default on new installs installs and upgrades
+if dpkg --compare-versions "$2" lt "234-1ubuntu2~"; then
+    systemctl enable systemd-resolved.service || true
+fi
+
+# Drop stock /etc/rc.local on upgrades
+if dpkg --compare-versions "$2" lt "234-2ubuntu11~"; then
+        if [ -f /etc/rc.local ]; then
+                if [ "10fd9f051accb6fd1f753f2d48371890" = "$(md5sum /etc/rc.local | cut -d\  -f1)" ]; then
+                        echo Removing empty /etc/rc.local
+                        rm -f /etc/rc.local || true
+                fi
+        fi
+fi
+
+# Use stub resolve.conf by default on new installs
+if [ -z "$2" ]; then
+    mkdir -p /run/systemd/resolve
+    if [ -e /etc/resolv.conf ]; then
+            cp /etc/resolv.conf /run/systemd/resolve/stub-resolv.conf
+    fi
+    # If /etc/resolv.conf is a bind-mount, moving or replacing
+    # /etc/resolv.conf may fail
+    ln -snf ../run/systemd/resolve/stub-resolv.conf /etc/resolv.conf || true
+fi
+
 # Enable ondemand by default on new installs
 if [ -e /lib/systemd/system/ondemand.service ] && [ -z "$2" ]; then
     systemctl enable ondemand.service || true
@@ -101,14 +127,11 @@ adduser --quiet --system --group --no-cr
 adduser --quiet --system --group --no-create-home --home /run/systemd \
     --gecos "systemd Resolver" systemd-resolve
 
-# Enable persistent journal, in auto-mode, by default on new installs and upgrades
-if dpkg --compare-versions "$2" lt "244.1-2~"; then
+# Enable persistent journal, in auto-mode, by default on new installs installs and upgrades
+if dpkg --compare-versions "$2" lt "235-3ubuntu3~"; then
     mkdir -p /var/log/journal
-    # Applying ACLs requires a mounted /proc and systemd-tmpfiles will fail if
-    # /proc is not available. Skip systemd-tmpfiles in this case. This should
-    # be fine, as this typically means we are inside a chroot and systemd is
-    # not currently active. The permissions will be applied on the next boot.
-    if mountpoint -q /proc; then
+    # create tmpfiles only when running systemd, otherwise %b substitution fails
+    if [ -d /run/systemd/system ]; then
         systemd-tmpfiles --create --prefix /var/log/journal
     fi
 fi
@@ -116,7 +139,15 @@ fi
 # Initial update of the Message Catalogs database
 _update_catalog
 
-if [ -n "$2" ]; then
+# Disable networkd when upgrading from broken versions 8..10. Turns out
+# enabling networkd unconditionally has long boot time side-effects
+if dpkg --compare-versions "$2" gt "234-2ubuntu8~" &&
+   dpkg --compare-versions "$2" lt "234-2ubuntu11~"; then
+    systemctl disable systemd-networkd-wait-online.service || true
+fi
+
+# skip daemon-reexec and try-restarts during shutdown to avoid hitting LP: #1803391
+if [ -n "$2" ] && [ "$(systemctl is-system-running)" != "stopping" ]; then
     _systemctl daemon-reexec || true
     # don't restart logind; this can be done again once this gets implemented:
     # https://github.com/systemd/systemd/issues/1163
@@ -144,6 +175,12 @@ if dpkg --compare-versions "$2" lt-nl "2
     fi
 fi
 
+# Process all tmpfiles that we ship, including any overrides in
+# runtime-dir/sysadmin-dir/other packages (e.g. rsyslog)
+#
+# Ignore if this fails, because e.g. %b will fail on WSL
+systemd-tmpfiles --create || :
+
 if dpkg --compare-versions "$2" lt-nl "245.4-4~"; then
     # systemd-pstore.service is now enabled via sysinit.target
     rm -f /etc/systemd/system/systemd-remount-fs.service.wants/systemd-pstore.service
diff -pruN 245.4-4/debian/systemd.prerm 245.4-4ubuntu3/debian/systemd.prerm
--- 245.4-4/debian/systemd.prerm	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/systemd.prerm	1970-01-01 00:00:00.000000000 +0000
@@ -1,15 +0,0 @@
-#!/bin/sh
-
-set -e
-
-#
-# Prevent systemd from being removed if it's the active init.  That
-# will not work.
-#
-
-if [ "$1" = "remove" ] && [ -d /run/systemd/system ]; then
-    echo "systemd is the active init system, please switch to another before removing systemd."
-    exit 1
-fi
-
-#DEBHELPER#
diff -pruN 245.4-4/debian/tests/boot-and-services 245.4-4ubuntu3/debian/tests/boot-and-services
--- 245.4-4/debian/tests/boot-and-services	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/tests/boot-and-services	2020-04-22 09:04:26.000000000 +0000
@@ -3,6 +3,7 @@
 # (C) 2014 Canonical Ltd.
 # Author: Martin Pitt <martin.pitt@ubuntu.com>
 
+import platform
 import sys
 import os
 import unittest
@@ -108,8 +109,13 @@ class ServicesTest(unittest.TestCase):
         with open('/var/log/syslog') as f:
             log = f.read()
         if not is_container:
-            # has kernel messages
-            self.assertRegex(log, 'kernel:.*')
+            try:
+                # has kernel messages
+                self.assertRegex(log, 'kernel:.*[cC]ommand line:')
+            except AssertionError:
+                # hm syslog is trimmed, for some reason?!
+                subprocess.call(['journalctl', '-k'])
+                self.assertRegex(log, 'kernel:.*')
         # has init messages
         self.assertRegex(log, 'systemd.*Reached target Graphical Interface')
         # has other services
@@ -254,7 +260,7 @@ poweroff\n''')
         subprocess.call(['journalctl', '--sync'])
         systemctl = subprocess.Popen(
             ['systemctl', 'status', '-overbose', '-l', 'systemd-nspawn@c1'],
-            stdout=subprocess.PIPE)
+            stdout=subprocess.PIPE, stderr=subprocess.PIPE)
         out = systemctl.communicate()[0].decode('UTF-8', 'replace')
         self.assertEqual(systemctl.returncode, 3, out)
         self.assertNotIn('failed', out)
@@ -262,6 +268,7 @@ poweroff\n''')
 
 @unittest.skipUnless(os.path.exists('/sys/kernel/security/apparmor'),
                      'AppArmor not enabled')
+@unittest.skipIf(is_container and platform.machine().startswith('arm'), 'fails on armhf testbeds, see LP: #1842352')
 class AppArmorTest(unittest.TestCase):
     def test_profile(self):
         '''AppArmor confined unit'''
diff -pruN 245.4-4/debian/tests/boot-smoke 245.4-4ubuntu3/debian/tests/boot-smoke
--- 245.4-4/debian/tests/boot-smoke	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/tests/boot-smoke	2020-04-22 09:04:26.000000000 +0000
@@ -42,7 +42,7 @@ else
     echo "waiting to boot..."
     TIMEOUT=35
     while [ $TIMEOUT -ge 0 ]; do
-        state="$(systemctl is-system-running || true)"
+        state="$(systemctl --wait is-system-running || true)"
         case $state in
             running|degraded)
                 break
@@ -74,6 +74,29 @@ else
         fail "found connection timeout in journal for this boot"
     fi
 
+    echo "checking that polkitd runs"
+    if ! pidof polkitd; then
+        fail "polkitd is NOT running"
+    fi
+
+    echo "checking failed jobs (non fatal)"
+    if [ "$state" != "running" ]; then
+        echo "systemctl is-system-running returns: $state"
+        systemctl --no-pager --no-legend list-jobs > $AUTOPKGTEST_ARTIFACTS/running-jobs.txt || true
+    fi
+
+    echo "checking that there are no running jobs"
+    TIMEOUT=$JOBS_TIMEOUT
+    while [ $TIMEOUT -ge 0 ]; do
+        running="$(systemctl --no-pager --no-legend list-jobs || true)"
+        [ -n "$running" ] || break
+        sleep 1
+        TIMEOUT=$((TIMEOUT - 1))
+    done
+    if [ -n "$running" ]; then
+        fail "running jobs after remaining timeout $TIMEOUT: $running"
+    fi
+
     echo "checking that NetworkManager runs"
     pidof NetworkManager || fail "NetworkManager was not running"
 fi
diff -pruN 245.4-4/debian/tests/control 245.4-4ubuntu3/debian/tests/control
--- 245.4-4/debian/tests/control	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/tests/control	2020-04-22 09:04:26.000000000 +0000
@@ -1,5 +1,6 @@
 Tests: timedated, hostnamed, localed-locale, localed-x11-keymap
 Depends: systemd,
+  udev,
   libpam-systemd,
   libnss-systemd,
   acl,
@@ -8,6 +9,7 @@ Restrictions: needs-root, isolation-cont
 
 Tests: logind
 Depends: systemd,
+  udev,
   libpam-systemd,
   libnss-systemd,
   acl,
@@ -17,6 +19,7 @@ Restrictions: needs-root, isolation-cont
 
 Tests: unit-config
 Depends: systemd,
+  udev,
   libpam-systemd,
   libnss-systemd,
   acl,
@@ -28,6 +31,7 @@ Restrictions: needs-root, allow-stderr
 
 Tests: storage
 Depends: systemd,
+  udev,
   libpam-systemd,
   libnss-systemd,
   acl,
@@ -41,6 +45,7 @@ Restrictions: needs-root, isolation-mach
 Tests: networkd-test.py
 Tests-Directory: test
 Depends: systemd,
+  udev,
   libpam-systemd,
   libnss-systemd,
   acl,
@@ -56,6 +61,7 @@ Restrictions: needs-root, isolation-cont
 
 Tests: build-login
 Depends: systemd,
+  udev,
   libpam-systemd,
   libnss-systemd,
   acl,
@@ -73,12 +79,14 @@ Restrictions: isolation-container
 
 Tests: boot-and-services
 Depends: systemd-sysv,
+  systemd,
+  udev,
   systemd-container,
   systemd-coredump,
   libpam-systemd,
   xserver-xorg-video-dummy,
   xserver-xorg,
-  gdm3 [!s390x],
+  gdm3 [amd64],
   cron,
   network-manager,
   busybox-static,
@@ -90,14 +98,16 @@ Restrictions: needs-root, isolation-cont
 
 Tests: udev
 Depends: systemd-tests,
+  udev,
   python3,
   tree,
   perl,
   xz-utils,
-Restrictions: needs-root, allow-stderr, isolation-container, skippable
+Restrictions: needs-root, allow-stderr, isolation-machine, skippable
 
 Tests: root-unittests
 Depends: systemd-tests,
+  udev,
   libpam-systemd,
   tree,
   perl,
@@ -176,6 +186,8 @@ Depends: libsystemd-dev,
   systemd-container,
   systemd-coredump,
   systemd-sysv,
+  systemd,
+  udev,
   fdisk | util-linux (<< 2.29.2-3~),
   netcat-openbsd,
   busybox-static,
diff -pruN 245.4-4/debian/tests/storage 245.4-4ubuntu3/debian/tests/storage
--- 245.4-4/debian/tests/storage	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/tests/storage	2020-04-22 09:04:26.000000000 +0000
@@ -21,15 +21,25 @@ TIMEOUT_SCSI_DEBUG_ADD_HOST = 5
 
 SCSI_DEBUG_DIR = '/sys/bus/pseudo/drivers/scsi_debug'
 
+
+def have_scsi_debug():
+    return os.path.isdir(SCSI_DEBUG_DIR)
+
+
+def load_scsi_debug():
+    return subprocess.call(['modprobe', 'scsi_debug', 'dev_size_mb=32'],
+                           stderr=subprocess.STDOUT) == 0
+
+
+# Some custom Ubuntu kernels do not build the scsi_debug module at all,
+# so skip the test if we can't load the module (LP: #1847816)
+# This doesn't (currently) apply to Debian, as scsi_debug should always
+# be available in Debian kernels
+@unittest.skipIf(not have_scsi_debug() and not load_scsi_debug(), 'Failed to load scsi_debug module')
 class FakeDriveTestBase(unittest.TestCase):
     @classmethod
     def setUpClass(cls):
-        if os.path.isdir(SCSI_DEBUG_DIR):
-            return
-
-        # Consider missing scsi_debug module a test failure
-        subprocess.check_call(['modprobe', 'scsi_debug', 'dev_size_mb=32'])
-        assert os.path.isdir(SCSI_DEBUG_DIR)
+        assert have_scsi_debug()
 
     def setUp(self):
         existing_adapters = set(glob(os.path.join(SCSI_DEBUG_DIR, 'adapter*')))
diff -pruN 245.4-4/debian/tests/systemd-fsckd 245.4-4ubuntu3/debian/tests/systemd-fsckd
--- 245.4-4/debian/tests/systemd-fsckd	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/tests/systemd-fsckd	2020-04-22 09:04:26.000000000 +0000
@@ -7,6 +7,7 @@ from contextlib import suppress
 import inspect
 import fileinput
 import os
+import platform
 import subprocess
 import shutil
 import stat
@@ -44,6 +45,7 @@ class FsckdTest(unittest.TestCase):
         # ensure we have our root fsck enabled by default (it detects it runs in a vm and doesn't pull the target)
         # note that it can already exists in case of a reboot (as there was no tearDown as we wanted)
         os.makedirs(os.path.dirname(SYSTEMD_FSCK_ROOT_ENABLE_PATH), exist_ok=True)
+        os.makedirs('/var/log/journal', exist_ok=True)
         with suppress(FileExistsError):
             os.symlink(SYSTEMD_FSCK_ROOT_PATH, SYSTEMD_FSCK_ROOT_ENABLE_PATH)
         enable_plymouth()
@@ -96,7 +98,10 @@ class FsckdTest(unittest.TestCase):
             self.assertFsckdStop()
             self.assertWasRunning('process-killer')
             self.assertFalse(self.is_failed_unit('process-killer'))
-            self.assertFsckProceeded()
+            self.assertWasRunning('systemd-fsckd')
+            self.assertFalse(self.is_failed_unit('systemd-fsckd'))
+            self.assertTrue(self.is_failed_unit('systemd-fsck-root'))
+            self.assertWasRunning('plymouth-start')
             self.assertSystemRunning()
 
     def test_systemd_fsck_with_failure(self):
@@ -120,7 +125,7 @@ class FsckdTest(unittest.TestCase):
         else:
             self.assertFsckdStop()
             self.assertProcessKilled()
-            self.assertFalse(self.is_failed_unit('systemd-fsck-root'))
+            self.assertTrue(self.is_failed_unit('systemd-fsck-root'))
             self.assertTrue(self.is_failed_unit('systemd-fsckd'))
             self.assertWasRunning('plymouth-start')
             self.assertSystemRunning()
@@ -219,7 +224,7 @@ WantedBy=systemd-fsck-root.service'''.fo
         subprocess.check_call(['systemctl', 'enable', 'process-killer'], stderr=subprocess.DEVNULL)
 
 
-def enable_plymouth(enable=True):
+def enable_plymouth_grub(enable=True):
     '''ensure plymouth is enabled in grub config (doesn't reboot)'''
     plymouth_enabled = 'splash' in open('/boot/grub/grub.cfg').read()
     if enable and not plymouth_enabled:
@@ -238,6 +243,23 @@ def enable_plymouth(enable=True):
     subprocess.check_call(['update-grub'], stderr=subprocess.DEVNULL)
 
 
+def enable_plymouth_zipl(enable=True, ziplconf='/etc/zipl.conf'):
+    '''ensure plymouth is enabled in zipl config (doesn't reboot)'''
+    plymouth_enabled = 'splash' in open(ziplconf).read()
+    if enable and not plymouth_enabled:
+        subprocess.check_call(['sed', '-i', 's/^\(parameters.*\)/\\1 splash quiet/', ziplconf], stderr=subprocess.DEVNULL)
+    elif not enable and plymouth_enabled:
+        subprocess.check_call(['sed', '-i', 's/ splash quiet//g', ziplconf], stderr=subprocess.DEVNULL)
+    subprocess.check_call(['zipl'], stderr=subprocess.DEVNULL)
+
+
+def enable_plymouth(enable=True):
+    if platform.processor() == 's390x':
+        enable_plymouth_zipl(enable)
+    else:
+        enable_plymouth_grub(enable)
+
+
 def boot_with_systemd_distro():
     '''Reboot with systemd as init and distro setup for grub'''
     enable_plymouth()
@@ -259,6 +281,10 @@ if __name__ == '__main__':
         print('SKIP: root file system is being checked by initramfs already')
         sys.exit(0)
 
+    if platform.processor() == 'aarch64':
+        print('SKIP: cannot reboot properly on arm64, see https://bugs.launchpad.net/ubuntu/+source/nova/+bug/1748280')
+        sys.exit(0)
+
     all_tests = getAllTests(FsckdTest)
     reboot_marker = os.getenv('AUTOPKGTEST_REBOOT_MARK')
 
diff -pruN 245.4-4/debian/tests/upstream 245.4-4ubuntu3/debian/tests/upstream
--- 245.4-4/debian/tests/upstream	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/tests/upstream	2020-04-22 09:04:26.000000000 +0000
@@ -5,6 +5,14 @@ set -e
 
 DPKGARCH=$(dpkg --print-architecture)
 
+# passes on baremetal, fails in nested qemu
+# https://github.com/systemd/systemd/issues/11612
+if [ $(dpkg --print-architecture) = "ppc64el" ]; then
+BLACKLIST="$BLACKLIST
+TEST-24-UNIT-TESTS
+"
+fi
+
 # quiesce Makefile.guess; not really relevant as systemd/nspawn run from
 # installed packages
 export BUILD_DIR=.
diff -pruN 245.4-4/debian/udev-udeb.install 245.4-4ubuntu3/debian/udev-udeb.install
--- 245.4-4/debian/udev-udeb.install	2020-04-13 09:34:31.000000000 +0000
+++ 245.4-4ubuntu3/debian/udev-udeb.install	2020-04-22 09:04:26.000000000 +0000
@@ -18,3 +18,4 @@ lib/udev/rules.d/80-net-setup-link.rules
 ../../extra/rules/50-firmware.rules lib/udev/rules.d/
 ../../extra/rules/73-special-net-names.rules lib/udev/rules.d/
 ../../extra/start-udev lib/debian-installer/
+../../extra/modprobe.d-udeb/scsi-mod-scan-sync.conf lib/modprobe.d/
